/* activity_info.c generated by valac 0.10.1, the Vala compiler
 * generated from activity_info.vala, do not modify */

/* activity_info.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/env.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



#define SUGAR_ACTIVITY_INFO__ACTIVITY_GROUP "Activity"



/**
     * Get activity info by path to activity sources
     *
     * @param path  full path to activity sources root directory
     * @param info  variable to store result
     *
     * @return      true on success when info contains valid object
     */
#line 49 "activity_info.vala"
gboolean sugar_activity_info_get (const char* path, SugarActivityInfo* _result_) {
#line 50 "activity_info.c"
	gboolean result = FALSE;
	char* activity_info;
	SugarActivityInfo _tmp0_ = {0};
	SugarActivityInfo info;
	GKeyFile* ini;
	SugarActivityInfo _tmp15_ = {0};
	SugarActivityInfo _tmp16_;
	GError * _inner_error_ = NULL;
#line 49 "activity_info.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 50 "activity_info.vala"
	activity_info = g_build_filename (path, "activity", "activity.info", NULL);
#line 53 "activity_info.vala"
	if (!g_file_test (activity_info, G_FILE_TEST_EXISTS)) {
#line 54 "activity_info.vala"
		g_warning ("activity_info.vala:54: Cannot find activity.info file in %s", path);
#line 67 "activity_info.c"
		result = FALSE;
		_g_free0 (activity_info);
#line 55 "activity_info.vala"
		return result;
#line 72 "activity_info.c"
	}
#line 58 "activity_info.vala"
	info = (_tmp0_);
#line 59 "activity_info.vala"
	ini = g_key_file_new ();
#line 78 "activity_info.c"
	{
		gboolean _tmp1_;
		gboolean _tmp7_;
		gboolean _tmp10_;
#line 62 "activity_info.vala"
		g_key_file_load_from_file (ini, activity_info, G_KEY_FILE_NONE, &_inner_error_);
#line 85 "activity_info.c"
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
		}
#line 64 "activity_info.vala"
		_tmp1_ = g_key_file_has_key (ini, SUGAR_ACTIVITY_INFO__ACTIVITY_GROUP, "bundle_id", &_inner_error_);
#line 91 "activity_info.c"
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
		}
#line 64 "activity_info.vala"
		if (_tmp1_) {
#line 97 "activity_info.c"
			char* _tmp2_;
			char* _tmp3_;
#line 65 "activity_info.vala"
			_tmp2_ = g_key_file_get_value (ini, SUGAR_ACTIVITY_INFO__ACTIVITY_GROUP, "bundle_id", &_inner_error_);
#line 102 "activity_info.c"
			if (_inner_error_ != NULL) {
				goto __catch4_g_error;
			}
#line 65 "activity_info.vala"
			info.bundle_id = (_tmp3_ = _tmp2_, _g_free0 (info.bundle_id), _tmp3_);
#line 108 "activity_info.c"
		} else {
			gboolean _tmp4_;
#line 66 "activity_info.vala"
			_tmp4_ = g_key_file_has_key (ini, SUGAR_ACTIVITY_INFO__ACTIVITY_GROUP, "service_name", &_inner_error_);
#line 113 "activity_info.c"
			if (_inner_error_ != NULL) {
				goto __catch4_g_error;
			}
#line 66 "activity_info.vala"
			if (_tmp4_) {
#line 119 "activity_info.c"
				char* _tmp5_;
				char* _tmp6_;
#line 67 "activity_info.vala"
				g_debug ("activity_info.vala:67: Deprecated service_name key in %s, use bundle_i" \
"d", activity_info);
#line 69 "activity_info.vala"
				_tmp5_ = g_key_file_get_value (ini, SUGAR_ACTIVITY_INFO__ACTIVITY_GROUP, "service_name", &_inner_error_);
#line 126 "activity_info.c"
				if (_inner_error_ != NULL) {
					goto __catch4_g_error;
				}
#line 69 "activity_info.vala"
				info.bundle_id = (_tmp6_ = _tmp5_, _g_free0 (info.bundle_id), _tmp6_);
#line 132 "activity_info.c"
			} else {
#line 72 "activity_info.vala"
				g_warning ("activity_info.vala:72: Malformed %s: lack of bundle_id key", activity_info);
#line 136 "activity_info.c"
				result = FALSE;
				_g_key_file_free0 (ini);
				sugar_activity_info_destroy (&info);
				_g_free0 (activity_info);
#line 73 "activity_info.vala"
				return result;
#line 143 "activity_info.c"
			}
		}
#line 76 "activity_info.vala"
		_tmp7_ = g_key_file_has_key (ini, SUGAR_ACTIVITY_INFO__ACTIVITY_GROUP, "name", &_inner_error_);
#line 148 "activity_info.c"
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
		}
#line 76 "activity_info.vala"
		if (_tmp7_) {
#line 154 "activity_info.c"
			char* _tmp8_;
			char* _tmp9_;
#line 77 "activity_info.vala"
			_tmp8_ = g_key_file_get_value (ini, SUGAR_ACTIVITY_INFO__ACTIVITY_GROUP, "name", &_inner_error_);
#line 159 "activity_info.c"
			if (_inner_error_ != NULL) {
				goto __catch4_g_error;
			}
#line 77 "activity_info.vala"
			info.name = (_tmp9_ = _tmp8_, _g_free0 (info.name), _tmp9_);
#line 165 "activity_info.c"
		} else {
#line 79 "activity_info.vala"
			g_warning ("activity_info.vala:79: Malformed %s: lack of name key", activity_info);
#line 169 "activity_info.c"
			result = FALSE;
			_g_key_file_free0 (ini);
			sugar_activity_info_destroy (&info);
			_g_free0 (activity_info);
#line 80 "activity_info.vala"
			return result;
#line 176 "activity_info.c"
		}
#line 83 "activity_info.vala"
		_tmp10_ = g_key_file_has_key (ini, SUGAR_ACTIVITY_INFO__ACTIVITY_GROUP, "icon", &_inner_error_);
#line 180 "activity_info.c"
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
		}
#line 83 "activity_info.vala"
		if (_tmp10_) {
#line 186 "activity_info.c"
			char* _tmp11_;
			char* _tmp12_;
			char* _tmp13_;
			char* _tmp14_;
#line 85 "activity_info.vala"
			_tmp11_ = g_key_file_get_value (ini, SUGAR_ACTIVITY_INFO__ACTIVITY_GROUP, "icon", &_inner_error_);
#line 193 "activity_info.c"
			if (_inner_error_ != NULL) {
				goto __catch4_g_error;
			}
#line 84 "activity_info.vala"
			info.icon = (_tmp14_ = g_build_filename (path, "activity", _tmp13_ = g_strconcat (_tmp12_ = _tmp11_, ".svg", NULL), NULL), _g_free0 (info.icon), _tmp14_);
#line 199 "activity_info.c"
			_g_free0 (_tmp13_);
			_g_free0 (_tmp12_);
		} else {
#line 87 "activity_info.vala"
			g_warning ("activity_info.vala:87: Malformed %s: lack of icon key", activity_info);
#line 205 "activity_info.c"
			result = FALSE;
			_g_key_file_free0 (ini);
			sugar_activity_info_destroy (&info);
			_g_free0 (activity_info);
#line 88 "activity_info.vala"
			return result;
#line 212 "activity_info.c"
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
#line 91 "activity_info.vala"
			g_warning ("activity_info.vala:91: Cannot parse %s: %s", activity_info, _error_->message);
#line 224 "activity_info.c"
			result = FALSE;
			_g_error_free0 (_error_);
			_g_key_file_free0 (ini);
			sugar_activity_info_destroy (&info);
			_g_free0 (activity_info);
#line 92 "activity_info.vala"
			return result;
#line 232 "activity_info.c"
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		_g_key_file_free0 (ini);
		sugar_activity_info_destroy (&info);
		_g_free0 (activity_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
#line 95 "activity_info.vala"
	*_result_ = (_tmp16_ = (sugar_activity_info_copy (&info, &_tmp15_), _tmp15_), sugar_activity_info_destroy (_result_), _tmp16_);
#line 246 "activity_info.c"
	result = TRUE;
	_g_key_file_free0 (ini);
	sugar_activity_info_destroy (&info);
	_g_free0 (activity_info);
#line 96 "activity_info.vala"
	return result;
#line 253 "activity_info.c"
}


void sugar_activity_info_copy (const SugarActivityInfo* self, SugarActivityInfo* dest) {
	dest->bundle_id = g_strdup (self->bundle_id);
	dest->icon = g_strdup (self->icon);
	dest->name = g_strdup (self->name);
}


void sugar_activity_info_destroy (SugarActivityInfo* self) {
	_g_free0 (self->bundle_id);
	_g_free0 (self->icon);
	_g_free0 (self->name);
}


SugarActivityInfo* sugar_activity_info_dup (const SugarActivityInfo* self) {
	SugarActivityInfo* dup;
	dup = g_new0 (SugarActivityInfo, 1);
	sugar_activity_info_copy (self, dup);
	return dup;
}


void sugar_activity_info_free (SugarActivityInfo* self) {
	sugar_activity_info_destroy (self);
	g_free (self);
}


GType sugar_activity_info_get_type (void) {
	static volatile gsize sugar_activity_info_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_activity_info_type_id__volatile)) {
		GType sugar_activity_info_type_id;
		sugar_activity_info_type_id = g_boxed_type_register_static ("SugarActivityInfo", (GBoxedCopyFunc) sugar_activity_info_dup, (GBoxedFreeFunc) sugar_activity_info_free);
		g_once_init_leave (&sugar_activity_info_type_id__volatile, sugar_activity_info_type_id);
	}
	return sugar_activity_info_type_id__volatile;
}




