/* environ.c generated by valac 0.10.1, the Vala compiler
 * generated from environ.vala, do not modify */

/* environ.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/env.h"
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SugarParamSpecEnviron SugarParamSpecEnviron;

struct _SugarParamSpecEnviron {
	GParamSpec parent_instance;
};


static gboolean sugar_environ__sync_dbus;
static gboolean sugar_environ__sync_dbus = FALSE;
static char* sugar_environ__bundle_id;
static char* sugar_environ__bundle_id = NULL;
static char* sugar_environ__activity_id;
static char* sugar_environ__activity_id = NULL;
static char* sugar_environ__object_id;
static char* sugar_environ__object_id = NULL;
static XID sugar_environ__window;
static XID sugar_environ__window = 0;
static SugarActivityInfo sugar_environ__activity;
static SugarActivityInfo sugar_environ__activity = {0};
static gpointer sugar_environ_parent_class = NULL;

enum  {
	SUGAR_ENVIRON_DUMMY_PROPERTY
};
static SugarEnviron* sugar_environ_new (void);
static SugarEnviron* sugar_environ_construct (GType object_type);
static void sugar_environ_finalize (SugarEnviron* obj);

static const GOptionEntry SUGAR_ENVIRON__entries[4] = {{"bundle-id", 'b', 0, G_OPTION_ARG_STRING, &sugar_environ__bundle_id, NULL, NULL}, {"activity-id", 'a', 0, G_OPTION_ARG_STRING, &sugar_environ__activity_id, NULL, NULL}, {"object-id", 'o', 0, G_OPTION_ARG_STRING, &sugar_environ__object_id, NULL, NULL}, {NULL}};


/**
     * Initialize Polyol environment
     *
     * @param argv  argv strings array that was passed to the main ();
     *              on success, parsed values will be removed from argv
     * @return      true if sugar mode was detected and properly initialized
     *
     * The rest of Polyol can be called after invoking this function and only if
     * it returned true.
     *
     * This function will Initialize internal data basing on command line
     * arguments sugar-activity command passes to the activity process.
     * These options are:
     *
     *  -b BUNDLE_ID, --bundle-id=BUNDLE_ID
     *      identifier of the activity bundle
     *      required for successful parsing
     *
     *  -a ACTIVITY_ID, --activity-id=ACTIVITY_ID
     *      identifier of the activity instance
     *      required for successful parsing
     *
     *  -o OBJECT_ID, --object-id=OBJECT_ID
     *      identifier of the associated journal entry
     *      optional, absence means activity session without or with new
     *      journal entry
     */
#line 178 "environ.vala"
gboolean sugar_init (char*** argv, int* argv_length1) {
#line 98 "environ.c"
	gboolean result = FALSE;
	GOptionContext* options;
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
#line 179 "environ.vala"
	if ((*argv) == NULL) {
#line 105 "environ.c"
		result = FALSE;
#line 180 "environ.vala"
		return result;
#line 109 "environ.c"
	}
#line 182 "environ.vala"
	options = g_option_context_new ("");
#line 184 "environ.vala"
	g_option_context_set_help_enabled (options, FALSE);
#line 185 "environ.vala"
	g_option_context_set_ignore_unknown_options (options, TRUE);
#line 186 "environ.vala"
	g_option_context_add_main_entries (options, SUGAR_ENVIRON__entries, NULL);
#line 119 "environ.c"
	{
#line 189 "environ.vala"
		g_option_context_parse (options, argv_length1, argv, &_inner_error_);
#line 123 "environ.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch7_g_option_error;
			}
			_g_option_context_free0 (options);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	goto __finally7;
	__catch7_g_option_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
#line 191 "environ.vala"
			g_warning ("environ.vala:191: Command line options error: %s", _error_->message);
#line 143 "environ.c"
			result = FALSE;
			_g_error_free0 (_error_);
			_g_option_context_free0 (options);
#line 192 "environ.vala"
			return result;
#line 149 "environ.c"
		}
	}
	__finally7:
	if (_inner_error_ != NULL) {
		_g_option_context_free0 (options);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
#line 195 "environ.vala"
	if (sugar_environ_get_activity_id () == NULL) {
#line 195 "environ.vala"
		_tmp0_ = TRUE;
#line 163 "environ.c"
	} else {
#line 195 "environ.vala"
		_tmp0_ = sugar_environ_get_bundle_id () == NULL;
#line 167 "environ.c"
	}
#line 195 "environ.vala"
	if (_tmp0_) {
#line 196 "environ.vala"
		g_message ("environ.vala:196: %s", "Sugar mode was not detected, pass --activity-id and " "--bundle_id to enable it");
#line 173 "environ.c"
		result = FALSE;
		_g_option_context_free0 (options);
#line 198 "environ.vala"
		return result;
#line 178 "environ.c"
	}
#line 201 "environ.vala"
	g_debug ("Activity command line arguments: activity_id=%s object_id=%s " "bundle_id=%s", sugar_environ_get_activity_id (), sugar_environ_get_object_id (), sugar_environ_get_bundle_id ());
#line 182 "environ.c"
	result = TRUE;
	_g_option_context_free0 (options);
#line 204 "environ.vala"
	return result;
#line 187 "environ.c"
}


/**
     * Setup X properties for activity main window
     *
     * Valid sugar activity should call this function for main X window.
     *
     * @param display   X display to setup properties for
     * @param window    activity main window to setup properties for
     */
static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1190 "glib-2.0.vapi"
	return result;
#line 205 "environ.c"
}


#line 215 "environ.vala"
void sugar_environ_set_window (Display* display, Window window) {
#line 215 "environ.vala"
	g_return_if_fail (display != NULL);
#line 216 "environ.vala"
	sugar_environ__window = (XID) window;
#line 218 "environ.vala"
	if (sugar_environ_get_bundle_id () != NULL) {
#line 219 "environ.vala"
		XChangeProperty (display, window, XInternAtom (display, "_SUGAR_BUNDLE_ID", FALSE), XInternAtom (display, "STRING", FALSE), 8, (gint) PropModeReplace, (guchar*) sugar_environ_get_bundle_id (), (gint) string_get_length (sugar_environ_get_bundle_id ()));
#line 219 "environ.c"
	} else {
#line 225 "environ.vala"
		g_warning ("environ.vala:225: _SUGAR_BUNDLE_ID X property was not set");
#line 223 "environ.c"
	}
#line 227 "environ.vala"
	if (sugar_environ_get_activity_id () != NULL) {
#line 228 "environ.vala"
		XChangeProperty (display, window, XInternAtom (display, "_SUGAR_ACTIVITY_ID", FALSE), XInternAtom (display, "STRING", FALSE), 8, (gint) PropModeReplace, (guchar*) sugar_environ_get_activity_id (), (gint) string_get_length (sugar_environ_get_activity_id ()));
#line 229 "environ.c"
	} else {
#line 234 "environ.vala"
		g_warning ("environ.vala:234: _SUGAR_ACTIVITY_ID X property was not set");
#line 233 "environ.c"
	}
}


#line 253 "environ.vala"
static SugarEnviron* sugar_environ_construct (GType object_type) {
#line 240 "environ.c"
	SugarEnviron* self = (SugarEnviron*) g_type_create_instance (object_type);
	return self;
}


#line 253 "environ.vala"
static SugarEnviron* sugar_environ_new (void) {
#line 253 "environ.vala"
	return sugar_environ_construct (SUGAR_TYPE_ENVIRON);
#line 250 "environ.c"
}


gboolean sugar_environ_get_initialized (void) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 47 "environ.vala"
	if (sugar_environ_get_activity_id () != NULL) {
#line 47 "environ.vala"
		_tmp0_ = sugar_environ_get_bundle_id () != NULL;
#line 261 "environ.c"
	} else {
#line 47 "environ.vala"
		_tmp0_ = FALSE;
#line 265 "environ.c"
	}
	result = _tmp0_;
#line 47 "environ.vala"
	return result;
#line 270 "environ.c"
}


const char* sugar_environ_get_activity_id (void) {
	const char* result;
	result = sugar_environ__activity_id;
#line 57 "environ.vala"
	return result;
#line 279 "environ.c"
}


const char* sugar_environ_get_bundle_id (void) {
	const char* result;
	result = sugar_environ__bundle_id;
#line 67 "environ.vala"
	return result;
#line 288 "environ.c"
}


const char* sugar_environ_get_object_id (void) {
	const char* result;
	result = sugar_environ__object_id;
#line 81 "environ.vala"
	return result;
#line 297 "environ.c"
}


void sugar_environ_get_activity (SugarActivityInfo* result) {
#line 95 "environ.vala"
	if (sugar_environ__activity.bundle_id == NULL) {
#line 304 "environ.c"
		char* path;
		gboolean _tmp0_ = FALSE;
#line 96 "environ.vala"
		path = g_strdup (g_getenv ("SUGAR_BUNDLE_PATH"));
#line 97 "environ.vala"
		if (path == NULL) {
#line 97 "environ.vala"
			_tmp0_ = TRUE;
#line 313 "environ.c"
		} else {
			SugarActivityInfo _tmp1_ = {0};
			gboolean _tmp2_;
			SugarActivityInfo _tmp3_;
#line 97 "environ.vala"
			_tmp0_ = !(_tmp2_ = sugar_activity_info_get (path, &_tmp1_), sugar_environ__activity = (_tmp3_ = _tmp1_, sugar_activity_info_destroy (&sugar_environ__activity), _tmp3_), _tmp2_);
#line 320 "environ.c"
		}
#line 97 "environ.vala"
		if (_tmp0_) {
#line 324 "environ.c"
			char* _tmp4_;
			char* _tmp5_;
			char* _tmp6_;
#line 98 "environ.vala"
			sugar_environ__activity.bundle_id = (_tmp4_ = g_strdup ("unknown.activity"), _g_free0 (sugar_environ__activity.bundle_id), _tmp4_);
#line 99 "environ.vala"
			sugar_environ__activity.name = (_tmp5_ = g_strdup ("Unknown Activity"), _g_free0 (sugar_environ__activity.name), _tmp5_);
#line 100 "environ.vala"
			sugar_environ__activity.icon = (_tmp6_ = g_strdup ("application-octet-stream"), _g_free0 (sugar_environ__activity.icon), _tmp6_);
#line 334 "environ.c"
		}
		_g_free0 (path);
	}
	*result = sugar_environ__activity;
#line 103 "environ.vala"
	return;
#line 341 "environ.c"
}


const char* sugar_environ_get_activity_root (void) {
	const char* result;
	const char* path;
	const char* _tmp0_;
#line 127 "environ.vala"
	path = g_getenv ("SUGAR_ACTIVITY_ROOT");
#line 351 "environ.c"
	_tmp0_ = NULL;
#line 128 "environ.vala"
	if (path == NULL) {
#line 128 "environ.vala"
		_tmp0_ = ".";
#line 357 "environ.c"
	} else {
#line 128 "environ.vala"
		_tmp0_ = path;
#line 361 "environ.c"
	}
	result = _tmp0_;
#line 128 "environ.vala"
	return result;
#line 366 "environ.c"
}


XID sugar_environ_get_window (void) {
	XID result;
	result = sugar_environ__window;
#line 136 "environ.vala"
	return result;
#line 375 "environ.c"
}


gboolean sugar_environ_get_secure_mode (void) {
	gboolean result;
	result = g_file_test ("/etc/olpc-security", G_FILE_TEST_EXISTS);
#line 146 "environ.vala"
	return result;
#line 384 "environ.c"
}


gboolean sugar_environ_get_sync_dbus (void) {
	gboolean result;
	result = sugar_environ__sync_dbus;
#line 251 "environ.vala"
	return result;
#line 393 "environ.c"
}


void sugar_environ_set_sync_dbus (gboolean value) {
	sugar_environ__sync_dbus = value;
}


static void sugar_value_environ_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void sugar_value_environ_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		sugar_environ_unref (value->data[0].v_pointer);
	}
}


static void sugar_value_environ_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = sugar_environ_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer sugar_value_environ_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* sugar_value_environ_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SugarEnviron* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = sugar_environ_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* sugar_value_environ_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SugarEnviron** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = sugar_environ_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* sugar_param_spec_environ (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	SugarParamSpecEnviron* spec;
	g_return_val_if_fail (g_type_is_a (object_type, SUGAR_TYPE_ENVIRON), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer sugar_value_get_environ (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SUGAR_TYPE_ENVIRON), NULL);
	return value->data[0].v_pointer;
}


void sugar_value_set_environ (GValue* value, gpointer v_object) {
	SugarEnviron* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SUGAR_TYPE_ENVIRON));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SUGAR_TYPE_ENVIRON));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		sugar_environ_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		sugar_environ_unref (old);
	}
}


void sugar_value_take_environ (GValue* value, gpointer v_object) {
	SugarEnviron* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SUGAR_TYPE_ENVIRON));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SUGAR_TYPE_ENVIRON));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		sugar_environ_unref (old);
	}
}


static void sugar_environ_class_init (SugarEnvironClass * klass) {
	sugar_environ_parent_class = g_type_class_peek_parent (klass);
	SUGAR_ENVIRON_CLASS (klass)->finalize = sugar_environ_finalize;
}


static void sugar_environ_instance_init (SugarEnviron * self) {
	self->ref_count = 1;
}


static void sugar_environ_finalize (SugarEnviron* obj) {
	SugarEnviron * self;
	self = SUGAR_ENVIRON (obj);
}


/**
 * Various sugar environment settings
 */
GType sugar_environ_get_type (void) {
	static volatile gsize sugar_environ_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_environ_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { sugar_value_environ_init, sugar_value_environ_free_value, sugar_value_environ_copy_value, sugar_value_environ_peek_pointer, "p", sugar_value_environ_collect_value, "p", sugar_value_environ_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SugarEnvironClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_environ_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarEnviron), 0, (GInstanceInitFunc) sugar_environ_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType sugar_environ_type_id;
		sugar_environ_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SugarEnviron", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&sugar_environ_type_id__volatile, sugar_environ_type_id);
	}
	return sugar_environ_type_id__volatile;
}


gpointer sugar_environ_ref (gpointer instance) {
	SugarEnviron* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void sugar_environ_unref (gpointer instance) {
	SugarEnviron* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SUGAR_ENVIRON_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}




