/* alignment.c generated by valac 0.10.1, the Vala compiler
 * generated from alignment.vala, do not modify */

/* alignment.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/gui.h"
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>


struct _SugarAlignmentPrivate {
	float _xalign;
	float _yalign;
	float _xscale;
	float _yscale;
	gboolean _xignore;
	gboolean _yignore;
	gint _xoffset;
	gint _yoffset;
	gint _child_width;
	gint _child_height;
	GtkRequisition _child_requisition;
};


static gpointer sugar_alignment_parent_class = NULL;

#define SUGAR_ALIGNMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_ALIGNMENT, SugarAlignmentPrivate))
enum  {
	SUGAR_ALIGNMENT_DUMMY_PROPERTY,
	SUGAR_ALIGNMENT_XALIGN,
	SUGAR_ALIGNMENT_YALIGN,
	SUGAR_ALIGNMENT_XSCALE,
	SUGAR_ALIGNMENT_YSCALE,
	SUGAR_ALIGNMENT_XIGNORE,
	SUGAR_ALIGNMENT_YIGNORE,
	SUGAR_ALIGNMENT_CHILD_X,
	SUGAR_ALIGNMENT_CHILD_Y,
	SUGAR_ALIGNMENT_CHILD_WIDTH,
	SUGAR_ALIGNMENT_CHILD_HEIGHT
};
static void sugar_alignment_real_size_request (GtkWidget* base, GtkRequisition* requisition);
static void sugar_alignment_real_size_allocate (GtkWidget* base, GdkRectangle* allocation);
static void _sugar_alignment_whether_to_resize (SugarAlignment* self, float* prop, float value);
static void sugar_alignment_finalize (GObject* obj);
static void sugar_alignment_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sugar_alignment_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 124 "alignment.vala"
static void sugar_alignment_real_size_request (GtkWidget* base, GtkRequisition* requisition) {
#line 74 "alignment.c"
	SugarAlignment * self;
	gboolean _tmp0_ = FALSE;
	self = (SugarAlignment*) base;
#line 125 "alignment.vala"
	GTK_WIDGET_CLASS (sugar_alignment_parent_class)->size_request ((GtkWidget*) SUGAR_BIN (self), requisition);
#line 126 "alignment.vala"
	self->priv->_child_requisition = *requisition;
#line 128 "alignment.vala"
	if (sugar_alignment_get_xignore (self)) {
#line 128 "alignment.vala"
		_tmp0_ = TRUE;
#line 86 "alignment.c"
	} else {
#line 128 "alignment.vala"
		_tmp0_ = sugar_alignment_get_yignore (self);
#line 90 "alignment.c"
	}
#line 128 "alignment.vala"
	if (_tmp0_) {
#line 94 "alignment.c"
		GtkRequisition _tmp1_ = {0};
		GtkRequisition container_requisition;
#line 129 "alignment.vala"
		container_requisition = (_tmp1_);
#line 130 "alignment.vala"
		sugar_container_child_size_request ((SugarContainer*) self, &container_requisition);
#line 132 "alignment.vala"
		if (sugar_alignment_get_xignore (self)) {
#line 133 "alignment.vala"
			(*requisition).width = container_requisition.width;
#line 105 "alignment.c"
		}
#line 134 "alignment.vala"
		if (sugar_alignment_get_yignore (self)) {
#line 135 "alignment.vala"
			(*requisition).height = container_requisition.height;
#line 111 "alignment.c"
		}
	}
}


#line 139 "alignment.vala"
static void sugar_alignment_real_size_allocate (GtkWidget* base, GdkRectangle* allocation) {
#line 119 "alignment.c"
	SugarAlignment * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GdkRectangle _tmp2_ = {0};
	GdkRectangle child_allocation;
	self = (SugarAlignment*) base;
#line 140 "alignment.vala"
	((GtkWidget*) self)->allocation = (GtkAllocation) (*allocation);
#line 142 "alignment.vala"
	if (sugar_bin_get_child ((SugarBin*) self) == NULL) {
#line 143 "alignment.vala"
		return;
#line 132 "alignment.c"
	}
#line 145 "alignment.vala"
	if (SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_width ((SugarContainer*) SUGAR_BIN (self)) <= self->priv->_child_requisition.width) {
#line 145 "alignment.vala"
		_tmp0_ = TRUE;
#line 138 "alignment.c"
	} else {
#line 145 "alignment.vala"
		_tmp0_ = sugar_alignment_get_xscale (self) == 1.0f;
#line 142 "alignment.c"
	}
#line 145 "alignment.vala"
	if (_tmp0_) {
#line 146 "alignment.vala"
		self->priv->_child_width = SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_width ((SugarContainer*) SUGAR_BIN (self));
#line 147 "alignment.vala"
		self->priv->_xoffset = 0;
#line 150 "alignment.c"
	} else {
#line 149 "alignment.vala"
		if (sugar_alignment_get_xscale (self) == 0.0f) {
#line 150 "alignment.vala"
			self->priv->_child_width = self->priv->_child_requisition.width;
#line 156 "alignment.c"
		} else {
#line 152 "alignment.vala"
			self->priv->_child_width = self->priv->_child_requisition.width + ((gint) ((SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_width ((SugarContainer*) SUGAR_BIN (self)) - self->priv->_child_requisition.width) * (1.0f - sugar_alignment_get_xscale (self))));
#line 160 "alignment.c"
		}
#line 155 "alignment.vala"
		if (gtk_widget_get_direction ((GtkWidget*) self) == GTK_TEXT_DIR_RTL) {
#line 156 "alignment.vala"
			self->priv->_xoffset = (gint) ((SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_width ((SugarContainer*) SUGAR_BIN (self)) - self->priv->_child_width) * (1.0f - sugar_alignment_get_xalign (self)));
#line 166 "alignment.c"
		} else {
#line 159 "alignment.vala"
			self->priv->_xoffset = (gint) ((SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_width ((SugarContainer*) SUGAR_BIN (self)) - self->priv->_child_width) * sugar_alignment_get_xalign (self));
#line 170 "alignment.c"
		}
	}
#line 162 "alignment.vala"
	if (SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_height ((SugarContainer*) SUGAR_BIN (self)) <= self->priv->_child_requisition.height) {
#line 162 "alignment.vala"
		_tmp1_ = TRUE;
#line 177 "alignment.c"
	} else {
#line 162 "alignment.vala"
		_tmp1_ = sugar_alignment_get_yscale (self) == 1.0f;
#line 181 "alignment.c"
	}
#line 162 "alignment.vala"
	if (_tmp1_) {
#line 163 "alignment.vala"
		self->priv->_child_height = SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_height ((SugarContainer*) SUGAR_BIN (self));
#line 164 "alignment.vala"
		self->priv->_yoffset = 0;
#line 189 "alignment.c"
	} else {
#line 166 "alignment.vala"
		if (sugar_alignment_get_yscale (self) == 0.0f) {
#line 167 "alignment.vala"
			self->priv->_child_height = self->priv->_child_requisition.height;
#line 195 "alignment.c"
		} else {
#line 169 "alignment.vala"
			self->priv->_child_height = self->priv->_child_requisition.height + ((gint) ((SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_height ((SugarContainer*) SUGAR_BIN (self)) - self->priv->_child_requisition.height) * (1.0f - sugar_alignment_get_yscale (self))));
#line 199 "alignment.c"
		}
#line 172 "alignment.vala"
		self->priv->_yoffset = (gint) ((SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_height ((SugarContainer*) SUGAR_BIN (self)) - self->priv->_child_height) * sugar_alignment_get_yalign (self));
#line 203 "alignment.c"
	}
#line 175 "alignment.vala"
	child_allocation = (_tmp2_.x = sugar_container_get_child_x ((SugarContainer*) self), _tmp2_.y = sugar_container_get_child_y ((SugarContainer*) self), _tmp2_.width = sugar_container_get_child_width ((SugarContainer*) self), _tmp2_.height = sugar_container_get_child_height ((SugarContainer*) self), _tmp2_);
#line 179 "alignment.vala"
	gtk_widget_size_allocate (sugar_bin_get_child ((SugarBin*) self), &child_allocation);
#line 209 "alignment.c"
}


#line 182 "alignment.vala"
static void _sugar_alignment_whether_to_resize (SugarAlignment* self, float* prop, float value) {
#line 182 "alignment.vala"
	g_return_if_fail (self != NULL);
#line 183 "alignment.vala"
	if (value != (*prop)) {
#line 184 "alignment.vala"
		*prop = value;
#line 185 "alignment.vala"
		gtk_widget_queue_resize ((GtkWidget*) self);
#line 223 "alignment.c"
	}
}


#line 19 "alignment.vala"
SugarAlignment* sugar_alignment_construct (GType object_type) {
#line 230 "alignment.c"
	SugarAlignment * self = NULL;
#line 19 "alignment.vala"
	self = (SugarAlignment*) sugar_bin_construct (object_type);
#line 234 "alignment.c"
	return self;
}


#line 19 "alignment.vala"
SugarAlignment* sugar_alignment_new (void) {
#line 19 "alignment.vala"
	return sugar_alignment_construct (SUGAR_TYPE_ALIGNMENT);
#line 243 "alignment.c"
}


float sugar_alignment_get_xalign (SugarAlignment* self) {
	float result;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = self->priv->_xalign;
#line 27 "alignment.vala"
	return result;
#line 253 "alignment.c"
}


void sugar_alignment_set_xalign (SugarAlignment* self, float value) {
	g_return_if_fail (self != NULL);
#line 28 "alignment.vala"
	_sugar_alignment_whether_to_resize (self, &self->priv->_xalign, value);
#line 261 "alignment.c"
	g_object_notify ((GObject *) self, "xalign");
}


float sugar_alignment_get_yalign (SugarAlignment* self) {
	float result;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = self->priv->_yalign;
#line 38 "alignment.vala"
	return result;
#line 272 "alignment.c"
}


void sugar_alignment_set_yalign (SugarAlignment* self, float value) {
	g_return_if_fail (self != NULL);
#line 39 "alignment.vala"
	_sugar_alignment_whether_to_resize (self, &self->priv->_yalign, value);
#line 280 "alignment.c"
	g_object_notify ((GObject *) self, "yalign");
}


float sugar_alignment_get_xscale (SugarAlignment* self) {
	float result;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = self->priv->_xscale;
#line 52 "alignment.vala"
	return result;
#line 291 "alignment.c"
}


void sugar_alignment_set_xscale (SugarAlignment* self, float value) {
	g_return_if_fail (self != NULL);
#line 53 "alignment.vala"
	_sugar_alignment_whether_to_resize (self, &self->priv->_xscale, value);
#line 299 "alignment.c"
	g_object_notify ((GObject *) self, "xscale");
}


float sugar_alignment_get_yscale (SugarAlignment* self) {
	float result;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = self->priv->_yscale;
#line 66 "alignment.vala"
	return result;
#line 310 "alignment.c"
}


void sugar_alignment_set_yscale (SugarAlignment* self, float value) {
	g_return_if_fail (self != NULL);
#line 67 "alignment.vala"
	_sugar_alignment_whether_to_resize (self, &self->priv->_yscale, value);
#line 318 "alignment.c"
	g_object_notify ((GObject *) self, "yscale");
}


gboolean sugar_alignment_get_xignore (SugarAlignment* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_xignore;
#line 79 "alignment.vala"
	return result;
#line 329 "alignment.c"
}


void sugar_alignment_set_xignore (SugarAlignment* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 82 "alignment.vala"
	if (value == sugar_alignment_get_xignore (self)) {
#line 83 "alignment.vala"
		return;
#line 339 "alignment.c"
	}
#line 84 "alignment.vala"
	self->priv->_xignore = value;
#line 85 "alignment.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 345 "alignment.c"
	g_object_notify ((GObject *) self, "xignore");
}


gboolean sugar_alignment_get_yignore (SugarAlignment* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_yignore;
#line 98 "alignment.vala"
	return result;
#line 356 "alignment.c"
}


void sugar_alignment_set_yignore (SugarAlignment* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 101 "alignment.vala"
	if (value == sugar_alignment_get_yignore (self)) {
#line 102 "alignment.vala"
		return;
#line 366 "alignment.c"
	}
#line 103 "alignment.vala"
	self->priv->_yignore = value;
#line 104 "alignment.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 372 "alignment.c"
	g_object_notify ((GObject *) self, "yignore");
}


static gint sugar_alignment_real_get_child_x (SugarContainer* base) {
	gint result;
	SugarAlignment* self;
	self = (SugarAlignment*) base;
	result = SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_x ((SugarContainer*) SUGAR_BIN (self)) + self->priv->_xoffset;
#line 109 "alignment.vala"
	return result;
#line 384 "alignment.c"
}


static gint sugar_alignment_real_get_child_y (SugarContainer* base) {
	gint result;
	SugarAlignment* self;
	self = (SugarAlignment*) base;
	result = SUGAR_CONTAINER_CLASS (sugar_alignment_parent_class)->get_child_y ((SugarContainer*) SUGAR_BIN (self)) + self->priv->_yoffset;
#line 113 "alignment.vala"
	return result;
#line 395 "alignment.c"
}


static gint sugar_alignment_real_get_child_width (SugarContainer* base) {
	gint result;
	SugarAlignment* self;
	self = (SugarAlignment*) base;
	result = self->priv->_child_width;
#line 117 "alignment.vala"
	return result;
#line 406 "alignment.c"
}


static gint sugar_alignment_real_get_child_height (SugarContainer* base) {
	gint result;
	SugarAlignment* self;
	self = (SugarAlignment*) base;
	result = self->priv->_child_height;
#line 121 "alignment.vala"
	return result;
#line 417 "alignment.c"
}


static void sugar_alignment_class_init (SugarAlignmentClass * klass) {
	sugar_alignment_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarAlignmentPrivate));
	GTK_WIDGET_CLASS (klass)->size_request = sugar_alignment_real_size_request;
	GTK_WIDGET_CLASS (klass)->size_allocate = sugar_alignment_real_size_allocate;
	SUGAR_CONTAINER_CLASS (klass)->get_child_x = sugar_alignment_real_get_child_x;
	SUGAR_CONTAINER_CLASS (klass)->get_child_y = sugar_alignment_real_get_child_y;
	SUGAR_CONTAINER_CLASS (klass)->get_child_width = sugar_alignment_real_get_child_width;
	SUGAR_CONTAINER_CLASS (klass)->get_child_height = sugar_alignment_real_get_child_height;
	G_OBJECT_CLASS (klass)->get_property = sugar_alignment_get_property;
	G_OBJECT_CLASS (klass)->set_property = sugar_alignment_set_property;
	G_OBJECT_CLASS (klass)->finalize = sugar_alignment_finalize;
	/**
	     * The horizontal alignment
	     *
	     * Value from 0 (left) to 1 (right), reversed for RTL layouts.
	     * Makes sense only if xscale < 1.0.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ALIGNMENT_XALIGN, g_param_spec_float ("xalign", "xalign", "xalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The vertical alignment
	     *
	     * Value from 0 (left) to 1 (right), reversed for RTL layouts.
	     * Makes sense only if yscale < 1.0.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ALIGNMENT_YALIGN, g_param_spec_float ("yalign", "yalign", "yalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Scale child horizontally
	     *
	     * If available horizontal space is bigger than needed for the child,
	     * how much of it to use for the child.
	     *
	     *  0.0     use exactly what child requested
	     *  1.0     use entirely Bin space for child needs
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ALIGNMENT_XSCALE, g_param_spec_float ("xscale", "xscale", "xscale", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Scale child vertically
	     *
	     * If available vertical space is bigger than needed for the child,
	     * how much of it to use for the child.
	     *
	     *  0.0     use exactly what child requested
	     *  1.0     use entirely Bin space for child needs
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ALIGNMENT_YSCALE, g_param_spec_float ("yscale", "yscale", "yscale", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Ignore width requested by child
	     *
	     * Alignment will request 0 width in spite of child needs.
	     * Thus child could get less size then it requested, otherwise regular
	     * scheme will be preswerved.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ALIGNMENT_XIGNORE, g_param_spec_boolean ("xignore", "xignore", "xignore", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Ignore height requested by child
	     *
	     * Alignment will request 0 width in spite of child needs.
	     * Thus child could get less size then it requested, otherwise regular
	     * scheme will be preswerved.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ALIGNMENT_YIGNORE, g_param_spec_boolean ("yignore", "yignore", "yignore", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_override_property (G_OBJECT_CLASS (klass), SUGAR_ALIGNMENT_CHILD_X, "child-x");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SUGAR_ALIGNMENT_CHILD_Y, "child-y");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SUGAR_ALIGNMENT_CHILD_WIDTH, "child-width");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SUGAR_ALIGNMENT_CHILD_HEIGHT, "child-height");
}


static void sugar_alignment_instance_init (SugarAlignment * self) {
	self->priv = SUGAR_ALIGNMENT_GET_PRIVATE (self);
	self->priv->_xalign = 0.5f;
	self->priv->_yalign = 0.5f;
	self->priv->_xscale = 1.0f;
	self->priv->_yscale = 1.0f;
	self->priv->_xignore = TRUE;
	self->priv->_yignore = TRUE;
	self->priv->_xoffset = 0;
	self->priv->_yoffset = 0;
	self->priv->_child_width = 0;
	self->priv->_child_height = 0;
}


static void sugar_alignment_finalize (GObject* obj) {
	SugarAlignment * self;
	self = SUGAR_ALIGNMENT (obj);
	G_OBJECT_CLASS (sugar_alignment_parent_class)->finalize (obj);
}


GType sugar_alignment_get_type (void) {
	static volatile gsize sugar_alignment_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_alignment_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarAlignmentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_alignment_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarAlignment), 0, (GInstanceInitFunc) sugar_alignment_instance_init, NULL };
		GType sugar_alignment_type_id;
		sugar_alignment_type_id = g_type_register_static (SUGAR_TYPE_BIN, "SugarAlignment", &g_define_type_info, 0);
		g_once_init_leave (&sugar_alignment_type_id__volatile, sugar_alignment_type_id);
	}
	return sugar_alignment_type_id__volatile;
}


static void sugar_alignment_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarAlignment * self;
	self = SUGAR_ALIGNMENT (object);
	switch (property_id) {
		case SUGAR_ALIGNMENT_XALIGN:
		g_value_set_float (value, sugar_alignment_get_xalign (self));
		break;
		case SUGAR_ALIGNMENT_YALIGN:
		g_value_set_float (value, sugar_alignment_get_yalign (self));
		break;
		case SUGAR_ALIGNMENT_XSCALE:
		g_value_set_float (value, sugar_alignment_get_xscale (self));
		break;
		case SUGAR_ALIGNMENT_YSCALE:
		g_value_set_float (value, sugar_alignment_get_yscale (self));
		break;
		case SUGAR_ALIGNMENT_XIGNORE:
		g_value_set_boolean (value, sugar_alignment_get_xignore (self));
		break;
		case SUGAR_ALIGNMENT_YIGNORE:
		g_value_set_boolean (value, sugar_alignment_get_yignore (self));
		break;
		case SUGAR_ALIGNMENT_CHILD_X:
		g_value_set_int (value, sugar_container_get_child_x ((SugarContainer*) self));
		break;
		case SUGAR_ALIGNMENT_CHILD_Y:
		g_value_set_int (value, sugar_container_get_child_y ((SugarContainer*) self));
		break;
		case SUGAR_ALIGNMENT_CHILD_WIDTH:
		g_value_set_int (value, sugar_container_get_child_width ((SugarContainer*) self));
		break;
		case SUGAR_ALIGNMENT_CHILD_HEIGHT:
		g_value_set_int (value, sugar_container_get_child_height ((SugarContainer*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sugar_alignment_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarAlignment * self;
	self = SUGAR_ALIGNMENT (object);
	switch (property_id) {
		case SUGAR_ALIGNMENT_XALIGN:
		sugar_alignment_set_xalign (self, g_value_get_float (value));
		break;
		case SUGAR_ALIGNMENT_YALIGN:
		sugar_alignment_set_yalign (self, g_value_get_float (value));
		break;
		case SUGAR_ALIGNMENT_XSCALE:
		sugar_alignment_set_xscale (self, g_value_get_float (value));
		break;
		case SUGAR_ALIGNMENT_YSCALE:
		sugar_alignment_set_yscale (self, g_value_get_float (value));
		break;
		case SUGAR_ALIGNMENT_XIGNORE:
		sugar_alignment_set_xignore (self, g_value_get_boolean (value));
		break;
		case SUGAR_ALIGNMENT_YIGNORE:
		sugar_alignment_set_yignore (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




