/* animator.c generated by valac 0.10.1, the Vala compiler
 * generated from animator.vala, do not modify */

/* animator.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Port from original sugar-toolkit project.
 * File:   src/sugar/graphics/animator.py
 * Commit: c9e63eb8eadb0b133b88e9feb1ca48b75d959a7c
 *
 * Copyright (C) 2007, Red Hat, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
/*
 * Port from original sugar-toolkit project.
 * File:   src/sugar/graphics/palettewindow.py
 * Commit: c684950ecff34e910e6da5840737a469f95a0e79
 *
 * Copyright (C) 2007, Eduardo Silva <edsiper@gmail.com>
 * Copyright (C) 2008, One Laptop Per Child
 * Copyright (C) 2009, Tomeu Vizoso
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/gui.h"
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SugarAnimatorPrivate {
	double _duration;
	gint _timeout;
	double _start;
	double _stop;
	SugarAnimationType _type;
	guint _timeout_sid;
	SugarTimestamp _start_time;
};

struct _SugarMouseSpeedDetectorPrivate {
	gint _delay;
	gint _threshold;
	gint _state;
	guint _timeout_hid;
	gint _x;
	gint _y;
};


static gpointer sugar_animator_parent_class = NULL;
static gpointer sugar_mouse_speed_detector_parent_class = NULL;

#define SUGAR_ANIMATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_ANIMATOR, SugarAnimatorPrivate))
enum  {
	SUGAR_ANIMATOR_DUMMY_PROPERTY,
	SUGAR_ANIMATOR_ACTIVE
};
static gboolean _sugar_animator_next_frame_cb (SugarAnimator* self);
static gboolean __sugar_animator_next_frame_cb_gsource_func (gpointer self);
static void _sugar_animator_complete (SugarAnimator* self, gboolean aborted);
static void sugar_animator_finalize (GObject* obj);
static void sugar_animator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
#define SUGAR_MOUSE_SPEED_DETECTOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_MOUSE_SPEED_DETECTOR, SugarMouseSpeedDetectorPrivate))
enum  {
	SUGAR_MOUSE_SPEED_DETECTOR_DUMMY_PROPERTY
};
#define SUGAR_MOUSE_SPEED_DETECTOR__MOTION_SLOW 1
#define SUGAR_MOUSE_SPEED_DETECTOR__MOTION_FAST 2
static void _sugar_mouse_speed_detector_init_position (SugarMouseSpeedDetector* self);
static gboolean _sugar_mouse_speed_detector_timer_cb (SugarMouseSpeedDetector* self);
static gboolean __sugar_mouse_speed_detector_timer_cb_gsource_func (gpointer self);
static gboolean _sugar_mouse_speed_detector_detect_motion (SugarMouseSpeedDetector* self);
static void sugar_mouse_speed_detector_finalize (GObject* obj);



GType sugar_animation_type_get_type (void) {
	static volatile gsize sugar_animation_type_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_animation_type_type_id__volatile)) {
		static const GEnumValue values[] = {{SUGAR_ANIMATION_TYPE_OUT_EXPO, "SUGAR_ANIMATION_TYPE_OUT_EXPO", "out-expo"}, {SUGAR_ANIMATION_TYPE_IN_EXPO, "SUGAR_ANIMATION_TYPE_IN_EXPO", "in-expo"}, {0, NULL, NULL}};
		GType sugar_animation_type_type_id;
		sugar_animation_type_type_id = g_enum_register_static ("SugarAnimationType", values);
		g_once_init_leave (&sugar_animation_type_type_id__volatile, sugar_animation_type_type_id);
	}
	return sugar_animation_type_type_id__volatile;
}


/**
     * @param duration sec
     */
#line 85 "animator.vala"
SugarAnimator* sugar_animator_construct (GType object_type, double duration, gint fps, double start, double stop, SugarAnimationType type) {
#line 142 "animator.c"
	SugarAnimator * self = NULL;
	g_return_val_if_fail (duration > 0.0, NULL);
	g_return_val_if_fail (fps > 0, NULL);
	g_return_val_if_fail ((start >= 0.0) && (start <= 1.0), NULL);
	g_return_val_if_fail ((stop >= start) && (stop <= 1.0), NULL);
#line 85 "animator.vala"
	self = (SugarAnimator*) g_object_new (object_type, NULL);
#line 91 "animator.vala"
	self->priv->_duration = duration;
#line 92 "animator.vala"
	self->priv->_timeout = (gint) ((1.0 / fps) * 1000);
#line 93 "animator.vala"
	self->priv->_start = start;
#line 94 "animator.vala"
	self->priv->_stop = stop;
#line 95 "animator.vala"
	self->priv->_type = type;
#line 160 "animator.c"
	return self;
}


#line 85 "animator.vala"
SugarAnimator* sugar_animator_new (double duration, gint fps, double start, double stop, SugarAnimationType type) {
#line 85 "animator.vala"
	return sugar_animator_construct (SUGAR_TYPE_ANIMATOR, duration, fps, start, stop, type);
#line 169 "animator.c"
}


#line 117 "animator.vala"
static gboolean __sugar_animator_next_frame_cb_gsource_func (gpointer self) {
#line 175 "animator.c"
	gboolean result;
	result = _sugar_animator_next_frame_cb (self);
	return result;
}


#line 98 "animator.vala"
void sugar_animator_start (SugarAnimator* self) {
#line 98 "animator.vala"
	g_return_if_fail (self != NULL);
#line 99 "animator.vala"
	if (self->priv->_timeout_sid == 0) {
#line 188 "animator.c"
		SugarTimestamp _tmp0_ = {0};
#line 100 "animator.vala"
		self->priv->_start_time = (sugar_timestamp_init (&_tmp0_), _tmp0_);
#line 101 "animator.vala"
		self->priv->_timeout_sid = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) self->priv->_timeout, __sugar_animator_next_frame_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 194 "animator.c"
	}
}


#line 105 "animator.vala"
void sugar_animator_abort (SugarAnimator* self) {
#line 105 "animator.vala"
	g_return_if_fail (self != NULL);
#line 106 "animator.vala"
	_sugar_animator_complete (self, TRUE);
#line 205 "animator.c"
}


#line 109 "animator.vala"
static void _sugar_animator_complete (SugarAnimator* self, gboolean aborted) {
#line 109 "animator.vala"
	g_return_if_fail (self != NULL);
#line 110 "animator.vala"
	if (self->priv->_timeout_sid == 0) {
#line 111 "animator.vala"
		return;
#line 217 "animator.c"
	}
#line 112 "animator.vala"
	g_source_remove (self->priv->_timeout_sid);
#line 113 "animator.vala"
	self->priv->_timeout_sid = (guint) 0;
#line 114 "animator.vala"
	g_signal_emit_by_name (self, "completed", aborted);
#line 225 "animator.c"
}


#line 117 "animator.vala"
static gboolean _sugar_animator_next_frame_cb (SugarAnimator* self) {
#line 231 "animator.c"
	gboolean result = FALSE;
	SugarTimestamp _tmp0_ = {0};
	SugarTimestamp _tmp1_;
	double offset;
	double the_rest;
	double frame;
#line 117 "animator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 118 "animator.vala"
	offset = MIN (self->priv->_duration, sugar_timestamp_diff ((_tmp1_ = (sugar_timestamp_init (&_tmp0_), _tmp0_), &_tmp1_), &self->priv->_start_time));
#line 119 "animator.vala"
	the_rest = self->priv->_stop - self->priv->_start;
#line 120 "animator.vala"
	frame = self->priv->_stop;
#line 122 "animator.vala"
	if (offset < self->priv->_duration) {
#line 123 "animator.vala"
		if (self->priv->_type == SUGAR_ANIMATION_TYPE_OUT_EXPO) {
#line 124 "animator.vala"
			frame = (the_rest * (1 - pow ((double) 2, ((-10) * offset) / self->priv->_duration))) + self->priv->_start;
#line 252 "animator.c"
		} else {
#line 126 "animator.vala"
			if (self->priv->_type == SUGAR_ANIMATION_TYPE_IN_EXPO) {
#line 127 "animator.vala"
				frame = (the_rest * pow ((double) 2, 10 * ((offset / self->priv->_duration) - 1))) + self->priv->_start;
#line 258 "animator.c"
			}
		}
	}
#line 132 "animator.vala"
	g_signal_emit_by_name (self, "next-frame", frame);
#line 134 "animator.vala"
	if (offset < self->priv->_duration) {
#line 266 "animator.c"
		result = TRUE;
#line 135 "animator.vala"
		return result;
#line 270 "animator.c"
	} else {
#line 137 "animator.vala"
		_sugar_animator_complete (self, FALSE);
#line 274 "animator.c"
		result = FALSE;
#line 138 "animator.vala"
		return result;
#line 278 "animator.c"
	}
}


gboolean sugar_animator_get_active (SugarAnimator* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_timeout_sid != 0;
#line 79 "animator.vala"
	return result;
#line 289 "animator.c"
}


static void sugar_animator_class_init (SugarAnimatorClass * klass) {
	sugar_animator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarAnimatorPrivate));
	G_OBJECT_CLASS (klass)->get_property = sugar_animator_get_property;
	G_OBJECT_CLASS (klass)->finalize = sugar_animator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ANIMATOR_ACTIVE, g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("next_frame", SUGAR_TYPE_ANIMATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	g_signal_new ("completed", SUGAR_TYPE_ANIMATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}


static void sugar_animator_instance_init (SugarAnimator * self) {
	self->priv = SUGAR_ANIMATOR_GET_PRIVATE (self);
	self->priv->_timeout_sid = (guint) 0;
}


static void sugar_animator_finalize (GObject* obj) {
	SugarAnimator * self;
	self = SUGAR_ANIMATOR (obj);
	G_OBJECT_CLASS (sugar_animator_parent_class)->finalize (obj);
}


GType sugar_animator_get_type (void) {
	static volatile gsize sugar_animator_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_animator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarAnimatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_animator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarAnimator), 0, (GInstanceInitFunc) sugar_animator_instance_init, NULL };
		GType sugar_animator_type_id;
		sugar_animator_type_id = g_type_register_static (G_TYPE_OBJECT, "SugarAnimator", &g_define_type_info, 0);
		g_once_init_leave (&sugar_animator_type_id__volatile, sugar_animator_type_id);
	}
	return sugar_animator_type_id__volatile;
}


static void sugar_animator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarAnimator * self;
	self = SUGAR_ANIMATOR (object);
	switch (property_id) {
		case SUGAR_ANIMATOR_ACTIVE:
		g_value_set_boolean (value, sugar_animator_get_active (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


/**
     * @param delay in msec
     * @param threshold in pixels (per tick of 'delay' msec)
     */
#line 159 "animator.vala"
SugarMouseSpeedDetector* sugar_mouse_speed_detector_construct (GType object_type, gint delay, gint threshold) {
#line 349 "animator.c"
	SugarMouseSpeedDetector * self = NULL;
#line 159 "animator.vala"
	self = (SugarMouseSpeedDetector*) g_object_new (object_type, NULL);
#line 160 "animator.vala"
	self->priv->_delay = delay;
#line 161 "animator.vala"
	self->priv->_threshold = threshold;
#line 357 "animator.c"
	return self;
}


#line 159 "animator.vala"
SugarMouseSpeedDetector* sugar_mouse_speed_detector_new (gint delay, gint threshold) {
#line 159 "animator.vala"
	return sugar_mouse_speed_detector_construct (SUGAR_TYPE_MOUSE_SPEED_DETECTOR, delay, threshold);
#line 366 "animator.c"
}


#line 183 "animator.vala"
static gboolean __sugar_mouse_speed_detector_timer_cb_gsource_func (gpointer self) {
#line 372 "animator.c"
	gboolean result;
	result = _sugar_mouse_speed_detector_timer_cb (self);
	return result;
}


#line 164 "animator.vala"
void sugar_mouse_speed_detector_start (SugarMouseSpeedDetector* self) {
#line 164 "animator.vala"
	g_return_if_fail (self != NULL);
#line 165 "animator.vala"
	sugar_mouse_speed_detector_stop (self);
#line 166 "animator.vala"
	_sugar_mouse_speed_detector_init_position (self);
#line 167 "animator.vala"
	self->priv->_timeout_hid = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) self->priv->_delay, __sugar_mouse_speed_detector_timer_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 389 "animator.c"
}


#line 170 "animator.vala"
void sugar_mouse_speed_detector_stop (SugarMouseSpeedDetector* self) {
#line 170 "animator.vala"
	g_return_if_fail (self != NULL);
#line 171 "animator.vala"
	if (self->priv->_timeout_hid != 0) {
#line 172 "animator.vala"
		g_source_remove (self->priv->_timeout_hid);
#line 173 "animator.vala"
		self->priv->_timeout_hid = (guint) 0;
#line 403 "animator.c"
	}
#line 175 "animator.vala"
	self->priv->_state = 0;
#line 407 "animator.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 178 "animator.vala"
static void _sugar_mouse_speed_detector_init_position (SugarMouseSpeedDetector* self) {
#line 418 "animator.c"
	GdkDisplay* display;
#line 178 "animator.vala"
	g_return_if_fail (self != NULL);
#line 179 "animator.vala"
	display = _g_object_ref0 (gdk_display_get_default ());
#line 180 "animator.vala"
	gdk_display_get_pointer (display, NULL, &self->priv->_x, &self->priv->_y, NULL);
#line 426 "animator.c"
	_g_object_unref0 (display);
}


#line 183 "animator.vala"
static gboolean _sugar_mouse_speed_detector_timer_cb (SugarMouseSpeedDetector* self) {
#line 433 "animator.c"
	gboolean result = FALSE;
	gboolean motion;
	gboolean _tmp0_ = FALSE;
#line 183 "animator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 184 "animator.vala"
	motion = _sugar_mouse_speed_detector_detect_motion (self);
#line 186 "animator.vala"
	if (motion) {
#line 186 "animator.vala"
		_tmp0_ = self->priv->_state != SUGAR_MOUSE_SPEED_DETECTOR__MOTION_FAST;
#line 445 "animator.c"
	} else {
#line 186 "animator.vala"
		_tmp0_ = FALSE;
#line 449 "animator.c"
	}
#line 186 "animator.vala"
	if (_tmp0_) {
#line 187 "animator.vala"
		self->priv->_state = SUGAR_MOUSE_SPEED_DETECTOR__MOTION_FAST;
#line 188 "animator.vala"
		g_signal_emit_by_name (self, "motion-fast");
#line 457 "animator.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 189 "animator.vala"
		if (!motion) {
#line 189 "animator.vala"
			_tmp1_ = self->priv->_state != SUGAR_MOUSE_SPEED_DETECTOR__MOTION_SLOW;
#line 464 "animator.c"
		} else {
#line 189 "animator.vala"
			_tmp1_ = FALSE;
#line 468 "animator.c"
		}
#line 189 "animator.vala"
		if (_tmp1_) {
#line 190 "animator.vala"
			self->priv->_state = SUGAR_MOUSE_SPEED_DETECTOR__MOTION_SLOW;
#line 191 "animator.vala"
			g_signal_emit_by_name (self, "motion-slow");
#line 476 "animator.c"
		}
	}
	result = TRUE;
#line 194 "animator.vala"
	return result;
#line 482 "animator.c"
}


#line 197 "animator.vala"
static gboolean _sugar_mouse_speed_detector_detect_motion (SugarMouseSpeedDetector* self) {
#line 488 "animator.c"
	gboolean result = FALSE;
	gint x;
	gint y;
	gint dist2;
#line 197 "animator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 198 "animator.vala"
	x = self->priv->_x;
#line 199 "animator.vala"
	y = self->priv->_y;
#line 200 "animator.vala"
	_sugar_mouse_speed_detector_init_position (self);
#line 201 "animator.vala"
	dist2 = ((x - self->priv->_x) * (x - self->priv->_x)) + ((y - self->priv->_y) * (y - self->priv->_y));
#line 503 "animator.c"
	result = dist2 > (self->priv->_threshold * self->priv->_threshold);
#line 202 "animator.vala"
	return result;
#line 507 "animator.c"
}


static void sugar_mouse_speed_detector_class_init (SugarMouseSpeedDetectorClass * klass) {
	sugar_mouse_speed_detector_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarMouseSpeedDetectorPrivate));
	G_OBJECT_CLASS (klass)->finalize = sugar_mouse_speed_detector_finalize;
	g_signal_new ("motion_slow", SUGAR_TYPE_MOUSE_SPEED_DETECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("motion_fast", SUGAR_TYPE_MOUSE_SPEED_DETECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void sugar_mouse_speed_detector_instance_init (SugarMouseSpeedDetector * self) {
	self->priv = SUGAR_MOUSE_SPEED_DETECTOR_GET_PRIVATE (self);
	self->priv->_state = 0;
	self->priv->_timeout_hid = (guint) 0;
	self->priv->_x = 0;
	self->priv->_y = 0;
}


static void sugar_mouse_speed_detector_finalize (GObject* obj) {
	SugarMouseSpeedDetector * self;
	self = SUGAR_MOUSE_SPEED_DETECTOR (obj);
	G_OBJECT_CLASS (sugar_mouse_speed_detector_parent_class)->finalize (obj);
}


GType sugar_mouse_speed_detector_get_type (void) {
	static volatile gsize sugar_mouse_speed_detector_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_mouse_speed_detector_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarMouseSpeedDetectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_mouse_speed_detector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarMouseSpeedDetector), 0, (GInstanceInitFunc) sugar_mouse_speed_detector_instance_init, NULL };
		GType sugar_mouse_speed_detector_type_id;
		sugar_mouse_speed_detector_type_id = g_type_register_static (G_TYPE_OBJECT, "SugarMouseSpeedDetector", &g_define_type_info, 0);
		g_once_init_leave (&sugar_mouse_speed_detector_type_id__volatile, sugar_mouse_speed_detector_type_id);
	}
	return sugar_mouse_speed_detector_type_id__volatile;
}




