/* entry.c generated by valac 0.10.1, the Vala compiler
 * generated from entry.vala, do not modify */

/* entry.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Port from original sugar-toolkit project.
 * File:   src/sugar/graphics/iconentry.py
 * Commit: c9e63eb8eadb0b133b88e9feb1ca48b75d959a7c
 *
 * Copyright (C) 2007, One Laptop Per Child
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/gui.h"
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <polyol/env.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SugarEntryPrivate {
	char* _primary_icon;
	char* _secondary_icon;
	gboolean _has_clear_button;
};


static gpointer sugar_entry_parent_class = NULL;

#define SUGAR_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_ENTRY, SugarEntryPrivate))
enum  {
	SUGAR_ENTRY_DUMMY_PROPERTY,
	SUGAR_ENTRY_PRIMARY_ICON,
	SUGAR_ENTRY_SECONDARY_ICON,
	SUGAR_ENTRY_HAS_CLEAR_BUTTON
};
#define SUGAR_ENTRY__CLEAR_ICON "dialog-cancel"
static gboolean sugar_entry_real_key_press_event (GtkWidget* base, GdkEventKey* event);
static GdkPixbuf* _sugar_entry_load_icon (SugarEntry* self, const char* icon_name);
static void _sugar_entry_icon_press_cb (SugarEntry* self, GtkEntryIconPosition pos, GdkEvent* event);
static void _sugar_entry_changed_cb (SugarEntry* self);
static gboolean sugar_entry_get__has_icons (SugarEntry* self);
static void __sugar_entry_icon_press_cb_gtk_entry_icon_press (GtkEntry* _sender, GtkEntryIconPosition p0, GdkEvent* p1, gpointer self);
static void __sugar_entry_changed_cb_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void sugar_entry_finalize (GObject* obj);
static void sugar_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sugar_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 106 "entry.vala"
static gboolean sugar_entry_real_key_press_event (GtkWidget* base, GdkEventKey* event) {
#line 91 "entry.c"
	SugarEntry * self;
	gboolean result = FALSE;
	self = (SugarEntry*) base;
#line 107 "entry.vala"
	if ((*event).keyval == 0xff1b) {
#line 108 "entry.vala"
		gtk_entry_set_text ((GtkEntry*) self, "");
#line 99 "entry.c"
		result = TRUE;
#line 109 "entry.vala"
		return result;
#line 103 "entry.c"
	} else {
		result = GTK_WIDGET_CLASS (sugar_entry_parent_class)->key_press_event ((GtkWidget*) GTK_ENTRY (self), event);
#line 111 "entry.vala"
		return result;
#line 108 "entry.c"
	}
}


#line 122 "entry.vala"
static GdkPixbuf* _sugar_entry_load_icon (SugarEntry* self, const char* icon_name) {
#line 115 "entry.c"
	GdkPixbuf* result = NULL;
	SugarIconAttr _tmp0_ = {0};
	SugarIconAttr attr;
	SugarColor _tmp1_ = {0};
	SugarColor _tmp2_ = {0};
#line 122 "entry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "entry.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 123 "entry.vala"
	attr = (_tmp0_);
#line 124 "entry.vala"
	sugar_icon_attr_set_icon_name (&attr, icon_name);
#line 125 "entry.vala"
	sugar_icon_attr_set_icon_size (&attr, GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 126 "entry.vala"
	attr.fill_color = (sugar_color_get (SUGAR_COLOR_TOOLBAR_GREY, &_tmp1_), _tmp1_);
#line 127 "entry.vala"
	attr.stroke_color = (sugar_color_get (SUGAR_COLOR_TOOLBAR_GREY, &_tmp2_), _tmp2_);
#line 135 "entry.c"
	result = sugar_icon_get_pixbuf (&attr);
	sugar_icon_attr_destroy (&attr);
#line 128 "entry.vala"
	return result;
#line 140 "entry.c"
}


#line 131 "entry.vala"
static void _sugar_entry_icon_press_cb (SugarEntry* self, GtkEntryIconPosition pos, GdkEvent* event) {
#line 131 "entry.vala"
	g_return_if_fail (self != NULL);
#line 131 "entry.vala"
	g_return_if_fail (event != NULL);
#line 132 "entry.vala"
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
#line 133 "entry.vala"
		gtk_entry_set_text ((GtkEntry*) self, "");
#line 134 "entry.vala"
		sugar_entry_set_secondary_icon (self, NULL);
#line 156 "entry.c"
	}
}


#line 138 "entry.vala"
static void _sugar_entry_changed_cb (SugarEntry* self) {
#line 138 "entry.vala"
	g_return_if_fail (self != NULL);
#line 139 "entry.vala"
	if (gtk_entry_get_text_length ((GtkEntry*) self) > 0) {
#line 140 "entry.vala"
		sugar_entry_set_secondary_icon (self, SUGAR_ENTRY__CLEAR_ICON);
#line 169 "entry.c"
	} else {
#line 142 "entry.vala"
		sugar_entry_set_secondary_icon (self, NULL);
#line 173 "entry.c"
	}
}


#line 42 "entry.vala"
SugarEntry* sugar_entry_construct (GType object_type) {
#line 180 "entry.c"
	SugarEntry * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 42 "entry.vala"
SugarEntry* sugar_entry_new (void) {
#line 42 "entry.vala"
	return sugar_entry_construct (SUGAR_TYPE_ENTRY);
#line 191 "entry.c"
}


const char* sugar_entry_get_primary_icon (SugarEntry* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_primary_icon;
#line 45 "entry.vala"
	return result;
#line 201 "entry.c"
}


void sugar_entry_set_primary_icon (SugarEntry* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
#line 48 "entry.vala"
	if (_vala_strcmp0 (sugar_entry_get_primary_icon (self), value) == 0) {
#line 49 "entry.vala"
		return;
#line 212 "entry.c"
	}
#line 51 "entry.vala"
	self->priv->_primary_icon = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_primary_icon), _tmp0_);
#line 53 "entry.vala"
	if (sugar_entry_get__has_icons (self)) {
#line 54 "entry.vala"
		if (sugar_entry_get_primary_icon (self) != NULL) {
#line 220 "entry.c"
			GdkPixbuf* _tmp1_;
#line 55 "entry.vala"
			g_object_set ((GtkEntry*) self, "primary-icon-pixbuf", _tmp1_ = _sugar_entry_load_icon (self, sugar_entry_get_primary_icon (self)), NULL);
#line 224 "entry.c"
			_g_object_unref0 (_tmp1_);
		} else {
#line 57 "entry.vala"
			g_object_set ((GtkEntry*) self, "primary-icon-pixbuf", NULL, NULL);
#line 229 "entry.c"
		}
	}
	g_object_notify ((GObject *) self, "primary-icon");
}


const char* sugar_entry_get_secondary_icon (SugarEntry* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_secondary_icon;
#line 64 "entry.vala"
	return result;
#line 242 "entry.c"
}


void sugar_entry_set_secondary_icon (SugarEntry* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
#line 67 "entry.vala"
	if (_vala_strcmp0 (sugar_entry_get_secondary_icon (self), value) == 0) {
#line 68 "entry.vala"
		return;
#line 253 "entry.c"
	}
#line 70 "entry.vala"
	self->priv->_secondary_icon = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_secondary_icon), _tmp0_);
#line 72 "entry.vala"
	if (sugar_entry_get__has_icons (self)) {
#line 73 "entry.vala"
		if (sugar_entry_get_secondary_icon (self) != NULL) {
#line 261 "entry.c"
			GdkPixbuf* _tmp1_;
#line 74 "entry.vala"
			g_object_set ((GtkEntry*) self, "secondary-icon-pixbuf", _tmp1_ = _sugar_entry_load_icon (self, sugar_entry_get_secondary_icon (self)), NULL);
#line 265 "entry.c"
			_g_object_unref0 (_tmp1_);
		} else {
#line 76 "entry.vala"
			g_object_set ((GtkEntry*) self, "secondary-icon-pixbuf", NULL, NULL);
#line 270 "entry.c"
		}
	}
	g_object_notify ((GObject *) self, "secondary-icon");
}


gboolean sugar_entry_get_has_clear_button (SugarEntry* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_clear_button;
#line 83 "entry.vala"
	return result;
#line 283 "entry.c"
}


#line 131 "entry.vala"
static void __sugar_entry_icon_press_cb_gtk_entry_icon_press (GtkEntry* _sender, GtkEntryIconPosition p0, GdkEvent* p1, gpointer self) {
#line 289 "entry.c"
	_sugar_entry_icon_press_cb (self, p0, p1);
}


#line 138 "entry.vala"
static void __sugar_entry_changed_cb_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 296 "entry.c"
	_sugar_entry_changed_cb (self);
}


void sugar_entry_set_has_clear_button (SugarEntry* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
#line 86 "entry.vala"
	if (sugar_entry_get_has_clear_button (self) == value) {
#line 87 "entry.vala"
		return;
#line 309 "entry.c"
	}
#line 89 "entry.vala"
	if (sugar_entry_get__has_icons (self)) {
#line 89 "entry.vala"
		_tmp0_ = sugar_entry_get_has_clear_button (self);
#line 315 "entry.c"
	} else {
#line 89 "entry.vala"
		_tmp0_ = FALSE;
#line 319 "entry.c"
	}
#line 89 "entry.vala"
	if (_tmp0_) {
#line 323 "entry.c"
		guint _tmp1_;
		guint _tmp2_;
#line 90 "entry.vala"
		g_signal_parse_name ("icon-press", GTK_TYPE_ENTRY, &_tmp1_, NULL, FALSE);
#line 90 "entry.vala"
		g_signal_handlers_disconnect_matched ((GtkEntry*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) __sugar_entry_icon_press_cb_gtk_entry_icon_press, self);
#line 91 "entry.vala"
		g_signal_parse_name ("changed", GTK_TYPE_EDITABLE, &_tmp2_, NULL, FALSE);
#line 91 "entry.vala"
		g_signal_handlers_disconnect_matched ((GtkEditable*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) __sugar_entry_changed_cb_gtk_editable_changed, self);
#line 92 "entry.vala"
		sugar_entry_set_secondary_icon (self, NULL);
#line 336 "entry.c"
	}
#line 95 "entry.vala"
	self->priv->_has_clear_button = value;
#line 97 "entry.vala"
	if (sugar_entry_get__has_icons (self)) {
#line 97 "entry.vala"
		_tmp3_ = sugar_entry_get_has_clear_button (self);
#line 344 "entry.c"
	} else {
#line 97 "entry.vala"
		_tmp3_ = FALSE;
#line 348 "entry.c"
	}
#line 97 "entry.vala"
	if (_tmp3_) {
#line 98 "entry.vala"
		g_signal_connect_object ((GtkEntry*) self, "icon-press", (GCallback) __sugar_entry_icon_press_cb_gtk_entry_icon_press, self, 0);
#line 99 "entry.vala"
		g_signal_connect_object ((GtkEditable*) self, "changed", (GCallback) __sugar_entry_changed_cb_gtk_editable_changed, self, 0);
#line 100 "entry.vala"
		if (gtk_entry_get_text_length ((GtkEntry*) self) > 0) {
#line 101 "entry.vala"
			sugar_entry_set_secondary_icon (self, SUGAR_ENTRY__CLEAR_ICON);
#line 360 "entry.c"
		}
	}
	g_object_notify ((GObject *) self, "has-clear-button");
}


static gboolean sugar_entry_get__has_icons (SugarEntry* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
#line 117 "entry.vala"
	if (GTK_MAJOR_VERSION > 2) {
#line 117 "entry.vala"
		_tmp0_ = TRUE;
#line 375 "entry.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 118 "entry.vala"
		if (GTK_MAJOR_VERSION == 2) {
#line 118 "entry.vala"
			_tmp1_ = GTK_MINOR_VERSION >= 16;
#line 382 "entry.c"
		} else {
#line 118 "entry.vala"
			_tmp1_ = FALSE;
#line 386 "entry.c"
		}
#line 118 "entry.vala"
		_tmp0_ = _tmp1_;
#line 390 "entry.c"
	}
	result = _tmp0_;
#line 117 "entry.vala"
	return result;
#line 395 "entry.c"
}


static void sugar_entry_class_init (SugarEntryClass * klass) {
	sugar_entry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarEntryPrivate));
	GTK_WIDGET_CLASS (klass)->key_press_event = sugar_entry_real_key_press_event;
	G_OBJECT_CLASS (klass)->get_property = sugar_entry_get_property;
	G_OBJECT_CLASS (klass)->set_property = sugar_entry_set_property;
	G_OBJECT_CLASS (klass)->finalize = sugar_entry_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ENTRY_PRIMARY_ICON, g_param_spec_string ("primary-icon", "primary-icon", "primary-icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ENTRY_SECONDARY_ICON, g_param_spec_string ("secondary-icon", "secondary-icon", "secondary-icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ENTRY_HAS_CLEAR_BUTTON, g_param_spec_boolean ("has-clear-button", "has-clear-button", "has-clear-button", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void sugar_entry_instance_init (SugarEntry * self) {
	self->priv = SUGAR_ENTRY_GET_PRIVATE (self);
}


static void sugar_entry_finalize (GObject* obj) {
	SugarEntry * self;
	self = SUGAR_ENTRY (obj);
	_g_free0 (self->priv->_primary_icon);
	_g_free0 (self->priv->_secondary_icon);
	G_OBJECT_CLASS (sugar_entry_parent_class)->finalize (obj);
}


GType sugar_entry_get_type (void) {
	static volatile gsize sugar_entry_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarEntry), 0, (GInstanceInitFunc) sugar_entry_instance_init, NULL };
		GType sugar_entry_type_id;
		sugar_entry_type_id = g_type_register_static (GTK_TYPE_ENTRY, "SugarEntry", &g_define_type_info, 0);
		g_once_init_leave (&sugar_entry_type_id__volatile, sugar_entry_type_id);
	}
	return sugar_entry_type_id__volatile;
}


static void sugar_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarEntry * self;
	self = SUGAR_ENTRY (object);
	switch (property_id) {
		case SUGAR_ENTRY_PRIMARY_ICON:
		g_value_set_string (value, sugar_entry_get_primary_icon (self));
		break;
		case SUGAR_ENTRY_SECONDARY_ICON:
		g_value_set_string (value, sugar_entry_get_secondary_icon (self));
		break;
		case SUGAR_ENTRY_HAS_CLEAR_BUTTON:
		g_value_set_boolean (value, sugar_entry_get_has_clear_button (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sugar_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarEntry * self;
	self = SUGAR_ENTRY (object);
	switch (property_id) {
		case SUGAR_ENTRY_PRIMARY_ICON:
		sugar_entry_set_primary_icon (self, g_value_get_string (value));
		break;
		case SUGAR_ENTRY_SECONDARY_ICON:
		sugar_entry_set_secondary_icon (self, g_value_get_string (value));
		break;
		case SUGAR_ENTRY_HAS_CLEAR_BUTTON:
		sugar_entry_set_has_clear_button (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




