/* icon.c generated by valac 0.10.1, the Vala compiler
 * generated from icon.vala, do not modify */

/* icon.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Port from original sugar-toolkit project.
 * File:   src/sugar/graphics/icon.py
 * Commit: 4a4ea538cacd740f8e32f625d400e26ab590daa0
 *
 * Copyright (C) 2006-2007 Red Hat, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/gui.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <polyol/env.h>
#include <librsvg/rsvg.h>
#include <gdk-pixbuf/gdk-pixdata.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sugar_lru_unref0(var) ((var == NULL) ? NULL : (var = (sugar_lru_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_mapped_file_free0(var) ((var == NULL) ? NULL : (var = (g_mapped_file_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SugarIconPrivate {
	SugarIconAttr _attr;
	char* _file;
	guint _pulse_hid;
	double _pulse_phase;
};

struct _Block4Data {
	int _ref_count_;
	gint dst_width;
	gint dst_height;
};


static gpointer sugar_icon_parent_class = NULL;
extern SugarLRU* sugar__surface_cache;
SugarLRU* sugar__surface_cache = NULL;

#define SUGAR_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_ICON, SugarIconPrivate))
enum  {
	SUGAR_ICON_DUMMY_PROPERTY,
	SUGAR_ICON_FILE,
	SUGAR_ICON_FILL_COLOR,
	SUGAR_ICON_STROKE_COLOR,
	SUGAR_ICON_XO_COLOR,
	SUGAR_ICON_WIDTH,
	SUGAR_ICON_HEIGHT,
	SUGAR_ICON_PIXEL_SIZE,
	SUGAR_ICON_ICON_SIZE,
	SUGAR_ICON_PULSING
};
#define SUGAR_ICON__PULSE_INTERVAL 100
#define SUGAR_ICON__PULSE_STEP (G_PI / 10.0)
static void sugar_icon_real_dispose (GObject* base);
static void sugar_icon_real_size_request (GtkWidget* base, GtkRequisition* requisition);
static gboolean sugar_icon_real_expose_event (GtkWidget* base, GdkEventExpose* event);
static gboolean _sugar_icon_pulse_cb (SugarIcon* self);
static gboolean __sugar_icon_pulse_cb_gsource_func (gpointer self);
static void sugar_icon_finalize (GObject* obj);
static void sugar_icon_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sugar_icon_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static gboolean _sugar_color_equal (const SugarColor* s1, const SugarColor* s2);
RsvgHandle* _sugar_icon_load_svg (SugarIconAttr* attr);
static void _lambda4_ (gint width, gint height, Block4Data* _data4_);
static void __lambda4__rsvg_size_func (gint* width, gint* height, gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (Block4Data* _data4_);
#define SUGAR__FILL_TAG "<!ENTITY fill_color \""
#define SUGAR__STROKE_TAG "<!ENTITY stroke_color \""
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 118 "icon.vala"
static void sugar_icon_real_dispose (GObject* base) {
#line 125 "icon.c"
	SugarIcon * self;
	self = (SugarIcon*) base;
#line 119 "icon.vala"
	sugar_icon_set_pulsing (self, FALSE);
#line 120 "icon.vala"
	G_OBJECT_CLASS (sugar_icon_parent_class)->dispose ((GObject*) GTK_IMAGE (self));
#line 132 "icon.c"
}


#line 123 "icon.vala"
static void sugar_icon_real_size_request (GtkWidget* base, GtkRequisition* requisition) {
#line 138 "icon.c"
	SugarIcon * self;
	self = (SugarIcon*) base;
#line 124 "icon.vala"
	GTK_WIDGET_CLASS (sugar_icon_parent_class)->size_request ((GtkWidget*) GTK_IMAGE (self), requisition);
#line 126 "icon.vala"
	if (sugar_icon_get_width (self) > 0) {
#line 127 "icon.vala"
		(*requisition).width = sugar_icon_get_width (self);
#line 147 "icon.c"
	}
#line 128 "icon.vala"
	if (sugar_icon_get_height (self) > 0) {
#line 129 "icon.vala"
		(*requisition).height = sugar_icon_get_height (self);
#line 153 "icon.c"
	}
}


#line 132 "icon.vala"
static gboolean sugar_icon_real_expose_event (GtkWidget* base, GdkEventExpose* event) {
#line 160 "icon.c"
	SugarIcon * self;
	gboolean result = FALSE;
	SugarIconAttr _tmp0_ = {0};
	SugarIconAttr attr;
	gboolean cache;
	gboolean _tmp1_ = FALSE;
	cairo_surface_t* surface;
	float _tmp2_ = 0.0F;
	float xalign_;
	gint _tmp5_;
	gint x;
	gint _tmp6_;
	float _tmp7_;
	gint y;
	cairo_t* cairo_context;
	self = (SugarIcon*) base;
#line 133 "icon.vala"
	GTK_WIDGET_CLASS (sugar_icon_parent_class)->expose_event ((GtkWidget*) GTK_IMAGE (self), event);
#line 135 "icon.vala"
	attr = (sugar_icon_attr_copy (&self->priv->_attr, &_tmp0_), _tmp0_);
#line 136 "icon.vala"
	cache = TRUE;
#line 138 "icon.vala"
	if (attr.width <= 0) {
#line 138 "icon.vala"
		_tmp1_ = TRUE;
#line 187 "icon.c"
	} else {
#line 138 "icon.vala"
		_tmp1_ = attr.height <= 0;
#line 191 "icon.c"
	}
#line 138 "icon.vala"
	if (_tmp1_) {
#line 139 "icon.vala"
		attr.width = ((GtkWidget*) self)->allocation.width;
#line 140 "icon.vala"
		attr.height = ((GtkWidget*) self)->allocation.height;
#line 141 "icon.vala"
		cache = FALSE;
#line 201 "icon.c"
	}
#line 144 "icon.vala"
	surface = sugar_icon_get_surface (&attr, cache);
#line 145 "icon.vala"
	if (surface == NULL) {
#line 207 "icon.c"
		result = FALSE;
		_cairo_surface_destroy0 (surface);
		sugar_icon_attr_destroy (&attr);
#line 146 "icon.vala"
		return result;
#line 213 "icon.c"
	}
#line 148 "icon.vala"
	if (gtk_widget_get_direction ((GtkWidget*) self) != GTK_TEXT_DIR_LTR) {
#line 217 "icon.c"
		float _tmp3_;
#line 149 "icon.vala"
		_tmp2_ = (g_object_get ((GtkMisc*) self, "xalign", &_tmp3_, NULL), _tmp3_);
#line 221 "icon.c"
	} else {
		float _tmp4_;
#line 149 "icon.vala"
		_tmp2_ = 1.0f - (g_object_get ((GtkMisc*) self, "xalign", &_tmp4_, NULL), _tmp4_);
#line 226 "icon.c"
	}
#line 148 "icon.vala"
	xalign_ = _tmp2_;
#line 151 "icon.vala"
	x = (gint) floor ((double) ((((GtkWidget*) self)->allocation.x + (g_object_get ((GtkMisc*) self, "xpad", &_tmp5_, NULL), _tmp5_)) + ((((GtkWidget*) self)->allocation.width - attr.width) * xalign_)));
#line 153 "icon.vala"
	y = (gint) floor ((double) ((((GtkWidget*) self)->allocation.y + (g_object_get ((GtkMisc*) self, "ypad", &_tmp6_, NULL), _tmp6_)) + ((((GtkWidget*) self)->allocation.height - attr.height) * (g_object_get ((GtkMisc*) self, "yalign", &_tmp7_, NULL), _tmp7_))));
#line 156 "icon.vala"
	cairo_context = gdk_cairo_create ((GdkDrawable*) ((GtkWidget*) self)->window);
#line 157 "icon.vala"
	cairo_set_source_surface (cairo_context, surface, (double) x, (double) y);
#line 159 "icon.vala"
	if (sugar_icon_get_pulsing (self)) {
#line 240 "icon.c"
		double alpha;
#line 160 "icon.vala"
		alpha = 0.2 + ((sin (self->priv->_pulse_phase) + 1.0) / 2.5);
#line 161 "icon.vala"
		cairo_paint_with_alpha (cairo_context, alpha);
#line 246 "icon.c"
	} else {
#line 162 "icon.vala"
		if (gtk_widget_get_state ((GtkWidget*) self) == GTK_STATE_INSENSITIVE) {
#line 163 "icon.vala"
			cairo_paint_with_alpha (cairo_context, 0.25);
#line 252 "icon.c"
		} else {
#line 165 "icon.vala"
			cairo_paint (cairo_context);
#line 256 "icon.c"
		}
	}
	result = FALSE;
	_cairo_destroy0 (cairo_context);
	_cairo_surface_destroy0 (surface);
	sugar_icon_attr_destroy (&attr);
#line 167 "icon.vala"
	return result;
#line 265 "icon.c"
}


#line 170 "icon.vala"
static gboolean _sugar_icon_pulse_cb (SugarIcon* self) {
#line 271 "icon.c"
	gboolean result = FALSE;
#line 170 "icon.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "icon.vala"
	self->priv->_pulse_phase = self->priv->_pulse_phase + SUGAR_ICON__PULSE_STEP;
#line 172 "icon.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 279 "icon.c"
	result = TRUE;
#line 173 "icon.vala"
	return result;
#line 283 "icon.c"
}


#line 44 "icon.vala"
SugarIcon* sugar_icon_construct (GType object_type) {
#line 289 "icon.c"
	SugarIcon * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 44 "icon.vala"
SugarIcon* sugar_icon_new (void) {
#line 44 "icon.vala"
	return sugar_icon_construct (SUGAR_TYPE_ICON);
#line 300 "icon.c"
}


const char* sugar_icon_get_file (SugarIcon* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_file;
#line 47 "icon.vala"
	return result;
#line 310 "icon.c"
}


void sugar_icon_set_file (SugarIcon* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
#line 50 "icon.vala"
	if (_vala_strcmp0 (value, sugar_icon_get_file (self)) == 0) {
#line 51 "icon.vala"
		return;
#line 321 "icon.c"
	}
#line 53 "icon.vala"
	self->priv->_file = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_file), _tmp0_);
#line 55 "icon.vala"
	if (g_utf8_get_char (g_utf8_offset_to_pointer (value, 0)) == '/') {
#line 327 "icon.c"
		char* _tmp1_;
#line 56 "icon.vala"
		self->priv->_attr.file_name = (_tmp1_ = g_strdup (sugar_icon_get_file (self)), _g_free0 (self->priv->_attr.file_name), _tmp1_);
#line 331 "icon.c"
	} else {
#line 58 "icon.vala"
		sugar_icon_attr_set_icon_name (&self->priv->_attr, sugar_icon_get_file (self));
#line 335 "icon.c"
	}
#line 60 "icon.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 339 "icon.c"
	g_object_notify ((GObject *) self, "file");
}


void sugar_icon_get_fill_color (SugarIcon* self, SugarColor* result) {
	g_return_if_fail (self != NULL);
	*result = self->priv->_attr.fill_color;
#line 65 "icon.vala"
	return;
#line 349 "icon.c"
}


void sugar_icon_set_fill_color (SugarIcon* self, SugarColor* value) {
	g_return_if_fail (self != NULL);
#line 66 "icon.vala"
	self->priv->_attr.fill_color = *value;
#line 66 "icon.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 359 "icon.c"
	g_object_notify ((GObject *) self, "fill-color");
}


void sugar_icon_get_stroke_color (SugarIcon* self, SugarColor* result) {
	g_return_if_fail (self != NULL);
	*result = self->priv->_attr.stroke_color;
#line 70 "icon.vala"
	return;
#line 369 "icon.c"
}


void sugar_icon_set_stroke_color (SugarIcon* self, SugarColor* value) {
	g_return_if_fail (self != NULL);
#line 71 "icon.vala"
	self->priv->_attr.stroke_color = *value;
#line 71 "icon.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 379 "icon.c"
	g_object_notify ((GObject *) self, "stroke-color");
}


void sugar_icon_set_xo_color (SugarIcon* self, SugarXoColor* value) {
	g_return_if_fail (self != NULL);
#line 75 "icon.vala"
	sugar_icon_attr_set_xo_color (&self->priv->_attr, value);
#line 388 "icon.c"
	g_object_notify ((GObject *) self, "xo-color");
}


gint sugar_icon_get_width (SugarIcon* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_attr.width;
#line 79 "icon.vala"
	return result;
#line 399 "icon.c"
}


gint sugar_icon_get_height (SugarIcon* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_attr.height;
#line 83 "icon.vala"
	return result;
#line 409 "icon.c"
}


void sugar_icon_set_pixel_size (SugarIcon* self, gint value) {
	g_return_if_fail (self != NULL);
#line 88 "icon.vala"
	self->priv->_attr.width = self->priv->_attr.height = value;
#line 89 "icon.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 419 "icon.c"
	g_object_notify ((GObject *) self, "pixel-size");
}


void sugar_icon_set_icon_size (SugarIcon* self, GtkIconSize value) {
	g_return_if_fail (self != NULL);
#line 95 "icon.vala"
	sugar_icon_attr_set_icon_size (&self->priv->_attr, value);
#line 96 "icon.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 430 "icon.c"
	g_object_notify ((GObject *) self, "icon-size");
}


gboolean sugar_icon_get_pulsing (SugarIcon* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_pulse_hid != 0;
#line 102 "icon.vala"
	return result;
#line 441 "icon.c"
}


#line 170 "icon.vala"
static gboolean __sugar_icon_pulse_cb_gsource_func (gpointer self) {
#line 447 "icon.c"
	gboolean result;
	result = _sugar_icon_pulse_cb (self);
	return result;
}


void sugar_icon_set_pulsing (SugarIcon* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 105 "icon.vala"
	if (value == sugar_icon_get_pulsing (self)) {
#line 106 "icon.vala"
		return;
#line 460 "icon.c"
	}
#line 107 "icon.vala"
	if (value) {
#line 108 "icon.vala"
		self->priv->_pulse_phase = 0.0;
#line 109 "icon.vala"
		self->priv->_pulse_hid = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) SUGAR_ICON__PULSE_INTERVAL, __sugar_icon_pulse_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 468 "icon.c"
	} else {
#line 111 "icon.vala"
		g_source_remove (self->priv->_pulse_hid);
#line 112 "icon.vala"
		self->priv->_pulse_hid = (guint) 0;
#line 113 "icon.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 476 "icon.c"
	}
	g_object_notify ((GObject *) self, "pulsing");
}


static void sugar_icon_class_init (SugarIconClass * klass) {
	sugar_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarIconPrivate));
	G_OBJECT_CLASS (klass)->dispose = sugar_icon_real_dispose;
	GTK_WIDGET_CLASS (klass)->size_request = sugar_icon_real_size_request;
	GTK_WIDGET_CLASS (klass)->expose_event = sugar_icon_real_expose_event;
	G_OBJECT_CLASS (klass)->get_property = sugar_icon_get_property;
	G_OBJECT_CLASS (klass)->set_property = sugar_icon_set_property;
	G_OBJECT_CLASS (klass)->finalize = sugar_icon_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ICON_FILE, g_param_spec_string ("file", "file", "file", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ICON_FILL_COLOR, g_param_spec_boxed ("fill-color", "fill-color", "fill-color", SUGAR_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ICON_STROKE_COLOR, g_param_spec_boxed ("stroke-color", "stroke-color", "stroke-color", SUGAR_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ICON_XO_COLOR, g_param_spec_boxed ("xo-color", "xo-color", "xo-color", SUGAR_TYPE_XO_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ICON_WIDTH, g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ICON_HEIGHT, g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ICON_PIXEL_SIZE, g_param_spec_int ("pixel-size", "pixel-size", "pixel-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ICON_ICON_SIZE, g_param_spec_enum ("icon-size", "icon-size", "icon-size", GTK_TYPE_ICON_SIZE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ICON_PULSING, g_param_spec_boolean ("pulsing", "pulsing", "pulsing", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void sugar_icon_instance_init (SugarIcon * self) {
	self->priv = SUGAR_ICON_GET_PRIVATE (self);
}


static void sugar_icon_finalize (GObject* obj) {
	SugarIcon * self;
	self = SUGAR_ICON (obj);
	sugar_icon_attr_destroy (&self->priv->_attr);
	_g_free0 (self->priv->_file);
	G_OBJECT_CLASS (sugar_icon_parent_class)->finalize (obj);
}


GType sugar_icon_get_type (void) {
	static volatile gsize sugar_icon_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarIcon), 0, (GInstanceInitFunc) sugar_icon_instance_init, NULL };
		GType sugar_icon_type_id;
		sugar_icon_type_id = g_type_register_static (GTK_TYPE_IMAGE, "SugarIcon", &g_define_type_info, 0);
		g_once_init_leave (&sugar_icon_type_id__volatile, sugar_icon_type_id);
	}
	return sugar_icon_type_id__volatile;
}


static void sugar_icon_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarIcon * self;
	SugarColor boxed0;
	SugarColor boxed1;
	self = SUGAR_ICON (object);
	switch (property_id) {
		case SUGAR_ICON_FILE:
		g_value_set_string (value, sugar_icon_get_file (self));
		break;
		case SUGAR_ICON_FILL_COLOR:
		sugar_icon_get_fill_color (self, &boxed0);
		g_value_set_boxed (value, &boxed0);
		break;
		case SUGAR_ICON_STROKE_COLOR:
		sugar_icon_get_stroke_color (self, &boxed1);
		g_value_set_boxed (value, &boxed1);
		break;
		case SUGAR_ICON_WIDTH:
		g_value_set_int (value, sugar_icon_get_width (self));
		break;
		case SUGAR_ICON_HEIGHT:
		g_value_set_int (value, sugar_icon_get_height (self));
		break;
		case SUGAR_ICON_PULSING:
		g_value_set_boolean (value, sugar_icon_get_pulsing (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sugar_icon_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarIcon * self;
	self = SUGAR_ICON (object);
	switch (property_id) {
		case SUGAR_ICON_FILE:
		sugar_icon_set_file (self, g_value_get_string (value));
		break;
		case SUGAR_ICON_FILL_COLOR:
		sugar_icon_set_fill_color (self, g_value_get_boxed (value));
		break;
		case SUGAR_ICON_STROKE_COLOR:
		sugar_icon_set_stroke_color (self, g_value_get_boxed (value));
		break;
		case SUGAR_ICON_XO_COLOR:
		sugar_icon_set_xo_color (self, g_value_get_boxed (value));
		break;
		case SUGAR_ICON_PIXEL_SIZE:
		sugar_icon_set_pixel_size (self, g_value_get_int (value));
		break;
		case SUGAR_ICON_ICON_SIZE:
		sugar_icon_set_icon_size (self, g_value_get_enum (value));
		break;
		case SUGAR_ICON_PULSING:
		sugar_icon_set_pulsing (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 227 "icon.vala"
guint sugar_icon_attr_hash (SugarIconAttr* x) {
#line 596 "icon.c"
	guint result = 0U;
	guint _tmp0_ = 0U;
#line 228 "icon.vala"
	if ((*x).file_name == NULL) {
#line 228 "icon.vala"
		_tmp0_ = (guint) 0;
#line 603 "icon.c"
	} else {
#line 228 "icon.vala"
		_tmp0_ = g_str_hash ((*x).file_name);
#line 607 "icon.c"
	}
	result = (((_tmp0_ + sugar_color_get_integer (&(*x).fill_color)) + sugar_color_get_integer (&(*x).stroke_color)) + (*x).width) + (*x).height;
#line 228 "icon.vala"
	return result;
#line 612 "icon.c"
}


static gboolean _sugar_color_equal (const SugarColor* s1, const SugarColor* s2) {
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->alpha != s2->alpha) {
		return FALSE;
	}
	if (s1->red != s2->red) {
		return FALSE;
	}
	if (s1->green != s2->green) {
		return FALSE;
	}
	if (s1->blue != s2->blue) {
		return FALSE;
	}
	return TRUE;
}


#line 233 "icon.vala"
gboolean sugar_icon_attr_cmp (SugarIconAttr* x, SugarIconAttr* y) {
#line 644 "icon.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 234 "icon.vala"
	if (_vala_strcmp0 ((*x).file_name, (*y).file_name) == 0) {
#line 234 "icon.vala"
		_tmp3_ = _sugar_color_equal (&(*x).fill_color, &(*y).fill_color) == TRUE;
#line 654 "icon.c"
	} else {
#line 234 "icon.vala"
		_tmp3_ = FALSE;
#line 658 "icon.c"
	}
#line 234 "icon.vala"
	if (_tmp3_) {
#line 235 "icon.vala"
		_tmp2_ = _sugar_color_equal (&(*x).stroke_color, &(*y).stroke_color) == TRUE;
#line 664 "icon.c"
	} else {
#line 234 "icon.vala"
		_tmp2_ = FALSE;
#line 668 "icon.c"
	}
#line 234 "icon.vala"
	if (_tmp2_) {
#line 235 "icon.vala"
		_tmp1_ = (*x).width == (*y).width;
#line 674 "icon.c"
	} else {
#line 234 "icon.vala"
		_tmp1_ = FALSE;
#line 678 "icon.c"
	}
#line 234 "icon.vala"
	if (_tmp1_) {
#line 236 "icon.vala"
		_tmp0_ = (*x).height == (*y).height;
#line 684 "icon.c"
	} else {
#line 234 "icon.vala"
		_tmp0_ = FALSE;
#line 688 "icon.c"
	}
	result = _tmp0_;
#line 234 "icon.vala"
	return result;
#line 693 "icon.c"
}


void sugar_icon_attr_set_xo_color (SugarIconAttr* self, SugarXoColor* value) {
	g_return_if_fail (self != NULL);
#line 200 "icon.vala"
	(*self).fill_color = (*value).fill;
#line 201 "icon.vala"
	(*self).stroke_color = (*value).stroke;
#line 703 "icon.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void sugar_icon_attr_set_icon_name (SugarIconAttr* self, const char* value) {
	GtkIconTheme* theme;
	GtkIconInfo* info;
	g_return_if_fail (self != NULL);
#line 208 "icon.vala"
	theme = _g_object_ref0 (gtk_icon_theme_get_default ());
#line 209 "icon.vala"
	info = gtk_icon_theme_lookup_icon (theme, value, (*self).width, 0);
#line 211 "icon.vala"
	if (info != NULL) {
#line 722 "icon.c"
		char* _tmp0_;
#line 212 "icon.vala"
		(*self).file_name = (_tmp0_ = g_strdup (gtk_icon_info_get_filename (info)), _g_free0 ((*self).file_name), _tmp0_);
#line 726 "icon.c"
	} else {
		char* _tmp1_;
#line 214 "icon.vala"
		g_warning ("icon.vala:214: No icon with the name '%s' was found", value);
#line 215 "icon.vala"
		(*self).file_name = (_tmp1_ = NULL, _g_free0 ((*self).file_name), _tmp1_);
#line 733 "icon.c"
	}
	_gtk_icon_info_free0 (info);
	_g_object_unref0 (theme);
}


void sugar_icon_attr_set_icon_size (SugarIconAttr* self, GtkIconSize value) {
	g_return_if_fail (self != NULL);
#line 223 "icon.vala"
	gtk_icon_size_lookup (value, &(*self).width, &(*self).height);
#line 744 "icon.c"
}


void sugar_icon_attr_copy (const SugarIconAttr* self, SugarIconAttr* dest) {
	dest->file_name = g_strdup (self->file_name);
	dest->fill_color = self->fill_color;
	dest->stroke_color = self->stroke_color;
	dest->width = self->width;
	dest->height = self->height;
}


void sugar_icon_attr_destroy (SugarIconAttr* self) {
	_g_free0 (self->file_name);
}


SugarIconAttr* sugar_icon_attr_dup (const SugarIconAttr* self) {
	SugarIconAttr* dup;
	dup = g_new0 (SugarIconAttr, 1);
	sugar_icon_attr_copy (self, dup);
	return dup;
}


void sugar_icon_attr_free (SugarIconAttr* self) {
	sugar_icon_attr_destroy (self);
	g_free (self);
}


GType sugar_icon_attr_get_type (void) {
	static volatile gsize sugar_icon_attr_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_icon_attr_type_id__volatile)) {
		GType sugar_icon_attr_type_id;
		sugar_icon_attr_type_id = g_boxed_type_register_static ("SugarIconAttr", (GBoxedCopyFunc) sugar_icon_attr_dup, (GBoxedFreeFunc) sugar_icon_attr_free);
		g_once_init_leave (&sugar_icon_attr_type_id__volatile, sugar_icon_attr_type_id);
	}
	return sugar_icon_attr_type_id__volatile;
}


#line 240 "icon.vala"
void sugar_icon_cache_reset (void) {
#line 789 "icon.c"
	SugarLRU* _tmp0_;
#line 241 "icon.vala"
	sugar__surface_cache = (_tmp0_ = NULL, _sugar_lru_unref0 (sugar__surface_cache), _tmp0_);
#line 793 "icon.c"
}


/**
     * Get cairo surface for sugar icon.
     *
     * @param attr  icon attributes
     * @param cache cache generated surface
     *
     * @return surface or null
     */
#line 252 "icon.vala"
cairo_surface_t* sugar_icon_get_surface (SugarIconAttr* attr, gboolean cache) {
#line 807 "icon.c"
	cairo_surface_t* result = NULL;
	cairo_surface_t* surface;
	RsvgHandle* handle;
	gint _tmp1_ = 0;
	gint dst_width;
	gint _tmp3_ = 0;
	gint dst_height;
	cairo_surface_t* _tmp5_;
	cairo_t* context;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_;
#line 253 "icon.vala"
	if ((*attr).file_name == NULL) {
#line 821 "icon.c"
		result = NULL;
#line 254 "icon.vala"
		return result;
#line 825 "icon.c"
	}
#line 256 "icon.vala"
	if (sugar__surface_cache == NULL) {
#line 829 "icon.c"
		SugarLRU* _tmp0_;
#line 257 "icon.vala"
		sugar__surface_cache = (_tmp0_ = sugar_lru_new (SUGAR_TYPE_ICON_ATTR, (GBoxedCopyFunc) sugar_icon_attr_dup, sugar_icon_attr_free, G_TYPE_POINTER, (GBoxedCopyFunc) cairo_surface_reference, cairo_surface_destroy, 50, (GHashFunc) sugar_icon_attr_hash, (GEqualFunc) sugar_icon_attr_cmp), _sugar_lru_unref0 (sugar__surface_cache), _tmp0_);
#line 833 "icon.c"
	}
#line 260 "icon.vala"
	surface = (cairo_surface_t*) sugar_lru_get (sugar__surface_cache, attr);
#line 261 "icon.vala"
	if (surface != NULL) {
#line 839 "icon.c"
		result = surface;
#line 262 "icon.vala"
		return result;
#line 843 "icon.c"
	}
#line 264 "icon.vala"
	handle = _sugar_icon_load_svg (attr);
#line 265 "icon.vala"
	if (handle == NULL) {
#line 849 "icon.c"
		result = NULL;
		_g_object_unref0 (handle);
		_cairo_surface_destroy0 (surface);
#line 266 "icon.vala"
		return result;
#line 855 "icon.c"
	}
#line 268 "icon.vala"
	if ((*attr).width > 0) {
#line 268 "icon.vala"
		_tmp1_ = (*attr).width;
#line 861 "icon.c"
	} else {
		gint _tmp2_;
#line 268 "icon.vala"
		_tmp1_ = (g_object_get (handle, "width", &_tmp2_, NULL), _tmp2_);
#line 866 "icon.c"
	}
#line 268 "icon.vala"
	dst_width = _tmp1_;
#line 269 "icon.vala"
	if ((*attr).height > 0) {
#line 269 "icon.vala"
		_tmp3_ = (*attr).height;
#line 874 "icon.c"
	} else {
		gint _tmp4_;
#line 269 "icon.vala"
		_tmp3_ = (g_object_get (handle, "height", &_tmp4_, NULL), _tmp4_);
#line 879 "icon.c"
	}
#line 269 "icon.vala"
	dst_height = _tmp3_;
#line 271 "icon.vala"
	surface = (_tmp5_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, dst_width, dst_height), _cairo_surface_destroy0 (surface), _tmp5_);
#line 273 "icon.vala"
	context = cairo_create (surface);
#line 275 "icon.vala"
	if (dst_width != (g_object_get (handle, "width", &_tmp7_, NULL), _tmp7_)) {
#line 275 "icon.vala"
		_tmp6_ = TRUE;
#line 891 "icon.c"
	} else {
		gint _tmp8_;
#line 275 "icon.vala"
		_tmp6_ = dst_height != (g_object_get (handle, "height", &_tmp8_, NULL), _tmp8_);
#line 896 "icon.c"
	}
#line 275 "icon.vala"
	if (_tmp6_) {
#line 900 "icon.c"
		gint _tmp9_;
		gint _tmp10_;
#line 276 "icon.vala"
		cairo_scale (context, (double) (((float) dst_width) / (g_object_get (handle, "width", &_tmp9_, NULL), _tmp9_)), (double) (((float) dst_height) / (g_object_get (handle, "height", &_tmp10_, NULL), _tmp10_)));
#line 905 "icon.c"
	}
#line 279 "icon.vala"
	rsvg_handle_render_cairo (handle, context);
#line 281 "icon.vala"
	if (cache) {
#line 282 "icon.vala"
		sugar_lru_set (sugar__surface_cache, attr, surface);
#line 913 "icon.c"
	}
	result = surface;
	_cairo_destroy0 (context);
	_g_object_unref0 (handle);
#line 284 "icon.vala"
	return result;
#line 920 "icon.c"
}


#line 298 "icon.vala"
static void _lambda4_ (gint width, gint height, Block4Data* _data4_) {
#line 299 "icon.vala"
	width = _data4_->dst_width;
#line 300 "icon.vala"
	height = _data4_->dst_height;
#line 930 "icon.c"
}


#line 298 "icon.vala"
static void __lambda4__rsvg_size_func (gint* width, gint* height, gpointer self) {
#line 936 "icon.c"
	_lambda4_ (width, height, self);
}


static Block4Data* block4_data_ref (Block4Data* _data4_) {
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}


static void block4_data_unref (Block4Data* _data4_) {
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		g_slice_free (Block4Data, _data4_);
	}
}


#line 287 "icon.vala"
GdkPixbuf* sugar_icon_get_pixbuf (SugarIconAttr* attr) {
#line 956 "icon.c"
	GdkPixbuf* result = NULL;
	Block4Data* _data4_;
	RsvgHandle* handle;
	gint _tmp0_ = 0;
	gint _tmp2_ = 0;
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
#line 288 "icon.vala"
	if ((*attr).file_name == NULL) {
#line 966 "icon.c"
		result = NULL;
		block4_data_unref (_data4_);
#line 289 "icon.vala"
		return result;
#line 971 "icon.c"
	}
#line 291 "icon.vala"
	handle = _sugar_icon_load_svg (attr);
#line 292 "icon.vala"
	if (handle == NULL) {
#line 977 "icon.c"
		result = NULL;
		_g_object_unref0 (handle);
		block4_data_unref (_data4_);
#line 293 "icon.vala"
		return result;
#line 983 "icon.c"
	}
#line 295 "icon.vala"
	if ((*attr).width > 0) {
#line 295 "icon.vala"
		_tmp0_ = (*attr).width;
#line 989 "icon.c"
	} else {
		gint _tmp1_;
#line 295 "icon.vala"
		_tmp0_ = (g_object_get (handle, "width", &_tmp1_, NULL), _tmp1_);
#line 994 "icon.c"
	}
	_data4_->dst_width = _tmp0_;
#line 296 "icon.vala"
	if ((*attr).height > 0) {
#line 296 "icon.vala"
		_tmp2_ = (*attr).height;
#line 1001 "icon.c"
	} else {
		gint _tmp3_;
#line 296 "icon.vala"
		_tmp2_ = (g_object_get (handle, "height", &_tmp3_, NULL), _tmp3_);
#line 1006 "icon.c"
	}
	_data4_->dst_height = _tmp2_;
#line 298 "icon.vala"
	rsvg_handle_set_size_callback (handle, __lambda4__rsvg_size_func, block4_data_ref (_data4_), block4_data_unref);
#line 1011 "icon.c"
	result = _g_object_ref0 (rsvg_handle_get_pixbuf (handle));
	_g_object_unref0 (handle);
	block4_data_unref (_data4_);
#line 303 "icon.vala"
	return result;
#line 1017 "icon.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1190 "glib-2.0.vapi"
	return result;
#line 1027 "icon.c"
}


#line 306 "icon.vala"
RsvgHandle* _sugar_icon_load_svg (SugarIconAttr* attr) {
#line 1033 "icon.c"
	RsvgHandle* result = NULL;
	GMappedFile* src;
	GString* dst;
	gchar* pos;
	gchar* end;
	char* _tmp2_;
	char* fill;
	char* _tmp5_;
	char* stroke;
	gboolean _tmp8_ = FALSE;
	gint data_length1;
	gint _data_size_;
	guchar* data;
	gsize data_len = 0UL;
	GError * _inner_error_ = NULL;
#line 307 "icon.vala"
	src = NULL;
#line 308 "icon.vala"
	dst = NULL;
#line 1053 "icon.c"
	{
		GMappedFile* _tmp0_;
		GMappedFile* _tmp1_;
#line 311 "icon.vala"
		_tmp0_ = g_mapped_file_new ((*attr).file_name, FALSE, &_inner_error_);
#line 1059 "icon.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch1_g_file_error;
			}
			_g_string_free0 (dst);
			_g_mapped_file_free0 (src);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
#line 311 "icon.vala"
		src = (_tmp1_ = _tmp0_, _g_mapped_file_free0 (src), _tmp1_);
#line 1072 "icon.c"
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 313 "icon.vala"
			g_warning ("icon.vala:313: Cannot load '%s' svg: %s", (*attr).file_name, e->message);
#line 1083 "icon.c"
			result = NULL;
			_g_error_free0 (e);
			_g_string_free0 (dst);
			_g_mapped_file_free0 (src);
#line 314 "icon.vala"
			return result;
#line 1090 "icon.c"
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_string_free0 (dst);
		_g_mapped_file_free0 (src);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
#line 317 "icon.vala"
	pos = g_mapped_file_get_contents (src);
#line 318 "icon.vala"
	end = g_mapped_file_get_contents (src) + g_mapped_file_get_length (src);
#line 1105 "icon.c"
	_tmp2_ = NULL;
#line 320 "icon.vala"
	if ((*attr).fill_color.alpha > 0.0) {
#line 1109 "icon.c"
		char* _tmp3_;
#line 321 "icon.vala"
		_tmp2_ = (_tmp3_ = sugar_color_get_html (&(*attr).fill_color), _g_free0 (_tmp2_), _tmp3_);
#line 1113 "icon.c"
	} else {
		char* _tmp4_;
#line 321 "icon.vala"
		_tmp2_ = (_tmp4_ = NULL, _g_free0 (_tmp2_), _tmp4_);
#line 1118 "icon.c"
	}
#line 320 "icon.vala"
	fill = g_strdup (_tmp2_);
#line 1122 "icon.c"
	_tmp5_ = NULL;
#line 322 "icon.vala"
	if ((*attr).stroke_color.alpha > 0.0) {
#line 1126 "icon.c"
		char* _tmp6_;
#line 323 "icon.vala"
		_tmp5_ = (_tmp6_ = sugar_color_get_html (&(*attr).stroke_color), _g_free0 (_tmp5_), _tmp6_);
#line 1130 "icon.c"
	} else {
		char* _tmp7_;
#line 323 "icon.vala"
		_tmp5_ = (_tmp7_ = NULL, _g_free0 (_tmp5_), _tmp7_);
#line 1135 "icon.c"
	}
#line 322 "icon.vala"
	stroke = g_strdup (_tmp5_);
#line 325 "icon.vala"
	if (fill != NULL) {
#line 325 "icon.vala"
		_tmp8_ = TRUE;
#line 1143 "icon.c"
	} else {
#line 325 "icon.vala"
		_tmp8_ = stroke != NULL;
#line 1147 "icon.c"
	}
#line 325 "icon.vala"
	if (_tmp8_) {
#line 1151 "icon.c"
		{
			gchar* i;
#line 326 "icon.vala"
			i = pos;
#line 1156 "icon.c"
			{
				gboolean _tmp9_;
#line 326 "icon.vala"
				_tmp9_ = TRUE;
#line 326 "icon.vala"
				while (TRUE) {
#line 1163 "icon.c"
					const char* color;
					gboolean _tmp10_ = FALSE;
#line 326 "icon.vala"
					if (!_tmp9_) {
#line 326 "icon.vala"
						i++;
#line 1170 "icon.c"
					}
#line 326 "icon.vala"
					_tmp9_ = FALSE;
#line 326 "icon.vala"
					if (!(i < end)) {
#line 326 "icon.vala"
						break;
#line 1178 "icon.c"
					}
#line 327 "icon.vala"
					if (g_str_has_prefix (sugar_to_string (i), "<svg")) {
#line 328 "icon.vala"
						break;
#line 1184 "icon.c"
					}
#line 330 "icon.vala"
					color = NULL;
#line 332 "icon.vala"
					if (fill != NULL) {
#line 332 "icon.vala"
						_tmp10_ = g_str_has_prefix (sugar_to_string (i), SUGAR__FILL_TAG);
#line 1192 "icon.c"
					} else {
#line 332 "icon.vala"
						_tmp10_ = FALSE;
#line 1196 "icon.c"
					}
#line 332 "icon.vala"
					if (_tmp10_) {
#line 333 "icon.vala"
						color = fill;
#line 334 "icon.vala"
						i = i + string_get_length (SUGAR__FILL_TAG);
#line 1204 "icon.c"
					} else {
						gboolean _tmp11_ = FALSE;
#line 335 "icon.vala"
						if (stroke != NULL) {
#line 336 "icon.vala"
							_tmp11_ = g_str_has_prefix (sugar_to_string (i), SUGAR__STROKE_TAG);
#line 1211 "icon.c"
						} else {
#line 335 "icon.vala"
							_tmp11_ = FALSE;
#line 1215 "icon.c"
						}
#line 335 "icon.vala"
						if (_tmp11_) {
#line 337 "icon.vala"
							color = stroke;
#line 338 "icon.vala"
							i = i + string_get_length (SUGAR__STROKE_TAG);
#line 1223 "icon.c"
						}
					}
#line 341 "icon.vala"
					if (color != NULL) {
#line 342 "icon.vala"
						if (dst == NULL) {
#line 1230 "icon.c"
							gsize _tmp12_ = 0UL;
							gsize _tmp13_ = 0UL;
							GString* _tmp14_;
#line 344 "icon.vala"
							if (fill == NULL) {
#line 344 "icon.vala"
								_tmp12_ = (gsize) 0;
#line 1238 "icon.c"
							} else {
#line 344 "icon.vala"
								_tmp12_ = strlen (fill);
#line 1242 "icon.c"
							}
#line 345 "icon.vala"
							if (stroke == NULL) {
#line 345 "icon.vala"
								_tmp13_ = (gsize) 0;
#line 1248 "icon.c"
							} else {
#line 345 "icon.vala"
								_tmp13_ = strlen (stroke);
#line 1252 "icon.c"
							}
#line 343 "icon.vala"
							dst = (_tmp14_ = g_string_sized_new ((g_mapped_file_get_length (src) + _tmp12_) + _tmp13_), _g_string_free0 (dst), _tmp14_);
#line 1256 "icon.c"
						}
#line 347 "icon.vala"
						g_string_append_len (dst, sugar_to_string (pos), (gssize) (i - pos));
#line 348 "icon.vala"
						g_string_append (dst, color);
#line 350 "icon.vala"
						i = pos = strstr (sugar_to_string (i), "\"");
#line 351 "icon.vala"
						if (pos == NULL) {
#line 352 "icon.vala"
							g_warning ("icon.vala:352: Wron svg file, cannot find second quotes");
#line 1268 "icon.c"
							result = NULL;
							_g_free0 (stroke);
							_g_free0 (_tmp5_);
							_g_free0 (fill);
							_g_free0 (_tmp2_);
							_g_string_free0 (dst);
							_g_mapped_file_free0 (src);
#line 353 "icon.vala"
							return result;
#line 1278 "icon.c"
						}
					}
				}
			}
		}
	}
	data = (data_length1 = 0, NULL);
#line 361 "icon.vala"
	if (pos == g_mapped_file_get_contents (src)) {
#line 1288 "icon.c"
		gint _tmp15_;
		guchar* _tmp16_;
#line 362 "icon.vala"
		data = (_tmp16_ = sugar_to_uchars (g_mapped_file_get_contents (src), &_tmp15_), data_length1 = _tmp15_, _data_size_ = data_length1, _tmp16_);
#line 363 "icon.vala"
		data_len = g_mapped_file_get_length (src);
#line 1295 "icon.c"
	} else {
		guchar* _tmp17_;
#line 365 "icon.vala"
		g_string_append (dst, sugar_to_string (pos));
#line 366 "icon.vala"
		data = (_tmp17_ = (guchar*) dst->str, data_length1 = -1, _data_size_ = data_length1, _tmp17_);
#line 367 "icon.vala"
		data_len = (gsize) dst->len;
#line 1304 "icon.c"
	}
	{
		RsvgHandle* _tmp18_;
#line 371 "icon.vala"
		_tmp18_ = rsvg_handle_new_from_data (data, data_len, &_inner_error_);
#line 1310 "icon.c"
		if (_inner_error_ != NULL) {
			goto __catch2_g_error;
		}
		result = _tmp18_;
		_g_free0 (stroke);
		_g_free0 (_tmp5_);
		_g_free0 (fill);
		_g_free0 (_tmp2_);
		_g_string_free0 (dst);
		_g_mapped_file_free0 (src);
#line 371 "icon.vala"
		return result;
#line 1323 "icon.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 373 "icon.vala"
			g_warning ("icon.vala:373: Cannot parse '%s' svg: %s", (*attr).file_name, e->message);
#line 1334 "icon.c"
			result = NULL;
			_g_error_free0 (e);
			_g_free0 (stroke);
			_g_free0 (_tmp5_);
			_g_free0 (fill);
			_g_free0 (_tmp2_);
			_g_string_free0 (dst);
			_g_mapped_file_free0 (src);
#line 374 "icon.vala"
			return result;
#line 1345 "icon.c"
		}
	}
	__finally2:
	{
		_g_free0 (stroke);
		_g_free0 (_tmp5_);
		_g_free0 (fill);
		_g_free0 (_tmp2_);
		_g_string_free0 (dst);
		_g_mapped_file_free0 (src);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_free0 (stroke);
	_g_free0 (_tmp5_);
	_g_free0 (fill);
	_g_free0 (_tmp2_);
	_g_string_free0 (dst);
	_g_mapped_file_free0 (src);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




