/* palette.c generated by valac 0.10.1, the Vala compiler
 * generated from palette.vala, do not modify */

/* palette.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Port from original sugar-toolkit project.
 * File:   src/sugar/graphics/palette.py
 * Commit: 927c576e318a3aebd3217b35e1d4cf73582f0e4f
 *
 * Copyright (C) 2007, Eduardo Silva <edsiper@gmail.com>
 * Copyright (C) 2008, One Laptop Per Child
 * Copyright (C) 2009, Tomeu Vizoso
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/gui.h"
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <polyol/env.h>
#include <gdk/gdk.h>
#include <pango/pango.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SugarPalettePrivate {
	char* _primary_text;
	char* _secondary_text;
	SugarIcon* _icon;
	gboolean _icon_visible;
	GtkEventBox* _icon_box;
	GtkAlignment* _label_alignment;
	GtkAccelLabel* _label;
	GtkLabel* _secondary_label;
	GtkVBox* _secondary_box;
	SugarBin* _secondary;
	SugarTrigger* _menu_trigger;
};


static gpointer sugar_palette_parent_class = NULL;
static SugarMenuContainerIface* sugar_palette_sugar_menu_container_parent_iface = NULL;

#define SUGAR_PALETTE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_PALETTE, SugarPalettePrivate))
enum  {
	SUGAR_PALETTE_DUMMY_PROPERTY,
	SUGAR_PALETTE_MENU_TRIGGER,
	SUGAR_PALETTE_PRIMARY_TEXT,
	SUGAR_PALETTE_SECONDARY_TEXT,
	SUGAR_PALETTE_TEXT_MAXLEN,
	SUGAR_PALETTE_ICON,
	SUGAR_PALETTE_ICON_VISIBLE,
	SUGAR_PALETTE_SECONDARY,
	SUGAR_PALETTE_SECONDARY_VISIBLE
};
static void sugar_palette_real_size_request (GtkWidget* base, GtkRequisition* requisition);
static void sugar_palette_real_realize (GtkWidget* base);
static void _sugar_palette_update_accept_focus (SugarPalette* self);
static void sugar_palette_real_style_set (GtkWidget* base, GtkStyle* previous_style);
static void sugar_palette_real_show (GtkWidget* base);
static void _sugar_palette_show_icon (SugarPalette* self);
static void _sugar_palette_hide_icon (SugarPalette* self);
static gboolean _sugar_palette_icon_button_release_event_cb (SugarPalette* self, GdkEventButton* event);
static void _sugar_palette_menu_trigger_activate_cb (SugarPalette* self, GtkWidget* initiator);
static void __sugar_palette_menu_trigger_activate_cb_sugar_trigger_activate (SugarTrigger* _sender, GtkWidget* initiator, gpointer self);
static gboolean __sugar_palette_icon_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static GObject * sugar_palette_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void sugar_palette_finalize (GObject* obj);
static void sugar_palette_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sugar_palette_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 213 "palette.vala"
static void sugar_palette_real_size_request (GtkWidget* base, GtkRequisition* requisition) {
#line 110 "palette.c"
	SugarPalette * self;
	GtkRequisition label_requisition = {0};
	gint label_width;
	self = (SugarPalette*) base;
#line 214 "palette.vala"
	GTK_WIDGET_CLASS (sugar_palette_parent_class)->size_request ((GtkWidget*) SUGAR_PALETTE_WINDOW (self), requisition);
#line 218 "palette.vala"
	gtk_widget_size_request ((GtkWidget*) self->priv->_label_alignment, &label_requisition);
#line 219 "palette.vala"
	label_width = (label_requisition.width + ((gint) gtk_accel_label_get_accel_width (self->priv->_label))) + (((gint) gtk_container_get_border_width ((GtkContainer*) self)) * 2);
#line 222 "palette.vala"
	(*requisition).width = MAX ((*requisition).width, label_width);
#line 123 "palette.c"
}


#line 225 "palette.vala"
static void sugar_palette_real_realize (GtkWidget* base) {
#line 129 "palette.c"
	SugarPalette * self;
	self = (SugarPalette*) base;
#line 226 "palette.vala"
	GTK_WIDGET_CLASS (sugar_palette_parent_class)->realize ((GtkWidget*) SUGAR_PALETTE_WINDOW (self));
#line 227 "palette.vala"
	_sugar_palette_update_accept_focus (self);
#line 136 "palette.c"
}


#line 230 "palette.vala"
static void sugar_palette_real_style_set (GtkWidget* base, GtkStyle* previous_style) {
#line 142 "palette.c"
	SugarPalette * self;
	self = (SugarPalette*) base;
#line 231 "palette.vala"
	GTK_WIDGET_CLASS (sugar_palette_parent_class)->style_set ((GtkWidget*) SUGAR_PALETTE_WINDOW (self), previous_style);
#line 232 "palette.vala"
	gtk_container_set_border_width ((GtkContainer*) self, (guint) gtk_widget_get_style ((GtkWidget*) self)->xthickness);
#line 149 "palette.c"
}


#line 235 "palette.vala"
static void sugar_palette_real_show (GtkWidget* base) {
#line 155 "palette.c"
	SugarPalette * self;
	GObject* _tmp0_;
	self = (SugarPalette*) base;
#line 236 "palette.vala"
	gtk_accel_label_set_accel_widget (self->priv->_label, (_tmp0_ = sugar_connector_get_subject (sugar_palette_window_get_connector ((SugarPaletteWindow*) self)), GTK_IS_WIDGET (_tmp0_) ? ((GtkWidget*) _tmp0_) : NULL));
#line 237 "palette.vala"
	GTK_WIDGET_CLASS (sugar_palette_parent_class)->show ((GtkWidget*) SUGAR_PALETTE_WINDOW (self));
#line 163 "palette.c"
}


#line 240 "palette.vala"
static void _sugar_palette_show_icon (SugarPalette* self) {
#line 240 "palette.vala"
	g_return_if_fail (self != NULL);
#line 241 "palette.vala"
	gtk_alignment_set_padding (self->priv->_label_alignment, (guint) 0, (guint) 0, (guint) 0, (guint) sugar_metrics_get (SUGAR_DEFAULT_SPACING));
#line 243 "palette.vala"
	gtk_widget_show ((GtkWidget*) gtk_widget_get_parent ((GtkWidget*) self->priv->_icon_box));
#line 175 "palette.c"
}


#line 246 "palette.vala"
static void _sugar_palette_hide_icon (SugarPalette* self) {
#line 246 "palette.vala"
	g_return_if_fail (self != NULL);
#line 247 "palette.vala"
	gtk_widget_hide ((GtkWidget*) gtk_widget_get_parent ((GtkWidget*) self->priv->_icon_box));
#line 248 "palette.vala"
	gtk_alignment_set_padding (self->priv->_label_alignment, (guint) 0, (guint) 0, (guint) sugar_metrics_get (SUGAR_DEFAULT_SPACING), (guint) sugar_metrics_get (SUGAR_DEFAULT_SPACING));
#line 187 "palette.c"
}


#line 253 "palette.vala"
static void _sugar_palette_update_accept_focus (SugarPalette* self) {
#line 253 "palette.vala"
	g_return_if_fail (self != NULL);
#line 254 "palette.vala"
	if (GTK_WIDGET_REALIZED ((GtkWidget*) self)) {
#line 255 "palette.vala"
		gdk_window_set_accept_focus (((GtkWidget*) self)->window, sugar_palette_window_get_secondary ((SugarPaletteWindow*) self) != NULL);
#line 199 "palette.c"
	}
}


#line 258 "palette.vala"
static gboolean _sugar_palette_icon_button_release_event_cb (SugarPalette* self, GdkEventButton* event) {
#line 206 "palette.c"
	gboolean result = FALSE;
#line 258 "palette.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 259 "palette.vala"
	gtk_widget_activate ((GtkWidget*) self);
#line 212 "palette.c"
	result = FALSE;
#line 260 "palette.vala"
	return result;
#line 216 "palette.c"
}


#line 263 "palette.vala"
static void _sugar_palette_menu_trigger_activate_cb (SugarPalette* self, GtkWidget* initiator) {
#line 263 "palette.vala"
	g_return_if_fail (self != NULL);
#line 263 "palette.vala"
	g_return_if_fail (initiator != NULL);
#line 264 "palette.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 265 "palette.vala"
	g_signal_emit_by_name (self, "activate-menu", initiator);
#line 230 "palette.c"
}


#line 44 "palette.vala"
SugarPalette* sugar_palette_construct (GType object_type) {
#line 236 "palette.c"
	SugarPalette * self = NULL;
#line 44 "palette.vala"
	self = (SugarPalette*) sugar_palette_window_construct (object_type);
#line 240 "palette.c"
	return self;
}


#line 44 "palette.vala"
SugarPalette* sugar_palette_new (void) {
#line 44 "palette.vala"
	return sugar_palette_construct (SUGAR_TYPE_PALETTE);
#line 249 "palette.c"
}


static SugarTrigger* sugar_palette_real_get_menu_trigger (SugarMenuContainer* base) {
	SugarTrigger* result;
	SugarPalette* self;
	self = (SugarPalette*) base;
	result = self->priv->_menu_trigger;
#line 48 "palette.vala"
	return result;
#line 260 "palette.c"
}


const char* sugar_palette_get_primary_text (SugarPalette* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_primary_text;
#line 53 "palette.vala"
	return result;
#line 270 "palette.c"
}


#line 1208 "glib-2.0.vapi"
static const char* string_to_string (const char* self) {
#line 276 "palette.c"
	const char* result = NULL;
#line 1208 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 280 "palette.c"
	result = self;
#line 1209 "glib-2.0.vapi"
	return result;
#line 284 "palette.c"
}


void sugar_palette_set_primary_text (SugarPalette* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
#line 56 "palette.vala"
	self->priv->_primary_text = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_primary_text), _tmp0_);
#line 58 "palette.vala"
	if (value != NULL) {
#line 295 "palette.c"
		char* _tmp1_;
#line 59 "palette.vala"
		gtk_label_set_markup ((GtkLabel*) self->priv->_label, _tmp1_ = g_strconcat ("<b>", string_to_string (value), "</b>", NULL));
#line 299 "palette.c"
		_g_free0 (_tmp1_);
#line 60 "palette.vala"
		gtk_widget_show ((GtkWidget*) self->priv->_label);
#line 303 "palette.c"
	}
	g_object_notify ((GObject *) self, "primary-text");
}


const char* sugar_palette_get_secondary_text (SugarPalette* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_secondary_text;
#line 67 "palette.vala"
	return result;
#line 315 "palette.c"
}


#line 1055 "glib-2.0.vapi"
static char* string_delimit (const char* self, const char* delimiters, gchar new_delimiter) {
#line 321 "palette.c"
	char* result = NULL;
	char* _result_;
#line 1055 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1055 "glib-2.0.vapi"
	g_return_val_if_fail (delimiters != NULL, NULL);
#line 1056 "glib-2.0.vapi"
	_result_ = g_strdup (self);
#line 1057 "glib-2.0.vapi"
	g_strdelimit (_result_, delimiters, new_delimiter);
#line 332 "palette.c"
	result = _result_;
#line 1058 "glib-2.0.vapi"
	return result;
#line 336 "palette.c"
}


void sugar_palette_set_secondary_text (SugarPalette* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
#line 70 "palette.vala"
	self->priv->_secondary_text = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_secondary_text), _tmp0_);
#line 72 "palette.vala"
	if (sugar_palette_get_secondary_text (self) == NULL) {
#line 73 "palette.vala"
		gtk_widget_hide ((GtkWidget*) self->priv->_secondary_label);
#line 349 "palette.c"
	} else {
		char* _tmp1_;
#line 75 "palette.vala"
		gtk_label_set_text (self->priv->_secondary_label, _tmp1_ = string_delimit (sugar_palette_get_secondary_text (self), "\n", '\0'));
#line 354 "palette.c"
		_g_free0 (_tmp1_);
#line 76 "palette.vala"
		gtk_widget_show ((GtkWidget*) self->priv->_secondary_label);
#line 358 "palette.c"
	}
	g_object_notify ((GObject *) self, "secondary-text");
}


void sugar_palette_set_text_maxlen (SugarPalette* self, gint value) {
	g_return_if_fail (self != NULL);
#line 83 "palette.vala"
	gtk_label_set_max_width_chars ((GtkLabel*) self->priv->_label, value);
#line 84 "palette.vala"
	gtk_label_set_max_width_chars (self->priv->_secondary_label, value);
#line 370 "palette.c"
	g_object_notify ((GObject *) self, "text-maxlen");
}


SugarIcon* sugar_palette_get_icon (SugarPalette* self) {
	SugarIcon* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_icon;
#line 90 "palette.vala"
	return result;
#line 381 "palette.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void sugar_palette_set_icon (SugarPalette* self, SugarIcon* value) {
	SugarIcon* _tmp0_;
	g_return_if_fail (self != NULL);
#line 93 "palette.vala"
	if (sugar_palette_get_icon (self) != NULL) {
#line 94 "palette.vala"
		gtk_container_remove ((GtkContainer*) self->priv->_icon_box, (GtkWidget*) sugar_palette_get_icon (self));
#line 397 "palette.c"
	}
#line 96 "palette.vala"
	self->priv->_icon = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_icon), _tmp0_);
#line 98 "palette.vala"
	if (sugar_palette_get_icon (self) == NULL) {
#line 99 "palette.vala"
		_sugar_palette_hide_icon (self);
#line 405 "palette.c"
	} else {
#line 101 "palette.vala"
		sugar_icon_set_icon_size (sugar_palette_get_icon (self), GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 102 "palette.vala"
		gtk_container_add ((GtkContainer*) self->priv->_icon_box, (GtkWidget*) sugar_palette_get_icon (self));
#line 103 "palette.vala"
		gtk_widget_show ((GtkWidget*) sugar_palette_get_icon (self));
#line 104 "palette.vala"
		_sugar_palette_show_icon (self);
#line 415 "palette.c"
	}
	g_object_notify ((GObject *) self, "icon");
}


gboolean sugar_palette_get_icon_visible (SugarPalette* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_icon_visible;
#line 111 "palette.vala"
	return result;
#line 427 "palette.c"
}


void sugar_palette_set_icon_visible (SugarPalette* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
#line 114 "palette.vala"
	self->priv->_icon_visible = value;
#line 116 "palette.vala"
	if (sugar_palette_get_icon (self) != NULL) {
#line 116 "palette.vala"
		_tmp0_ = sugar_palette_get_icon_visible (self);
#line 440 "palette.c"
	} else {
#line 116 "palette.vala"
		_tmp0_ = FALSE;
#line 444 "palette.c"
	}
#line 116 "palette.vala"
	if (_tmp0_) {
#line 117 "palette.vala"
		_sugar_palette_show_icon (self);
#line 450 "palette.c"
	} else {
#line 119 "palette.vala"
		_sugar_palette_hide_icon (self);
#line 454 "palette.c"
	}
	g_object_notify ((GObject *) self, "icon-visible");
}


static GtkWidget* sugar_palette_real_get_secondary (SugarPaletteWindow* base) {
	GtkWidget* result;
	SugarPalette* self;
	self = (SugarPalette*) base;
	result = sugar_bin_get_child (self->priv->_secondary);
#line 125 "palette.vala"
	return result;
#line 467 "palette.c"
}


static void sugar_palette_real_set_secondary (SugarPaletteWindow* base, GtkWidget* value) {
	SugarPalette* self;
	self = (SugarPalette*) base;
#line 128 "palette.vala"
	if (value == sugar_palette_window_get_secondary ((SugarPaletteWindow*) self)) {
#line 129 "palette.vala"
		return;
#line 478 "palette.c"
	}
#line 131 "palette.vala"
	if (sugar_palette_window_get_secondary ((SugarPaletteWindow*) self) != NULL) {
#line 132 "palette.vala"
		gtk_container_remove ((GtkContainer*) self->priv->_secondary, sugar_palette_window_get_secondary ((SugarPaletteWindow*) self));
#line 484 "palette.c"
	}
#line 134 "palette.vala"
	if (value == NULL) {
#line 135 "palette.vala"
		sugar_palette_window_set_secondary_visible ((SugarPaletteWindow*) self, FALSE);
#line 490 "palette.c"
	} else {
#line 137 "palette.vala"
		gtk_widget_show (value);
#line 138 "palette.vala"
		gtk_container_add ((GtkContainer*) self->priv->_secondary, value);
#line 496 "palette.c"
	}
#line 141 "palette.vala"
	_sugar_palette_update_accept_focus (self);
#line 500 "palette.c"
	g_object_notify ((GObject *) self, "secondary");
}


static gboolean sugar_palette_real_get_secondary_visible (SugarPaletteWindow* base) {
	gboolean result;
	SugarPalette* self;
	self = (SugarPalette*) base;
	result = gtk_widget_get_visible ((GtkWidget*) self->priv->_secondary_box);
#line 146 "palette.vala"
	return result;
#line 512 "palette.c"
}


static void sugar_palette_real_set_secondary_visible (SugarPaletteWindow* base, gboolean value) {
	SugarPalette* self;
	self = (SugarPalette*) base;
#line 147 "palette.vala"
	gtk_widget_set_visible ((GtkWidget*) self->priv->_secondary_box, value);
#line 521 "palette.c"
	g_object_notify ((GObject *) self, "secondary-visible");
}


#line 263 "palette.vala"
static void __sugar_palette_menu_trigger_activate_cb_sugar_trigger_activate (SugarTrigger* _sender, GtkWidget* initiator, gpointer self) {
#line 528 "palette.c"
	_sugar_palette_menu_trigger_activate_cb (self, initiator);
}


#line 258 "palette.vala"
static gboolean __sugar_palette_icon_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
#line 535 "palette.c"
	gboolean result;
	result = _sugar_palette_icon_button_release_event_cb (self, event);
	return result;
}


static GObject * sugar_palette_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SugarPalette * self;
	parent_class = G_OBJECT_CLASS (sugar_palette_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = SUGAR_PALETTE (obj);
	{
		GtkVBox* palette_box;
		SugarTrigger* _tmp0_;
		GtkHBox* primary_box;
		GtkHBox* icon_box;
		GtkEventBox* _tmp1_;
		GtkVBox* labels_box;
		GtkAlignment* _tmp2_;
		GtkAccelLabel* _tmp3_;
		GtkLabel* _tmp4_;
		GtkVBox* _tmp5_;
		GtkHSeparator* separator;
		SugarBin* _tmp6_;
#line 151 "palette.vala"
		palette_box = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0));
#line 152 "palette.vala"
		gtk_widget_show ((GtkWidget*) palette_box);
#line 153 "palette.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) palette_box);
#line 155 "palette.vala"
		self->priv->_menu_trigger = (_tmp0_ = sugar_trigger_new (), _g_object_unref0 (self->priv->_menu_trigger), _tmp0_);
#line 156 "palette.vala"
		g_signal_connect_object (self->priv->_menu_trigger, "activate", (GCallback) __sugar_palette_menu_trigger_activate_cb_sugar_trigger_activate, self, 0);
#line 160 "palette.vala"
		primary_box = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 0));
#line 161 "palette.vala"
		gtk_widget_set_size_request ((GtkWidget*) primary_box, -1, sugar_metrics_get (SUGAR_GRID_CELL_SIZE) - (((gint) gtk_container_get_border_width ((GtkContainer*) self)) * 2));
#line 163 "palette.vala"
		gtk_widget_show ((GtkWidget*) primary_box);
#line 164 "palette.vala"
		gtk_box_pack_start ((GtkBox*) palette_box, (GtkWidget*) primary_box, FALSE, TRUE, (guint) 0);
#line 166 "palette.vala"
		icon_box = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 0));
#line 167 "palette.vala"
		gtk_widget_set_size_request ((GtkWidget*) icon_box, sugar_metrics_get (SUGAR_GRID_CELL_SIZE), -1);
#line 168 "palette.vala"
		gtk_box_pack_start ((GtkBox*) primary_box, (GtkWidget*) icon_box, FALSE, TRUE, (guint) 0);
#line 170 "palette.vala"
		self->priv->_icon_box = (_tmp1_ = g_object_ref_sink ((GtkEventBox*) gtk_event_box_new ()), _g_object_unref0 (self->priv->_icon_box), _tmp1_);
#line 171 "palette.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->_icon_box, "button-release-event", (GCallback) __sugar_palette_icon_button_release_event_cb_gtk_widget_button_release_event, self, 0);
#line 172 "palette.vala"
		gtk_widget_show ((GtkWidget*) self->priv->_icon_box);
#line 173 "palette.vala"
		gtk_box_pack_start ((GtkBox*) icon_box, (GtkWidget*) self->priv->_icon_box, TRUE, TRUE, (guint) 0);
#line 175 "palette.vala"
		labels_box = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0));
#line 176 "palette.vala"
		gtk_widget_show ((GtkWidget*) labels_box);
#line 177 "palette.vala"
		self->priv->_label_alignment = (_tmp2_ = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new (0.0f, 0.5f, 1.0f, 0.33f)), _g_object_unref0 (self->priv->_label_alignment), _tmp2_);
#line 178 "palette.vala"
		gtk_alignment_set_padding (self->priv->_label_alignment, (guint) 0, (guint) 0, (guint) sugar_metrics_get (SUGAR_DEFAULT_SPACING), (guint) sugar_metrics_get (SUGAR_DEFAULT_SPACING));
#line 181 "palette.vala"
		gtk_container_add ((GtkContainer*) self->priv->_label_alignment, (GtkWidget*) labels_box);
#line 182 "palette.vala"
		gtk_widget_show ((GtkWidget*) self->priv->_label_alignment);
#line 183 "palette.vala"
		gtk_box_pack_start ((GtkBox*) primary_box, (GtkWidget*) self->priv->_label_alignment, TRUE, TRUE, (guint) 0);
#line 185 "palette.vala"
		self->priv->_label = (_tmp3_ = g_object_ref_sink ((GtkAccelLabel*) gtk_accel_label_new ("")), _g_object_unref0 (self->priv->_label), _tmp3_);
#line 186 "palette.vala"
		gtk_misc_set_alignment ((GtkMisc*) self->priv->_label, 0.0f, 0.5f);
#line 187 "palette.vala"
		gtk_label_set_ellipsize ((GtkLabel*) self->priv->_label, PANGO_ELLIPSIZE_MIDDLE);
#line 188 "palette.vala"
		gtk_box_pack_start ((GtkBox*) labels_box, (GtkWidget*) self->priv->_label, TRUE, TRUE, (guint) 0);
#line 190 "palette.vala"
		self->priv->_secondary_label = (_tmp4_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (NULL)), _g_object_unref0 (self->priv->_secondary_label), _tmp4_);
#line 191 "palette.vala"
		gtk_misc_set_alignment ((GtkMisc*) self->priv->_secondary_label, 0.0f, 0.5f);
#line 192 "palette.vala"
		gtk_label_set_ellipsize (self->priv->_secondary_label, PANGO_ELLIPSIZE_END);
#line 193 "palette.vala"
		gtk_box_pack_start ((GtkBox*) labels_box, (GtkWidget*) self->priv->_secondary_label, TRUE, TRUE, (guint) 0);
#line 195 "palette.vala"
		sugar_palette_set_text_maxlen (self, 60);
#line 199 "palette.vala"
		self->priv->_secondary_box = (_tmp5_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0)), _g_object_unref0 (self->priv->_secondary_box), _tmp5_);
#line 200 "palette.vala"
		gtk_box_pack_start ((GtkBox*) palette_box, (GtkWidget*) self->priv->_secondary_box, TRUE, TRUE, (guint) 0);
#line 202 "palette.vala"
		separator = g_object_ref_sink ((GtkHSeparator*) gtk_hseparator_new ());
#line 203 "palette.vala"
		gtk_widget_show ((GtkWidget*) separator);
#line 204 "palette.vala"
		gtk_box_pack_start ((GtkBox*) self->priv->_secondary_box, (GtkWidget*) separator, TRUE, TRUE, (guint) 0);
#line 206 "palette.vala"
		self->priv->_secondary = (_tmp6_ = g_object_ref_sink (sugar_bin_new ()), _g_object_unref0 (self->priv->_secondary), _tmp6_);
#line 207 "palette.vala"
		sugar_container_set_border_top ((SugarContainer*) self->priv->_secondary, sugar_metrics_get (SUGAR_DEFAULT_SPACING));
#line 208 "palette.vala"
		sugar_container_set_border_bottom ((SugarContainer*) self->priv->_secondary, sugar_metrics_get (SUGAR_DEFAULT_SPACING));
#line 209 "palette.vala"
		gtk_widget_show ((GtkWidget*) self->priv->_secondary);
#line 210 "palette.vala"
		gtk_box_pack_start ((GtkBox*) self->priv->_secondary_box, (GtkWidget*) self->priv->_secondary, TRUE, TRUE, (guint) 0);
#line 646 "palette.c"
		_g_object_unref0 (separator);
		_g_object_unref0 (labels_box);
		_g_object_unref0 (icon_box);
		_g_object_unref0 (primary_box);
		_g_object_unref0 (palette_box);
	}
	return obj;
}


static void sugar_palette_class_init (SugarPaletteClass * klass) {
	sugar_palette_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarPalettePrivate));
	GTK_WIDGET_CLASS (klass)->size_request = sugar_palette_real_size_request;
	GTK_WIDGET_CLASS (klass)->realize = sugar_palette_real_realize;
	GTK_WIDGET_CLASS (klass)->style_set = sugar_palette_real_style_set;
	GTK_WIDGET_CLASS (klass)->show = sugar_palette_real_show;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->get_secondary = sugar_palette_real_get_secondary;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->set_secondary = sugar_palette_real_set_secondary;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->get_secondary_visible = sugar_palette_real_get_secondary_visible;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->set_secondary_visible = sugar_palette_real_set_secondary_visible;
	G_OBJECT_CLASS (klass)->get_property = sugar_palette_get_property;
	G_OBJECT_CLASS (klass)->set_property = sugar_palette_set_property;
	G_OBJECT_CLASS (klass)->constructor = sugar_palette_constructor;
	G_OBJECT_CLASS (klass)->finalize = sugar_palette_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_MENU_TRIGGER, "menu-trigger");
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_PRIMARY_TEXT, g_param_spec_string ("primary-text", "primary-text", "primary-text", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_SECONDARY_TEXT, g_param_spec_string ("secondary-text", "secondary-text", "secondary-text", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_TEXT_MAXLEN, g_param_spec_int ("text-maxlen", "text-maxlen", "text-maxlen", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_ICON, g_param_spec_object ("icon", "icon", "icon", SUGAR_TYPE_ICON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_ICON_VISIBLE, g_param_spec_boolean ("icon-visible", "icon-visible", "icon-visible", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_override_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_SECONDARY, "secondary");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_SECONDARY_VISIBLE, "secondary-visible");
	g_signal_new ("activate_menu", SUGAR_TYPE_PALETTE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GTK_TYPE_WIDGET);
}


static void sugar_palette_sugar_menu_container_interface_init (SugarMenuContainerIface * iface) {
	sugar_palette_sugar_menu_container_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_menu_trigger = sugar_palette_real_get_menu_trigger;
}


static void sugar_palette_instance_init (SugarPalette * self) {
	self->priv = SUGAR_PALETTE_GET_PRIVATE (self);
	self->priv->_icon_visible = TRUE;
}


static void sugar_palette_finalize (GObject* obj) {
	SugarPalette * self;
	self = SUGAR_PALETTE (obj);
	_g_free0 (self->priv->_primary_text);
	_g_free0 (self->priv->_secondary_text);
	_g_object_unref0 (self->priv->_icon);
	_g_object_unref0 (self->priv->_icon_box);
	_g_object_unref0 (self->priv->_label_alignment);
	_g_object_unref0 (self->priv->_label);
	_g_object_unref0 (self->priv->_secondary_label);
	_g_object_unref0 (self->priv->_secondary_box);
	_g_object_unref0 (self->priv->_secondary);
	_g_object_unref0 (self->priv->_menu_trigger);
	G_OBJECT_CLASS (sugar_palette_parent_class)->finalize (obj);
}


GType sugar_palette_get_type (void) {
	static volatile gsize sugar_palette_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_palette_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarPaletteClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_palette_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarPalette), 0, (GInstanceInitFunc) sugar_palette_instance_init, NULL };
		static const GInterfaceInfo sugar_menu_container_info = { (GInterfaceInitFunc) sugar_palette_sugar_menu_container_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType sugar_palette_type_id;
		sugar_palette_type_id = g_type_register_static (SUGAR_TYPE_PALETTE_WINDOW, "SugarPalette", &g_define_type_info, 0);
		g_type_add_interface_static (sugar_palette_type_id, SUGAR_TYPE_MENU_CONTAINER, &sugar_menu_container_info);
		g_once_init_leave (&sugar_palette_type_id__volatile, sugar_palette_type_id);
	}
	return sugar_palette_type_id__volatile;
}


static void sugar_palette_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarPalette * self;
	self = SUGAR_PALETTE (object);
	switch (property_id) {
		case SUGAR_PALETTE_MENU_TRIGGER:
		g_value_set_object (value, sugar_menu_container_get_menu_trigger ((SugarMenuContainer*) self));
		break;
		case SUGAR_PALETTE_PRIMARY_TEXT:
		g_value_set_string (value, sugar_palette_get_primary_text (self));
		break;
		case SUGAR_PALETTE_SECONDARY_TEXT:
		g_value_set_string (value, sugar_palette_get_secondary_text (self));
		break;
		case SUGAR_PALETTE_ICON:
		g_value_set_object (value, sugar_palette_get_icon (self));
		break;
		case SUGAR_PALETTE_ICON_VISIBLE:
		g_value_set_boolean (value, sugar_palette_get_icon_visible (self));
		break;
		case SUGAR_PALETTE_SECONDARY:
		g_value_set_object (value, sugar_palette_window_get_secondary ((SugarPaletteWindow*) self));
		break;
		case SUGAR_PALETTE_SECONDARY_VISIBLE:
		g_value_set_boolean (value, sugar_palette_window_get_secondary_visible ((SugarPaletteWindow*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sugar_palette_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarPalette * self;
	self = SUGAR_PALETTE (object);
	switch (property_id) {
		case SUGAR_PALETTE_PRIMARY_TEXT:
		sugar_palette_set_primary_text (self, g_value_get_string (value));
		break;
		case SUGAR_PALETTE_SECONDARY_TEXT:
		sugar_palette_set_secondary_text (self, g_value_get_string (value));
		break;
		case SUGAR_PALETTE_TEXT_MAXLEN:
		sugar_palette_set_text_maxlen (self, g_value_get_int (value));
		break;
		case SUGAR_PALETTE_ICON:
		sugar_palette_set_icon (self, g_value_get_object (value));
		break;
		case SUGAR_PALETTE_ICON_VISIBLE:
		sugar_palette_set_icon_visible (self, g_value_get_boolean (value));
		break;
		case SUGAR_PALETTE_SECONDARY:
		sugar_palette_window_set_secondary ((SugarPaletteWindow*) self, g_value_get_object (value));
		break;
		case SUGAR_PALETTE_SECONDARY_VISIBLE:
		sugar_palette_window_set_secondary_visible ((SugarPaletteWindow*) self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




