/* paletteconnector.c generated by valac 0.10.1, the Vala compiler
 * generated from paletteconnector.vala, do not modify */

/* paletteconnector.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Port from original sugar-toolkit project.
 * File:   src/sugar/graphics/palettewindow.py
 * Commit: c684950ecff34e910e6da5840737a469f95a0e79
 *
 * Copyright (C) 2007, Eduardo Silva <edsiper@gmail.com>
 * Copyright (C) 2008, One Laptop Per Child
 * Copyright (C) 2009, Tomeu Vizoso
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/gui.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <polyol/env.h>
#include <float.h>
#include <math.h>
#include <string.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SugarConnectorPrivate {
	GObject* _subject;
	SugarPalettePosition _palette_position;
};


static gpointer sugar_connector_parent_class = NULL;
static gpointer sugar_widget_connector_parent_class = NULL;
static gpointer sugar_tool_connector_parent_class = NULL;

#define SUGAR_CONNECTOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_CONNECTOR, SugarConnectorPrivate))
enum  {
	SUGAR_CONNECTOR_DUMMY_PROPERTY,
	SUGAR_CONNECTOR_SUBJECT,
	SUGAR_CONNECTOR_PALETTE_POSITION
};
static void _sugar_connector_get_alignment (SugarConnector* self, GtkRequisition* palette_size, SugarConnectorAlignment* result);
static void _sugar_connector_get_position_for_alignment (SugarConnector* self, SugarConnectorAlignment* alignment, GtkRequisition* palette_size, GdkRectangle* result);
static gboolean _sugar_connector_in_screen (SugarConnector* self, GdkRectangle* rect);
static void sugar_connector_real_on_popup (SugarConnector* self);
static void sugar_connector_real_on_popdown (SugarConnector* self);
static void sugar_connector_real_draw_rectangle (SugarConnector* self, GdkEventExpose* event, SugarPaletteWindow* palette);
static GtkWindow* sugar_connector_real_get_toplevel (SugarConnector* self);
static void sugar_connector_real_get_rect (SugarConnector* self, GdkRectangle* result);
static SugarConnectorAlignment* sugar_connector_real_get_alignments (SugarConnector* self, int* result_length1);
static gint _sugar_connector_get_area_in_screen (SugarConnector* self, GdkRectangle* rect);
static void sugar_connector_finalize (GObject* obj);
static void sugar_connector_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sugar_connector_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
enum  {
	SUGAR_WIDGET_CONNECTOR_DUMMY_PROPERTY,
	SUGAR_WIDGET_CONNECTOR_WIDGET
};
static void sugar_widget_connector_real_draw_rectangle (SugarConnector* base, GdkEventExpose* event, SugarPaletteWindow* palette);
static void sugar_widget_connector_real_on_popup (SugarConnector* base);
static void sugar_widget_connector_real_on_popdown (SugarConnector* base);
static GtkWindow* sugar_widget_connector_real_get_toplevel (SugarConnector* base);
static void sugar_widget_connector_real_get_rect (SugarConnector* base, GdkRectangle* result);
static gboolean _sugar_widget_connector_enter_notify_event_cb (SugarWidgetConnector* self, GdkEventCrossing* event);
static gboolean _sugar_widget_connector_leave_notify_event_cb (SugarWidgetConnector* self, GdkEventCrossing* event);
static gboolean _sugar_widget_connector_button_release_event_cb (SugarWidgetConnector* self, GdkEventButton* event);
static void _sugar_widget_connector_hierarchy_changed_cb (SugarWidgetConnector* self, GtkWidget* previous_toplevel);
static gboolean __sugar_widget_connector_enter_notify_event_cb_gtk_widget_enter_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self);
static gboolean __sugar_widget_connector_leave_notify_event_cb_gtk_widget_leave_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self);
static gboolean __sugar_widget_connector_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void __sugar_widget_connector_hierarchy_changed_cb_gtk_widget_hierarchy_changed (GtkWidget* _sender, GtkWidget* previous_toplevel, gpointer self);
static void sugar_widget_connector_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sugar_widget_connector_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
enum  {
	SUGAR_TOOL_CONNECTOR_DUMMY_PROPERTY,
	SUGAR_TOOL_CONNECTOR_TOOL_ITEM
};
static SugarConnectorAlignment* sugar_tool_connector_real_get_alignments (SugarConnector* base, int* result_length1);
static void sugar_tool_connector_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sugar_tool_connector_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);

static const SugarConnectorAlignment SUGAR_CONNECTOR_ALIGNMENT_AT_CURSOR[4] = {{0.0f, 0.0f, 1.0f, 1.0f, -1}, {0.0f, -1.0f, 1.0f, 0.0f, -1}, {-1.0f, -1.0f, 0.0f, 0.0f, -1}, {-1.0f, 0.0f, 0.0f, 1.0f, -1}};
static const SugarConnectorAlignment SUGAR_CONNECTOR_ALIGNMENT_ANCHORED[8] = {{0.0f, 0.0f, 0.0f, 1.0f, (gint) GTK_POS_BOTTOM}, {-1.0f, 0.0f, 1.0f, 1.0f, (gint) GTK_POS_BOTTOM}, {0.0f, 0.0f, 1.0f, 0.0f, (gint) GTK_POS_RIGHT}, {0.0f, -1.0f, 1.0f, 1.0f, (gint) GTK_POS_RIGHT}, {0.0f, -1.0f, 0.0f, 0.0f, (gint) GTK_POS_TOP}, {-1.0f, -1.0f, 1.0f, 0.0f, (gint) GTK_POS_TOP}, {-1.0f, 0.0f, 0.0f, 0.0f, (gint) GTK_POS_LEFT}, {-1.0f, -1.0f, 0.0f, 1.0f, (gint) GTK_POS_LEFT}};
static const SugarConnectorAlignment SUGAR_TOOL_CONNECTOR_ALIGNMENT_HORIZONTAL[4] = {{0.0f, 0.0f, 0.0f, 1.0f, (gint) GTK_POS_BOTTOM}, {-1.0f, 0.0f, 1.0f, 1.0f, (gint) GTK_POS_BOTTOM}, {0.0f, -1.0f, 0.0f, 0.0f, (gint) GTK_POS_TOP}, {-1.0f, -1.0f, 1.0f, 0.0f, (gint) GTK_POS_TOP}};
static const SugarConnectorAlignment SUGAR_TOOL_CONNECTOR_ALIGNMENT_VERTICAL[4] = {{-1.0f, 0.0f, 0.0f, 0.0f, (gint) GTK_POS_LEFT}, {-1.0f, -1.0f, 0.0f, 1.0f, (gint) GTK_POS_LEFT}, {0.0f, 0.0f, 1.0f, 0.0f, (gint) GTK_POS_RIGHT}, {0.0f, -1.0f, 1.0f, 1.0f, (gint) GTK_POS_RIGHT}};


GType sugar_palette_position_get_type (void) {
	static volatile gsize sugar_palette_position_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_palette_position_type_id__volatile)) {
		static const GEnumValue values[] = {{SUGAR_PALETTE_POSITION_ANCHORED, "SUGAR_PALETTE_POSITION_ANCHORED", "anchored"}, {SUGAR_PALETTE_POSITION_AT_CURSOR, "SUGAR_PALETTE_POSITION_AT_CURSOR", "at-cursor"}, {0, NULL, NULL}};
		GType sugar_palette_position_type_id;
		sugar_palette_position_type_id = g_enum_register_static ("SugarPalettePosition", values);
		g_once_init_leave (&sugar_palette_position_type_id__volatile, sugar_palette_position_type_id);
	}
	return sugar_palette_position_type_id__volatile;
}


/** Helper function to find the gap position and size of widget a */
#line 62 "paletteconnector.vala"
gboolean sugar_connector_get_box_gap (GdkRectangle* a, GdkRectangle* b, GtkPositionType* gap_side, gint* gap_start, gint* gap_size) {
#line 136 "paletteconnector.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 65 "paletteconnector.vala"
	if (((*a).y + (*a).height) == (*b).y) {
#line 66 "paletteconnector.vala"
		*gap_side = GTK_POS_BOTTOM;
#line 143 "paletteconnector.c"
	} else {
#line 67 "paletteconnector.vala"
		if (((*a).x + (*a).width) == (*b).x) {
#line 68 "paletteconnector.vala"
			*gap_side = GTK_POS_RIGHT;
#line 149 "paletteconnector.c"
		} else {
#line 69 "paletteconnector.vala"
			if ((*a).x == ((*b).x + (*b).width)) {
#line 70 "paletteconnector.vala"
				*gap_side = GTK_POS_LEFT;
#line 155 "paletteconnector.c"
			} else {
#line 71 "paletteconnector.vala"
				if ((*a).y == ((*b).y + (*b).height)) {
#line 72 "paletteconnector.vala"
					*gap_side = GTK_POS_TOP;
#line 161 "paletteconnector.c"
				} else {
					result = FALSE;
#line 74 "paletteconnector.vala"
					return result;
#line 166 "paletteconnector.c"
				}
			}
		}
	}
#line 76 "paletteconnector.vala"
	if ((*gap_side) == GTK_POS_BOTTOM) {
#line 76 "paletteconnector.vala"
		_tmp0_ = TRUE;
#line 175 "paletteconnector.c"
	} else {
#line 77 "paletteconnector.vala"
		_tmp0_ = (*gap_side) == GTK_POS_TOP;
#line 179 "paletteconnector.c"
	}
#line 76 "paletteconnector.vala"
	if (_tmp0_) {
#line 78 "paletteconnector.vala"
		*gap_start = MIN ((*a).width, MAX (0, (*b).x - (*a).x));
#line 79 "paletteconnector.vala"
		*gap_size = MAX (0, MIN ((*a).width, ((*b).x + (*b).width) - (*a).x) - (*gap_start));
#line 187 "paletteconnector.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 81 "paletteconnector.vala"
		if ((*gap_side) == GTK_POS_RIGHT) {
#line 81 "paletteconnector.vala"
			_tmp1_ = TRUE;
#line 194 "paletteconnector.c"
		} else {
#line 82 "paletteconnector.vala"
			_tmp1_ = (*gap_side) == GTK_POS_LEFT;
#line 198 "paletteconnector.c"
		}
#line 81 "paletteconnector.vala"
		if (_tmp1_) {
#line 83 "paletteconnector.vala"
			*gap_start = MIN ((*a).height, MAX (0, (*b).y - (*a).y));
#line 84 "paletteconnector.vala"
			*gap_size = MAX (0, MIN ((*a).height, ((*b).y + (*b).height) - (*a).y) - (*gap_start));
#line 206 "paletteconnector.c"
		}
	}
	result = TRUE;
#line 88 "paletteconnector.vala"
	return result;
#line 212 "paletteconnector.c"
}


#line 91 "paletteconnector.vala"
void sugar_connector_get_palette_pos (SugarConnector* self, GtkRequisition* palette_size, gint* x, gint* y) {
#line 218 "paletteconnector.c"
	SugarConnectorAlignment _tmp0_ = {0};
	SugarConnectorAlignment alignment;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle rect;
#line 91 "paletteconnector.vala"
	g_return_if_fail (self != NULL);
#line 93 "paletteconnector.vala"
	alignment = (_sugar_connector_get_alignment (self, palette_size, &_tmp0_), _tmp0_);
#line 94 "paletteconnector.vala"
	rect = (_sugar_connector_get_position_for_alignment (self, &alignment, palette_size, &_tmp1_), _tmp1_);
#line 96 "paletteconnector.vala"
	if (_sugar_connector_in_screen (self, &rect)) {
#line 97 "paletteconnector.vala"
		*x = rect.x;
#line 98 "paletteconnector.vala"
		*y = rect.y;
#line 235 "paletteconnector.c"
	} else {
#line 103 "paletteconnector.vala"
		*x = MAX (0, rect.x);
#line 104 "paletteconnector.vala"
		*y = MAX (0, rect.y);
#line 106 "paletteconnector.vala"
		*x = MIN (*x, gdk_screen_width () - rect.width);
#line 107 "paletteconnector.vala"
		*y = MIN (*y, gdk_screen_height () - rect.height);
#line 245 "paletteconnector.c"
	}
}


#line 111 "paletteconnector.vala"
static void sugar_connector_real_on_popup (SugarConnector* self) {
#line 111 "paletteconnector.vala"
	g_return_if_fail (self != NULL);
#line 254 "paletteconnector.c"
}


void sugar_connector_on_popup (SugarConnector* self) {
	SUGAR_CONNECTOR_GET_CLASS (self)->on_popup (self);
}


#line 114 "paletteconnector.vala"
static void sugar_connector_real_on_popdown (SugarConnector* self) {
#line 114 "paletteconnector.vala"
	g_return_if_fail (self != NULL);
#line 267 "paletteconnector.c"
}


void sugar_connector_on_popdown (SugarConnector* self) {
	SUGAR_CONNECTOR_GET_CLASS (self)->on_popdown (self);
}


#line 117 "paletteconnector.vala"
static void sugar_connector_real_draw_rectangle (SugarConnector* self, GdkEventExpose* event, SugarPaletteWindow* palette) {
#line 278 "paletteconnector.c"
	g_return_if_fail (self != NULL);
	g_critical ("Type `%s' does not implement abstract method `sugar_connector_draw_rectangle'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void sugar_connector_draw_rectangle (SugarConnector* self, GdkEventExpose* event, SugarPaletteWindow* palette) {
	SUGAR_CONNECTOR_GET_CLASS (self)->draw_rectangle (self, event, palette);
}


#line 120 "paletteconnector.vala"
static GtkWindow* sugar_connector_real_get_toplevel (SugarConnector* self) {
#line 292 "paletteconnector.c"
	g_return_val_if_fail (self != NULL, NULL);
	g_critical ("Type `%s' does not implement abstract method `sugar_connector_get_toplevel'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


GtkWindow* sugar_connector_get_toplevel (SugarConnector* self) {
	return SUGAR_CONNECTOR_GET_CLASS (self)->get_toplevel (self);
}


#line 122 "paletteconnector.vala"
static void sugar_connector_real_get_rect (SugarConnector* self, GdkRectangle* result) {
#line 306 "paletteconnector.c"
	g_return_if_fail (self != NULL);
	g_critical ("Type `%s' does not implement abstract method `sugar_connector_get_rect'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void sugar_connector_get_rect (SugarConnector* self, GdkRectangle* result) {
	SUGAR_CONNECTOR_GET_CLASS (self)->get_rect (self, result);
}


#line 124 "paletteconnector.vala"
static SugarConnectorAlignment* sugar_connector_real_get_alignments (SugarConnector* self, int* result_length1) {
#line 320 "paletteconnector.c"
	SugarConnectorAlignment* result = NULL;
#line 124 "paletteconnector.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "paletteconnector.vala"
	if (self->priv->_palette_position == SUGAR_PALETTE_POSITION_AT_CURSOR) {
#line 326 "paletteconnector.c"
		SugarConnectorAlignment* _tmp0_;
		result = (_tmp0_ = SUGAR_CONNECTOR_ALIGNMENT_AT_CURSOR, *result_length1 = G_N_ELEMENTS (SUGAR_CONNECTOR_ALIGNMENT_AT_CURSOR), _tmp0_);
#line 126 "paletteconnector.vala"
		return result;
#line 331 "paletteconnector.c"
	} else {
		SugarConnectorAlignment* _tmp1_;
		result = (_tmp1_ = SUGAR_CONNECTOR_ALIGNMENT_ANCHORED, *result_length1 = G_N_ELEMENTS (SUGAR_CONNECTOR_ALIGNMENT_ANCHORED), _tmp1_);
#line 128 "paletteconnector.vala"
		return result;
#line 337 "paletteconnector.c"
	}
}


SugarConnectorAlignment* sugar_connector_get_alignments (SugarConnector* self, int* result_length1) {
	return SUGAR_CONNECTOR_GET_CLASS (self)->get_alignments (self, result_length1);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 131 "paletteconnector.vala"
static void _sugar_connector_get_position_for_alignment (SugarConnector* self, SugarConnectorAlignment* alignment, GtkRequisition* palette_size, GdkRectangle* result) {
#line 354 "paletteconnector.c"
	GdkRectangle _tmp0_ = {0};
	GdkRectangle rect;
#line 131 "paletteconnector.vala"
	g_return_if_fail (self != NULL);
#line 133 "paletteconnector.vala"
	rect = (_tmp0_);
#line 135 "paletteconnector.vala"
	if (self->priv->_palette_position == SUGAR_PALETTE_POSITION_ANCHORED) {
#line 363 "paletteconnector.c"
		GdkRectangle _tmp1_ = {0};
#line 136 "paletteconnector.vala"
		rect = (sugar_connector_get_rect (self, &_tmp1_), _tmp1_);
#line 367 "paletteconnector.c"
	} else {
		gint cursor_x = 0;
		gint cursor_y = 0;
		GdkDisplay* display;
		gint dist;
#line 139 "paletteconnector.vala"
		display = _g_object_ref0 (gdk_display_get_default ());
#line 140 "paletteconnector.vala"
		gdk_display_get_pointer (display, NULL, &cursor_x, &cursor_y, NULL);
#line 142 "paletteconnector.vala"
		dist = sugar_metrics_get (SUGAR_PALETTE_CURSOR_DISTANCE);
#line 143 "paletteconnector.vala"
		rect.x = cursor_x - dist;
#line 144 "paletteconnector.vala"
		rect.y = cursor_y - dist;
#line 145 "paletteconnector.vala"
		rect.width = dist * 2;
#line 146 "paletteconnector.vala"
		rect.height = dist * 2;
#line 387 "paletteconnector.c"
		_g_object_unref0 (display);
	}
#line 149 "paletteconnector.vala"
	rect.x = (gint) ((rect.x + (rect.width * (*alignment).invoker_halign)) + ((*palette_size).width * (*alignment).palette_halign));
#line 151 "paletteconnector.vala"
	rect.y = (gint) ((rect.y + (rect.height * (*alignment).invoker_valign)) + ((*palette_size).height * (*alignment).palette_valign));
#line 153 "paletteconnector.vala"
	rect.width = (*palette_size).width;
#line 154 "paletteconnector.vala"
	rect.height = (*palette_size).height;
#line 398 "paletteconnector.c"
	*result = rect;
#line 156 "paletteconnector.vala"
	return;
#line 402 "paletteconnector.c"
}


#line 159 "paletteconnector.vala"
static void _sugar_connector_get_alignment (SugarConnector* self, GtkRequisition* palette_size, SugarConnectorAlignment* result) {
#line 408 "paletteconnector.c"
	gint best_area;
	SugarConnectorAlignment* best_alignment;
	SugarConnectorAlignment _result_;
	GdkRectangle _tmp2_ = {0};
	GdkRectangle rect;
	gboolean _tmp3_ = FALSE;
#line 159 "paletteconnector.vala"
	g_return_if_fail (self != NULL);
#line 160 "paletteconnector.vala"
	best_area = -1;
#line 161 "paletteconnector.vala"
	best_alignment = NULL;
#line 421 "paletteconnector.c"
	{
		gint _tmp0_;
		SugarConnectorAlignment* alignment_collection;
		int alignment_collection_length1;
		int alignment_it;
#line 163 "paletteconnector.vala"
		alignment_collection = sugar_connector_get_alignments (self, &_tmp0_);
#line 429 "paletteconnector.c"
		alignment_collection_length1 = _tmp0_;
		for (alignment_it = 0; alignment_it < _tmp0_; alignment_it = alignment_it + 1) {
			SugarConnectorAlignment alignment;
			alignment = alignment_collection[alignment_it];
			{
				GdkRectangle _tmp1_ = {0};
				GdkRectangle rect;
				gint area;
#line 164 "paletteconnector.vala"
				rect = (_sugar_connector_get_position_for_alignment (self, &alignment, palette_size, &_tmp1_), _tmp1_);
#line 165 "paletteconnector.vala"
				if (_sugar_connector_in_screen (self, &rect)) {
#line 442 "paletteconnector.c"
					*result = alignment;
#line 166 "paletteconnector.vala"
					return;
#line 446 "paletteconnector.c"
				}
#line 167 "paletteconnector.vala"
				area = _sugar_connector_get_area_in_screen (self, &rect);
#line 168 "paletteconnector.vala"
				if (area > best_area) {
#line 169 "paletteconnector.vala"
					best_alignment = &alignment;
#line 170 "paletteconnector.vala"
					best_area = area;
#line 456 "paletteconnector.c"
				}
			}
		}
	}
#line 174 "paletteconnector.vala"
	_result_ = *best_alignment;
#line 175 "paletteconnector.vala"
	rect = (sugar_connector_get_rect (self, &_tmp2_), _tmp2_);
#line 177 "paletteconnector.vala"
	if (_result_.position == GTK_POS_LEFT) {
#line 177 "paletteconnector.vala"
		_tmp3_ = TRUE;
#line 469 "paletteconnector.c"
	} else {
#line 178 "paletteconnector.vala"
		_tmp3_ = _result_.position == GTK_POS_RIGHT;
#line 473 "paletteconnector.c"
	}
#line 177 "paletteconnector.vala"
	if (_tmp3_) {
#line 477 "paletteconnector.c"
		gint top;
		gint bottom;
#line 179 "paletteconnector.vala"
		top = rect.y;
#line 180 "paletteconnector.vala"
		bottom = (gdk_screen_height () - rect.y) - rect.width;
#line 181 "paletteconnector.vala"
		if (top > bottom) {
#line 183 "paletteconnector.vala"
			_result_.palette_valign = (-((float) top)) / (*palette_size).height;
#line 488 "paletteconnector.c"
		} else {
#line 186 "paletteconnector.vala"
			_result_.palette_valign = (-((float) (((*palette_size).height - bottom) - rect.height))) / (*palette_size).height;
#line 492 "paletteconnector.c"
		}
#line 189 "paletteconnector.vala"
		_result_.invoker_valign = (float) 0;
#line 496 "paletteconnector.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 190 "paletteconnector.vala"
		if (_result_.position == GTK_POS_TOP) {
#line 190 "paletteconnector.vala"
			_tmp4_ = TRUE;
#line 503 "paletteconnector.c"
		} else {
#line 191 "paletteconnector.vala"
			_tmp4_ = _result_.position == GTK_POS_BOTTOM;
#line 507 "paletteconnector.c"
		}
#line 190 "paletteconnector.vala"
		if (_tmp4_) {
#line 511 "paletteconnector.c"
			gint left;
			gint right;
#line 192 "paletteconnector.vala"
			left = rect.x;
#line 193 "paletteconnector.vala"
			right = (gdk_screen_width () - rect.x) - rect.width;
#line 194 "paletteconnector.vala"
			if (left > right) {
#line 196 "paletteconnector.vala"
				_result_.palette_halign = (-((float) left)) / (*palette_size).width;
#line 522 "paletteconnector.c"
			} else {
#line 199 "paletteconnector.vala"
				_result_.palette_halign = (-((float) (((*palette_size).width - right) - rect.width))) / (*palette_size).width;
#line 526 "paletteconnector.c"
			}
#line 202 "paletteconnector.vala"
			_result_.invoker_halign = (float) 0;
#line 530 "paletteconnector.c"
		}
	}
	*result = _result_;
#line 205 "paletteconnector.vala"
	return;
#line 536 "paletteconnector.c"
}


/** Return area of rectangle visible in the screen */
#line 209 "paletteconnector.vala"
static gint _sugar_connector_get_area_in_screen (SugarConnector* self, GdkRectangle* rect) {
#line 543 "paletteconnector.c"
	gint result = 0;
	gint x1;
	gint y1;
	gint x2;
	gint y2;
#line 209 "paletteconnector.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 210 "paletteconnector.vala"
	x1 = MAX (0, (*rect).x);
#line 211 "paletteconnector.vala"
	y1 = MAX (0, (*rect).y);
#line 212 "paletteconnector.vala"
	x2 = MIN (gdk_screen_width (), (*rect).x + (*rect).width);
#line 213 "paletteconnector.vala"
	y2 = MIN (gdk_screen_height (), (*rect).y + (*rect).height);
#line 559 "paletteconnector.c"
	result = (x2 - x1) * (y2 - y1);
#line 215 "paletteconnector.vala"
	return result;
#line 563 "paletteconnector.c"
}


#line 218 "paletteconnector.vala"
static gboolean _sugar_connector_in_screen (SugarConnector* self, GdkRectangle* rect) {
#line 569 "paletteconnector.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 218 "paletteconnector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 219 "paletteconnector.vala"
	if ((*rect).x >= 0) {
#line 219 "paletteconnector.vala"
		_tmp2_ = (*rect).y >= 0;
#line 580 "paletteconnector.c"
	} else {
#line 219 "paletteconnector.vala"
		_tmp2_ = FALSE;
#line 584 "paletteconnector.c"
	}
#line 219 "paletteconnector.vala"
	if (_tmp2_) {
#line 220 "paletteconnector.vala"
		_tmp1_ = ((*rect).x + (*rect).width) <= gdk_screen_width ();
#line 590 "paletteconnector.c"
	} else {
#line 219 "paletteconnector.vala"
		_tmp1_ = FALSE;
#line 594 "paletteconnector.c"
	}
#line 219 "paletteconnector.vala"
	if (_tmp1_) {
#line 221 "paletteconnector.vala"
		_tmp0_ = ((*rect).y + (*rect).height) <= gdk_screen_height ();
#line 600 "paletteconnector.c"
	} else {
#line 219 "paletteconnector.vala"
		_tmp0_ = FALSE;
#line 604 "paletteconnector.c"
	}
	result = _tmp0_;
#line 219 "paletteconnector.vala"
	return result;
#line 609 "paletteconnector.c"
}


#line 49 "paletteconnector.vala"
SugarConnector* sugar_connector_construct (GType object_type) {
#line 615 "paletteconnector.c"
	SugarConnector * self = NULL;
#line 49 "paletteconnector.vala"
	self = (SugarConnector*) g_object_new (object_type, NULL);
#line 619 "paletteconnector.c"
	return self;
}


GObject* sugar_connector_get_subject (SugarConnector* self) {
	GObject* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_subject;
#line 55 "paletteconnector.vala"
	return result;
#line 630 "paletteconnector.c"
}


void sugar_connector_set_subject (SugarConnector* self, GObject* value) {
	GObject* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_subject = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_subject), _tmp0_);
	g_object_notify ((GObject *) self, "subject");
}


SugarPalettePosition sugar_connector_get_palette_position (SugarConnector* self) {
	SugarPalettePosition result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_palette_position;
#line 58 "paletteconnector.vala"
	return result;
#line 648 "paletteconnector.c"
}


void sugar_connector_set_palette_position (SugarConnector* self, SugarPalettePosition value) {
	g_return_if_fail (self != NULL);
	self->priv->_palette_position = value;
	g_object_notify ((GObject *) self, "palette-position");
}


SugarConnectorAlignment* sugar_connector_alignment_dup (const SugarConnectorAlignment* self) {
	SugarConnectorAlignment* dup;
	dup = g_new0 (SugarConnectorAlignment, 1);
	memcpy (dup, self, sizeof (SugarConnectorAlignment));
	return dup;
}


void sugar_connector_alignment_free (SugarConnectorAlignment* self) {
	g_free (self);
}


GType sugar_connector_alignment_get_type (void) {
	static volatile gsize sugar_connector_alignment_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_connector_alignment_type_id__volatile)) {
		GType sugar_connector_alignment_type_id;
		sugar_connector_alignment_type_id = g_boxed_type_register_static ("SugarConnectorAlignment", (GBoxedCopyFunc) sugar_connector_alignment_dup, (GBoxedFreeFunc) sugar_connector_alignment_free);
		g_once_init_leave (&sugar_connector_alignment_type_id__volatile, sugar_connector_alignment_type_id);
	}
	return sugar_connector_alignment_type_id__volatile;
}


static void sugar_connector_class_init (SugarConnectorClass * klass) {
	sugar_connector_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarConnectorPrivate));
	SUGAR_CONNECTOR_CLASS (klass)->on_popup = sugar_connector_real_on_popup;
	SUGAR_CONNECTOR_CLASS (klass)->on_popdown = sugar_connector_real_on_popdown;
	SUGAR_CONNECTOR_CLASS (klass)->draw_rectangle = sugar_connector_real_draw_rectangle;
	SUGAR_CONNECTOR_CLASS (klass)->get_toplevel = sugar_connector_real_get_toplevel;
	SUGAR_CONNECTOR_CLASS (klass)->get_rect = sugar_connector_real_get_rect;
	SUGAR_CONNECTOR_CLASS (klass)->get_alignments = sugar_connector_real_get_alignments;
	G_OBJECT_CLASS (klass)->get_property = sugar_connector_get_property;
	G_OBJECT_CLASS (klass)->set_property = sugar_connector_set_property;
	G_OBJECT_CLASS (klass)->finalize = sugar_connector_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_CONNECTOR_SUBJECT, g_param_spec_object ("subject", "subject", "subject", G_TYPE_OBJECT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_CONNECTOR_PALETTE_POSITION, g_param_spec_enum ("palette-position", "palette-position", "palette-position", SUGAR_TYPE_PALETTE_POSITION, SUGAR_PALETTE_POSITION_ANCHORED, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("invoker_enter", SUGAR_TYPE_CONNECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("invoker_leave", SUGAR_TYPE_CONNECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("popup", SUGAR_TYPE_CONNECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("popdown", SUGAR_TYPE_CONNECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void sugar_connector_instance_init (SugarConnector * self) {
	self->priv = SUGAR_CONNECTOR_GET_PRIVATE (self);
	self->priv->_palette_position = SUGAR_PALETTE_POSITION_ANCHORED;
}


static void sugar_connector_finalize (GObject* obj) {
	SugarConnector * self;
	self = SUGAR_CONNECTOR (obj);
	_g_object_unref0 (self->priv->_subject);
	G_OBJECT_CLASS (sugar_connector_parent_class)->finalize (obj);
}


GType sugar_connector_get_type (void) {
	static volatile gsize sugar_connector_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_connector_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarConnectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_connector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarConnector), 0, (GInstanceInitFunc) sugar_connector_instance_init, NULL };
		GType sugar_connector_type_id;
		sugar_connector_type_id = g_type_register_static (G_TYPE_OBJECT, "SugarConnector", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&sugar_connector_type_id__volatile, sugar_connector_type_id);
	}
	return sugar_connector_type_id__volatile;
}


static void sugar_connector_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarConnector * self;
	self = SUGAR_CONNECTOR (object);
	switch (property_id) {
		case SUGAR_CONNECTOR_SUBJECT:
		g_value_set_object (value, sugar_connector_get_subject (self));
		break;
		case SUGAR_CONNECTOR_PALETTE_POSITION:
		g_value_set_enum (value, sugar_connector_get_palette_position (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sugar_connector_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarConnector * self;
	self = SUGAR_CONNECTOR (object);
	switch (property_id) {
		case SUGAR_CONNECTOR_SUBJECT:
		sugar_connector_set_subject (self, g_value_get_object (value));
		break;
		case SUGAR_CONNECTOR_PALETTE_POSITION:
		sugar_connector_set_palette_position (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 276 "paletteconnector.vala"
SugarWidgetConnector* sugar_widget_connector_construct (GType object_type, GtkWidget* widget) {
#line 766 "paletteconnector.c"
	SugarWidgetConnector * self = NULL;
#line 276 "paletteconnector.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 277 "paletteconnector.vala"
	self = (SugarWidgetConnector*) g_object_new (object_type, "widget", widget, NULL);
#line 772 "paletteconnector.c"
	return self;
}


#line 276 "paletteconnector.vala"
SugarWidgetConnector* sugar_widget_connector_new (GtkWidget* widget) {
#line 276 "paletteconnector.vala"
	return sugar_widget_connector_construct (SUGAR_TYPE_WIDGET_CONNECTOR, widget);
#line 781 "paletteconnector.c"
}


#line 280 "paletteconnector.vala"
static void sugar_widget_connector_real_draw_rectangle (SugarConnector* base, GdkEventExpose* event, SugarPaletteWindow* palette) {
#line 787 "paletteconnector.c"
	SugarWidgetConnector * self;
	GtkPositionType gap_side = 0;
	gint gap_start = 0;
	gint gap_size = 0;
	gint x;
	gint y;
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	self = (SugarWidgetConnector*) base;
#line 280 "paletteconnector.vala"
	g_return_if_fail (palette != NULL);
#line 284 "paletteconnector.vala"
	x = 0;
#line 284 "paletteconnector.vala"
	y = 0;
#line 286 "paletteconnector.vala"
	if (GTK_WIDGET_NO_WINDOW (sugar_widget_connector_get_widget (self))) {
#line 287 "paletteconnector.vala"
		x = sugar_widget_connector_get_widget (self)->allocation.x;
#line 288 "paletteconnector.vala"
		y = sugar_widget_connector_get_widget (self)->allocation.y;
#line 811 "paletteconnector.c"
	}
#line 291 "paletteconnector.vala"
	if (sugar_connector_get_box_gap ((_tmp2_ = (sugar_connector_get_rect ((SugarConnector*) self, &_tmp0_), _tmp0_), &_tmp2_), (_tmp3_ = (sugar_palette_window_get_rect (palette, &_tmp1_), _tmp1_), &_tmp3_), &gap_side, &gap_start, &gap_size)) {
#line 293 "paletteconnector.vala"
		gtk_paint_box_gap (gtk_widget_get_style (sugar_widget_connector_get_widget (self)), (*event).window, GTK_STATE_PRELIGHT, GTK_SHADOW_IN, &(*event).area, sugar_widget_connector_get_widget (self), "palette-invoker", x, y, sugar_widget_connector_get_widget (self)->allocation.width, sugar_widget_connector_get_widget (self)->allocation.height, gap_side, gap_start, gap_size);
#line 817 "paletteconnector.c"
	} else {
#line 299 "paletteconnector.vala"
		gtk_paint_box (gtk_widget_get_style (sugar_widget_connector_get_widget (self)), (*event).window, GTK_STATE_PRELIGHT, GTK_SHADOW_IN, &(*event).area, sugar_widget_connector_get_widget (self), "palette-invoker", x, y, sugar_widget_connector_get_widget (self)->allocation.width, sugar_widget_connector_get_widget (self)->allocation.height);
#line 821 "paletteconnector.c"
	}
}


#line 305 "paletteconnector.vala"
static void sugar_widget_connector_real_on_popup (SugarConnector* base) {
#line 828 "paletteconnector.c"
	SugarWidgetConnector * self;
	self = (SugarWidgetConnector*) base;
#line 306 "paletteconnector.vala"
	gtk_widget_queue_draw (sugar_widget_connector_get_widget (self));
#line 833 "paletteconnector.c"
}


#line 309 "paletteconnector.vala"
static void sugar_widget_connector_real_on_popdown (SugarConnector* base) {
#line 839 "paletteconnector.c"
	SugarWidgetConnector * self;
	self = (SugarWidgetConnector*) base;
#line 310 "paletteconnector.vala"
	gtk_widget_queue_draw (sugar_widget_connector_get_widget (self));
#line 844 "paletteconnector.c"
}


#line 313 "paletteconnector.vala"
static GtkWindow* sugar_widget_connector_real_get_toplevel (SugarConnector* base) {
#line 850 "paletteconnector.c"
	SugarWidgetConnector * self;
	GtkWindow* result = NULL;
	GtkWidget* _tmp0_;
	self = (SugarWidgetConnector*) base;
	result = (_tmp0_ = gtk_widget_get_toplevel (sugar_widget_connector_get_widget (self)), GTK_IS_WINDOW (_tmp0_) ? ((GtkWindow*) _tmp0_) : NULL);
#line 314 "paletteconnector.vala"
	return result;
#line 858 "paletteconnector.c"
}


#line 317 "paletteconnector.vala"
static void sugar_widget_connector_real_get_rect (SugarConnector* base, GdkRectangle* result) {
#line 864 "paletteconnector.c"
	SugarWidgetConnector * self;
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _result_;
	self = (SugarWidgetConnector*) base;
#line 318 "paletteconnector.vala"
	_result_ = (_tmp0_.x = 0, _tmp0_.y = 0, _tmp0_.width = sugar_widget_connector_get_widget (self)->allocation.width, _tmp0_.height = sugar_widget_connector_get_widget (self)->allocation.height, _tmp0_);
#line 323 "paletteconnector.vala"
	if (sugar_widget_connector_get_widget (self)->window != NULL) {
#line 324 "paletteconnector.vala"
		gdk_window_get_origin (sugar_widget_connector_get_widget (self)->window, &_result_.x, &_result_.y);
#line 875 "paletteconnector.c"
	} else {
#line 326 "paletteconnector.vala"
		g_warning ("paletteconnector.vala:326: %s", "Trying to position palette with invoker " "that's not realized.");
#line 879 "paletteconnector.c"
	}
#line 329 "paletteconnector.vala"
	if (GTK_WIDGET_NO_WINDOW (sugar_widget_connector_get_widget (self))) {
#line 330 "paletteconnector.vala"
		_result_.x = _result_.x + sugar_widget_connector_get_widget (self)->allocation.x;
#line 331 "paletteconnector.vala"
		_result_.y = _result_.y + sugar_widget_connector_get_widget (self)->allocation.y;
#line 887 "paletteconnector.c"
	}
	*result = _result_;
#line 334 "paletteconnector.vala"
	return;
#line 892 "paletteconnector.c"
}


#line 337 "paletteconnector.vala"
static gboolean _sugar_widget_connector_enter_notify_event_cb (SugarWidgetConnector* self, GdkEventCrossing* event) {
#line 898 "paletteconnector.c"
	gboolean result = FALSE;
#line 337 "paletteconnector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 338 "paletteconnector.vala"
	g_signal_emit_by_name ((SugarConnector*) self, "invoker-enter");
#line 904 "paletteconnector.c"
	result = FALSE;
#line 339 "paletteconnector.vala"
	return result;
#line 908 "paletteconnector.c"
}


#line 342 "paletteconnector.vala"
static gboolean _sugar_widget_connector_leave_notify_event_cb (SugarWidgetConnector* self, GdkEventCrossing* event) {
#line 914 "paletteconnector.c"
	gboolean result = FALSE;
#line 342 "paletteconnector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 343 "paletteconnector.vala"
	g_signal_emit_by_name ((SugarConnector*) self, "invoker-leave");
#line 920 "paletteconnector.c"
	result = FALSE;
#line 344 "paletteconnector.vala"
	return result;
#line 924 "paletteconnector.c"
}


#line 347 "paletteconnector.vala"
static gboolean _sugar_widget_connector_button_release_event_cb (SugarWidgetConnector* self, GdkEventButton* event) {
#line 930 "paletteconnector.c"
	gboolean result = FALSE;
#line 347 "paletteconnector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 348 "paletteconnector.vala"
	if ((*event).button == 3) {
#line 349 "paletteconnector.vala"
		g_signal_emit_by_name ((SugarConnector*) self, "popup");
#line 938 "paletteconnector.c"
		result = TRUE;
#line 350 "paletteconnector.vala"
		return result;
#line 942 "paletteconnector.c"
	} else {
		result = FALSE;
#line 352 "paletteconnector.vala"
		return result;
#line 947 "paletteconnector.c"
	}
}


#line 356 "paletteconnector.vala"
static void _sugar_widget_connector_hierarchy_changed_cb (SugarWidgetConnector* self, GtkWidget* previous_toplevel) {
#line 356 "paletteconnector.vala"
	g_return_if_fail (self != NULL);
#line 357 "paletteconnector.vala"
	g_signal_emit_by_name ((SugarConnector*) self, "popdown");
#line 958 "paletteconnector.c"
}


GtkWidget* sugar_widget_connector_get_widget (SugarWidgetConnector* self) {
	GtkWidget* result;
	GObject* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	result = (_tmp0_ = sugar_connector_get_subject ((SugarConnector*) self), GTK_IS_WIDGET (_tmp0_) ? ((GtkWidget*) _tmp0_) : NULL);
#line 254 "paletteconnector.vala"
	return result;
#line 969 "paletteconnector.c"
}


#line 337 "paletteconnector.vala"
static gboolean __sugar_widget_connector_enter_notify_event_cb_gtk_widget_enter_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self) {
#line 975 "paletteconnector.c"
	gboolean result;
	result = _sugar_widget_connector_enter_notify_event_cb (self, event);
	return result;
}


#line 342 "paletteconnector.vala"
static gboolean __sugar_widget_connector_leave_notify_event_cb_gtk_widget_leave_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self) {
#line 984 "paletteconnector.c"
	gboolean result;
	result = _sugar_widget_connector_leave_notify_event_cb (self, event);
	return result;
}


#line 347 "paletteconnector.vala"
static gboolean __sugar_widget_connector_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
#line 993 "paletteconnector.c"
	gboolean result;
	result = _sugar_widget_connector_button_release_event_cb (self, event);
	return result;
}


#line 356 "paletteconnector.vala"
static void __sugar_widget_connector_hierarchy_changed_cb_gtk_widget_hierarchy_changed (GtkWidget* _sender, GtkWidget* previous_toplevel, gpointer self) {
#line 1002 "paletteconnector.c"
	_sugar_widget_connector_hierarchy_changed_cb (self, previous_toplevel);
}


void sugar_widget_connector_set_widget (SugarWidgetConnector* self, GtkWidget* value) {
	g_return_if_fail (self != NULL);
#line 257 "paletteconnector.vala"
	if (sugar_widget_connector_get_widget (self) != NULL) {
#line 1011 "paletteconnector.c"
		guint _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
#line 258 "paletteconnector.vala"
		g_signal_parse_name ("enter-notify-event", GTK_TYPE_WIDGET, &_tmp0_, NULL, FALSE);
#line 258 "paletteconnector.vala"
		g_signal_handlers_disconnect_matched (sugar_widget_connector_get_widget (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) __sugar_widget_connector_enter_notify_event_cb_gtk_widget_enter_notify_event, self);
#line 259 "paletteconnector.vala"
		g_signal_parse_name ("leave-notify-event", GTK_TYPE_WIDGET, &_tmp1_, NULL, FALSE);
#line 259 "paletteconnector.vala"
		g_signal_handlers_disconnect_matched (sugar_widget_connector_get_widget (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) __sugar_widget_connector_leave_notify_event_cb_gtk_widget_leave_notify_event, self);
#line 260 "paletteconnector.vala"
		g_signal_parse_name ("button-release-event", GTK_TYPE_WIDGET, &_tmp2_, NULL, FALSE);
#line 260 "paletteconnector.vala"
		g_signal_handlers_disconnect_matched (sugar_widget_connector_get_widget (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) __sugar_widget_connector_button_release_event_cb_gtk_widget_button_release_event, self);
#line 262 "paletteconnector.vala"
		g_signal_parse_name ("hierarchy-changed", GTK_TYPE_WIDGET, &_tmp3_, NULL, FALSE);
#line 262 "paletteconnector.vala"
		g_signal_handlers_disconnect_matched (sugar_widget_connector_get_widget (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) __sugar_widget_connector_hierarchy_changed_cb_gtk_widget_hierarchy_changed, self);
#line 1032 "paletteconnector.c"
	}
#line 265 "paletteconnector.vala"
	sugar_connector_set_subject ((SugarConnector*) self, (GObject*) value);
#line 267 "paletteconnector.vala"
	if (sugar_widget_connector_get_widget (self) != NULL) {
#line 268 "paletteconnector.vala"
		g_signal_connect_object (sugar_widget_connector_get_widget (self), "enter-notify-event", (GCallback) __sugar_widget_connector_enter_notify_event_cb_gtk_widget_enter_notify_event, self, 0);
#line 269 "paletteconnector.vala"
		g_signal_connect_object (sugar_widget_connector_get_widget (self), "leave-notify-event", (GCallback) __sugar_widget_connector_leave_notify_event_cb_gtk_widget_leave_notify_event, self, 0);
#line 270 "paletteconnector.vala"
		g_signal_connect_object (sugar_widget_connector_get_widget (self), "button-release-event", (GCallback) __sugar_widget_connector_button_release_event_cb_gtk_widget_button_release_event, self, 0);
#line 271 "paletteconnector.vala"
		g_signal_connect_object (sugar_widget_connector_get_widget (self), "hierarchy-changed", (GCallback) __sugar_widget_connector_hierarchy_changed_cb_gtk_widget_hierarchy_changed, self, 0);
#line 1046 "paletteconnector.c"
	}
	g_object_notify ((GObject *) self, "widget");
}


static void sugar_widget_connector_class_init (SugarWidgetConnectorClass * klass) {
	sugar_widget_connector_parent_class = g_type_class_peek_parent (klass);
	SUGAR_CONNECTOR_CLASS (klass)->draw_rectangle = sugar_widget_connector_real_draw_rectangle;
	SUGAR_CONNECTOR_CLASS (klass)->on_popup = sugar_widget_connector_real_on_popup;
	SUGAR_CONNECTOR_CLASS (klass)->on_popdown = sugar_widget_connector_real_on_popdown;
	SUGAR_CONNECTOR_CLASS (klass)->get_toplevel = sugar_widget_connector_real_get_toplevel;
	SUGAR_CONNECTOR_CLASS (klass)->get_rect = sugar_widget_connector_real_get_rect;
	G_OBJECT_CLASS (klass)->get_property = sugar_widget_connector_get_property;
	G_OBJECT_CLASS (klass)->set_property = sugar_widget_connector_set_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_WIDGET_CONNECTOR_WIDGET, g_param_spec_object ("widget", "widget", "widget", GTK_TYPE_WIDGET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void sugar_widget_connector_instance_init (SugarWidgetConnector * self) {
}


GType sugar_widget_connector_get_type (void) {
	static volatile gsize sugar_widget_connector_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_widget_connector_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarWidgetConnectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_widget_connector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarWidgetConnector), 0, (GInstanceInitFunc) sugar_widget_connector_instance_init, NULL };
		GType sugar_widget_connector_type_id;
		sugar_widget_connector_type_id = g_type_register_static (SUGAR_TYPE_CONNECTOR, "SugarWidgetConnector", &g_define_type_info, 0);
		g_once_init_leave (&sugar_widget_connector_type_id__volatile, sugar_widget_connector_type_id);
	}
	return sugar_widget_connector_type_id__volatile;
}


static void sugar_widget_connector_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarWidgetConnector * self;
	self = SUGAR_WIDGET_CONNECTOR (object);
	switch (property_id) {
		case SUGAR_WIDGET_CONNECTOR_WIDGET:
		g_value_set_object (value, sugar_widget_connector_get_widget (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sugar_widget_connector_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarWidgetConnector * self;
	self = SUGAR_WIDGET_CONNECTOR (object);
	switch (property_id) {
		case SUGAR_WIDGET_CONNECTOR_WIDGET:
		sugar_widget_connector_set_widget (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 374 "paletteconnector.vala"
SugarToolConnector* sugar_tool_connector_construct (GType object_type, GtkToolItem* tool_item) {
#line 1111 "paletteconnector.c"
	SugarToolConnector * self = NULL;
#line 374 "paletteconnector.vala"
	g_return_val_if_fail (tool_item != NULL, NULL);
#line 375 "paletteconnector.vala"
	self = (SugarToolConnector*) g_object_new (object_type, "tool-item", tool_item, NULL);
#line 1117 "paletteconnector.c"
	return self;
}


#line 374 "paletteconnector.vala"
SugarToolConnector* sugar_tool_connector_new (GtkToolItem* tool_item) {
#line 374 "paletteconnector.vala"
	return sugar_tool_connector_construct (SUGAR_TYPE_TOOL_CONNECTOR, tool_item);
#line 1126 "paletteconnector.c"
}


#line 378 "paletteconnector.vala"
static SugarConnectorAlignment* sugar_tool_connector_real_get_alignments (SugarConnector* base, int* result_length1) {
#line 1132 "paletteconnector.c"
	SugarToolConnector * self;
	SugarConnectorAlignment* result = NULL;
	GtkContainer* _tmp0_;
	GtkToolbar* toolbar;
	self = (SugarToolConnector*) base;
#line 379 "paletteconnector.vala"
	toolbar = _g_object_ref0 ((_tmp0_ = gtk_widget_get_parent ((GtkWidget*) sugar_tool_connector_get_tool_item (self)), GTK_IS_TOOLBAR (_tmp0_) ? ((GtkToolbar*) _tmp0_) : NULL));
#line 380 "paletteconnector.vala"
	if (toolbar == NULL) {
#line 1142 "paletteconnector.c"
		gint _tmp1_;
		SugarConnectorAlignment* _tmp2_;
		result = (_tmp2_ = SUGAR_CONNECTOR_CLASS (sugar_tool_connector_parent_class)->get_alignments ((SugarConnector*) SUGAR_WIDGET_CONNECTOR (self), &_tmp1_), *result_length1 = _tmp1_, _tmp2_);
		_g_object_unref0 (toolbar);
#line 381 "paletteconnector.vala"
		return result;
#line 1149 "paletteconnector.c"
	} else {
#line 382 "paletteconnector.vala"
		if (toolbar->orientation == GTK_ORIENTATION_HORIZONTAL) {
#line 1153 "paletteconnector.c"
			SugarConnectorAlignment* _tmp3_;
			result = (_tmp3_ = SUGAR_TOOL_CONNECTOR_ALIGNMENT_HORIZONTAL, *result_length1 = G_N_ELEMENTS (SUGAR_TOOL_CONNECTOR_ALIGNMENT_HORIZONTAL), _tmp3_);
			_g_object_unref0 (toolbar);
#line 383 "paletteconnector.vala"
			return result;
#line 1159 "paletteconnector.c"
		} else {
			SugarConnectorAlignment* _tmp4_;
			result = (_tmp4_ = SUGAR_TOOL_CONNECTOR_ALIGNMENT_VERTICAL, *result_length1 = G_N_ELEMENTS (SUGAR_TOOL_CONNECTOR_ALIGNMENT_VERTICAL), _tmp4_);
			_g_object_unref0 (toolbar);
#line 385 "paletteconnector.vala"
			return result;
#line 1166 "paletteconnector.c"
		}
	}
	_g_object_unref0 (toolbar);
}


GtkToolItem* sugar_tool_connector_get_tool_item (SugarToolConnector* self) {
	GtkToolItem* result;
	GtkContainer* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	result = (_tmp0_ = gtk_widget_get_parent (sugar_widget_connector_get_widget ((SugarWidgetConnector*) self)), GTK_IS_TOOL_ITEM (_tmp0_) ? ((GtkToolItem*) _tmp0_) : NULL);
#line 364 "paletteconnector.vala"
	return result;
#line 1180 "paletteconnector.c"
}


void sugar_tool_connector_set_tool_item (SugarToolConnector* self, GtkToolItem* value) {
	g_return_if_fail (self != NULL);
#line 367 "paletteconnector.vala"
	if (value == NULL) {
#line 368 "paletteconnector.vala"
		sugar_widget_connector_set_widget ((SugarWidgetConnector*) self, NULL);
#line 1190 "paletteconnector.c"
	} else {
#line 370 "paletteconnector.vala"
		sugar_widget_connector_set_widget ((SugarWidgetConnector*) self, ((GtkBin*) value)->child);
#line 1194 "paletteconnector.c"
	}
	g_object_notify ((GObject *) self, "tool-item");
}


static void sugar_tool_connector_class_init (SugarToolConnectorClass * klass) {
	sugar_tool_connector_parent_class = g_type_class_peek_parent (klass);
	SUGAR_CONNECTOR_CLASS (klass)->get_alignments = sugar_tool_connector_real_get_alignments;
	G_OBJECT_CLASS (klass)->get_property = sugar_tool_connector_get_property;
	G_OBJECT_CLASS (klass)->set_property = sugar_tool_connector_set_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_TOOL_CONNECTOR_TOOL_ITEM, g_param_spec_object ("tool-item", "tool-item", "tool-item", GTK_TYPE_TOOL_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void sugar_tool_connector_instance_init (SugarToolConnector * self) {
}


GType sugar_tool_connector_get_type (void) {
	static volatile gsize sugar_tool_connector_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_tool_connector_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarToolConnectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_tool_connector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarToolConnector), 0, (GInstanceInitFunc) sugar_tool_connector_instance_init, NULL };
		GType sugar_tool_connector_type_id;
		sugar_tool_connector_type_id = g_type_register_static (SUGAR_TYPE_WIDGET_CONNECTOR, "SugarToolConnector", &g_define_type_info, 0);
		g_once_init_leave (&sugar_tool_connector_type_id__volatile, sugar_tool_connector_type_id);
	}
	return sugar_tool_connector_type_id__volatile;
}


static void sugar_tool_connector_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarToolConnector * self;
	self = SUGAR_TOOL_CONNECTOR (object);
	switch (property_id) {
		case SUGAR_TOOL_CONNECTOR_TOOL_ITEM:
		g_value_set_object (value, sugar_tool_connector_get_tool_item (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sugar_tool_connector_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarToolConnector * self;
	self = SUGAR_TOOL_CONNECTOR (object);
	switch (property_id) {
		case SUGAR_TOOL_CONNECTOR_TOOL_ITEM:
		sugar_tool_connector_set_tool_item (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




