/* paletteinvoker.c generated by valac 0.10.1, the Vala compiler
 * generated from paletteinvoker.vala, do not modify */

/* paletteinvoker.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Port from original sugar-toolkit project.
 * File:   src/sugar/graphics/palettewindow.py
 * Commit: c684950ecff34e910e6da5840737a469f95a0e79
 *
 * Copyright (C) 2007, Eduardo Silva <edsiper@gmail.com>
 * Copyright (C) 2008, One Laptop Per Child
 * Copyright (C) 2009, Tomeu Vizoso
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/gui.h"
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SugarInvokerPrivate {
	gboolean _is_up;
	gboolean _focused;
	char* _group_id;
	SugarConnector* _connector;
	SugarPaletteWindow* _palette;
	SugarAnimator* _popup_anim;
	SugarAnimator* _popdown_anim;
	SugarAnimator* _secondary_anim;
	SugarMouseSpeedDetector* _mouse_detector;
	gboolean _secondary_visible;
};


static gpointer sugar_invoker_parent_class = NULL;

#define SUGAR_INVOKER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_INVOKER, SugarInvokerPrivate))
enum  {
	SUGAR_INVOKER_DUMMY_PROPERTY,
	SUGAR_INVOKER_CONNECTOR,
	SUGAR_INVOKER_GROUP_ID,
	SUGAR_INVOKER_PALETTE_WINDOW,
	SUGAR_INVOKER_PALETTE,
	SUGAR_INVOKER_IS_UP,
	SUGAR_INVOKER_FOCUSED
};
static void sugar_invoker_real_dispose (GObject* base);
static void _sugar_invoker_popup (SugarInvoker* self, gboolean immediate, gboolean force_secondary);
static void _sugar_invoker_popdown (SugarInvoker* self, gboolean immediate);
static void sugar_invoker_set_is_up (SugarInvoker* self, gboolean value);
static void _sugar_invoker_reveal_palette (SugarInvoker* self);
static void _sugar_invoker_on_enter (SugarInvoker* self);
static void sugar_invoker_set_focused (SugarInvoker* self, gboolean value);
static void _sugar_invoker_on_leave (SugarInvoker* self);
static void _sugar_invoker_invoker_enter_cb (SugarInvoker* self);
static void _sugar_invoker_invoker_leave_cb (SugarInvoker* self);
static void _sugar_invoker_force_popup_cb (SugarInvoker* self);
static void _sugar_invoker_force_popdown_cb (SugarInvoker* self);
static void _sugar_invoker_palette_show_cb (SugarInvoker* self);
static void _sugar_invoker_palette_hide_cb (SugarInvoker* self);
static gboolean _sugar_invoker_palette_enter_notify_event_cb (SugarInvoker* self, GdkEventCrossing* event);
static gboolean _sugar_invoker_palette_leave_notify_event_cb (SugarInvoker* self, GdkEventCrossing* event);
static void _sugar_invoker_popup_completed_cb (SugarInvoker* self, gboolean aborted);
static void _sugar_invoker_popdown_completed_cb (SugarInvoker* self, gboolean aborted);
static void _sugar_invoker_motion_slow_cb (SugarInvoker* self);
static void _sugar_invoker_secondary_completed_cb (SugarInvoker* self, gboolean aborted);
static void __sugar_invoker_invoker_enter_cb_sugar_connector_invoker_enter (SugarConnector* _sender, gpointer self);
static void __sugar_invoker_invoker_leave_cb_sugar_connector_invoker_leave (SugarConnector* _sender, gpointer self);
static void __sugar_invoker_force_popup_cb_sugar_connector_popup (SugarConnector* _sender, gpointer self);
static void __sugar_invoker_force_popdown_cb_sugar_connector_popdown (SugarConnector* _sender, gpointer self);
static void __sugar_invoker_palette_show_cb_gtk_widget_show (GtkWidget* _sender, gpointer self);
static void __sugar_invoker_palette_hide_cb_gtk_widget_hide (GtkWidget* _sender, gpointer self);
static gboolean __sugar_invoker_palette_enter_notify_event_cb_gtk_widget_enter_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self);
static gboolean __sugar_invoker_palette_leave_notify_event_cb_gtk_widget_leave_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self);
static void __sugar_invoker_popup_completed_cb_sugar_animator_completed (SugarAnimator* _sender, gboolean aborted, gpointer self);
static void __sugar_invoker_popdown_completed_cb_sugar_animator_completed (SugarAnimator* _sender, gboolean aborted, gpointer self);
static void __sugar_invoker_secondary_completed_cb_sugar_animator_completed (SugarAnimator* _sender, gboolean aborted, gpointer self);
static void __sugar_invoker_motion_slow_cb_sugar_mouse_speed_detector_motion_slow (SugarMouseSpeedDetector* _sender, gpointer self);
static GObject * sugar_invoker_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void sugar_invoker_finalize (GObject* obj);
static void sugar_invoker_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sugar_invoker_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 139 "paletteinvoker.vala"
SugarInvoker* sugar_invoker_construct (GType object_type, SugarConnector* connector, const char* group_id) {
#line 125 "paletteinvoker.c"
	SugarInvoker * self = NULL;
#line 139 "paletteinvoker.vala"
	g_return_val_if_fail (connector != NULL, NULL);
#line 139 "paletteinvoker.vala"
	g_return_val_if_fail (group_id != NULL, NULL);
#line 140 "paletteinvoker.vala"
	self = (SugarInvoker*) g_object_new (object_type, "connector", connector, "group-id", group_id, NULL);
#line 133 "paletteinvoker.c"
	return self;
}


#line 139 "paletteinvoker.vala"
SugarInvoker* sugar_invoker_new (SugarConnector* connector, const char* group_id) {
#line 139 "paletteinvoker.vala"
	return sugar_invoker_construct (SUGAR_TYPE_INVOKER, connector, group_id);
#line 142 "paletteinvoker.c"
}


#line 157 "paletteinvoker.vala"
static void sugar_invoker_real_dispose (GObject* base) {
#line 148 "paletteinvoker.c"
	SugarInvoker * self;
	self = (SugarInvoker*) base;
#line 158 "paletteinvoker.vala"
	sugar_invoker_set_group_id (self, NULL);
#line 159 "paletteinvoker.vala"
	G_OBJECT_CLASS (sugar_invoker_parent_class)->dispose (G_OBJECT (self));
#line 155 "paletteinvoker.c"
}


#line 162 "paletteinvoker.vala"
void sugar_invoker_popup (SugarInvoker* self) {
#line 162 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 163 "paletteinvoker.vala"
	_sugar_invoker_popup (self, TRUE, TRUE);
#line 165 "paletteinvoker.c"
}


#line 166 "paletteinvoker.vala"
void sugar_invoker_popdown (SugarInvoker* self) {
#line 166 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 167 "paletteinvoker.vala"
	_sugar_invoker_popdown (self, TRUE);
#line 175 "paletteinvoker.c"
}


#line 36 "glib-2.0.vapi"
static char* bool_to_string (gboolean self) {
#line 181 "paletteinvoker.c"
	char* result = NULL;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 185 "paletteinvoker.c"
		result = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		return result;
#line 189 "paletteinvoker.c"
	} else {
		result = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		return result;
#line 194 "paletteinvoker.c"
	}
}


#line 170 "paletteinvoker.vala"
static void _sugar_invoker_popup (SugarInvoker* self, gboolean immediate, gboolean force_secondary) {
#line 201 "paletteinvoker.c"
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
	char* _tmp6_;
	char* _tmp7_;
	char* _tmp8_;
	char* _tmp9_;
	char* _tmp10_;
	char* _tmp11_;
	char* _tmp12_;
	char* _tmp13_;
	char* _tmp14_;
	char* _tmp15_;
	char* _tmp16_;
#line 170 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 171 "paletteinvoker.vala"
	g_debug ("paletteinvoker.vala:171: %s", _tmp16_ = g_strconcat (_tmp13_ = g_strconcat (_tmp10_ = g_strconcat (_tmp7_ = g_strconcat (_tmp4_ = g_strconcat (_tmp1_ = g_strconcat ("Invoker._popup immediate=", _tmp0_ = bool_to_string (immediate), " ", NULL), _tmp3_ = g_strconcat ("force_secondary=", _tmp2_ = bool_to_string (force_secondary), " ", NULL), NULL), _tmp6_ = g_strconcat ("popup_anim=", _tmp5_ = bool_to_string (sugar_animator_get_active (self->priv->_popup_anim)), " ", NULL), NULL), _tmp9_ = g_strconcat ("popdown_anim=", _tmp8_ = bool_to_string (sugar_animator_get_active (self->priv->_popdown_anim)), " ", NULL), NULL), _tmp12_ = g_strconcat ("secondary_anim=", _tmp11_ = bool_to_string (sugar_animator_get_active (self->priv->_secondary_anim)), NULL), NULL), _tmp15_ = g_strconcat ("secondary_visible=", _tmp14_ = bool_to_string (self->priv->_secondary_visible), NULL), NULL));
#line 223 "paletteinvoker.c"
	_g_free0 (_tmp16_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 178 "paletteinvoker.vala"
	sugar_animator_abort (self->priv->_popdown_anim);
#line 179 "paletteinvoker.vala"
	self->priv->_secondary_visible = self->priv->_secondary_visible | force_secondary;
#line 181 "paletteinvoker.vala"
	if (immediate) {
#line 182 "paletteinvoker.vala"
		sugar_invoker_set_is_up (self, TRUE);
#line 183 "paletteinvoker.vala"
		sugar_animator_abort (self->priv->_popup_anim);
#line 184 "paletteinvoker.vala"
		_sugar_invoker_reveal_palette (self);
#line 253 "paletteinvoker.c"
	} else {
#line 186 "paletteinvoker.vala"
		sugar_animator_start (self->priv->_popup_anim);
#line 257 "paletteinvoker.c"
	}
}


#line 190 "paletteinvoker.vala"
static void _sugar_invoker_popdown (SugarInvoker* self, gboolean immediate) {
#line 264 "paletteinvoker.c"
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
	char* _tmp6_;
	char* _tmp7_;
	char* _tmp8_;
	char* _tmp9_;
	char* _tmp10_;
	gboolean _tmp11_ = FALSE;
#line 190 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 191 "paletteinvoker.vala"
	g_debug ("paletteinvoker.vala:191: %s", _tmp10_ = g_strconcat (_tmp7_ = g_strconcat (_tmp4_ = g_strconcat (_tmp1_ = g_strconcat ("Invoker._popdown immediate=", _tmp0_ = bool_to_string (immediate), " ", NULL), _tmp3_ = g_strconcat ("popup_anim=", _tmp2_ = bool_to_string (sugar_animator_get_active (self->priv->_popup_anim)), " ", NULL), NULL), _tmp6_ = g_strconcat ("popdown_anim=", _tmp5_ = bool_to_string (sugar_animator_get_active (self->priv->_popdown_anim)), " ", NULL), NULL), _tmp9_ = g_strconcat ("secondary_anim=", _tmp8_ = bool_to_string (sugar_animator_get_active (self->priv->_secondary_anim)), NULL), NULL));
#line 281 "paletteinvoker.c"
	_g_free0 (_tmp10_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 196 "paletteinvoker.vala"
	sugar_animator_abort (self->priv->_popup_anim);
#line 197 "paletteinvoker.vala"
	sugar_animator_abort (self->priv->_secondary_anim);
#line 198 "paletteinvoker.vala"
	sugar_mouse_speed_detector_stop (self->priv->_mouse_detector);
#line 199 "paletteinvoker.vala"
	self->priv->_secondary_visible = FALSE;
#line 201 "paletteinvoker.vala"
	if (immediate) {
#line 201 "paletteinvoker.vala"
		_tmp11_ = TRUE;
#line 305 "paletteinvoker.c"
	} else {
#line 201 "paletteinvoker.vala"
		_tmp11_ = !self->priv->_is_up;
#line 309 "paletteinvoker.c"
	}
#line 201 "paletteinvoker.vala"
	if (_tmp11_) {
#line 202 "paletteinvoker.vala"
		sugar_invoker_set_is_up (self, FALSE);
#line 203 "paletteinvoker.vala"
		sugar_animator_abort (self->priv->_popdown_anim);
#line 204 "paletteinvoker.vala"
		if (sugar_invoker_get_palette_window (self) != NULL) {
#line 205 "paletteinvoker.vala"
			gtk_widget_hide ((GtkWidget*) sugar_invoker_get_palette_window (self));
#line 207 "paletteinvoker.vala"
			sugar_palette_window_set_secondary_visible (sugar_invoker_get_palette_window (self), FALSE);
#line 323 "paletteinvoker.c"
		}
	} else {
#line 210 "paletteinvoker.vala"
		sugar_animator_start (self->priv->_popdown_anim);
#line 328 "paletteinvoker.c"
	}
}


#line 214 "paletteinvoker.vala"
static void _sugar_invoker_reveal_palette (SugarInvoker* self) {
#line 214 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 215 "paletteinvoker.vala"
	if (sugar_invoker_get_palette_window (self) == NULL) {
#line 216 "paletteinvoker.vala"
		g_signal_emit_by_name (self, "palette-request");
#line 217 "paletteinvoker.vala"
		return;
#line 343 "paletteinvoker.c"
	}
#line 220 "paletteinvoker.vala"
	if (sugar_palette_window_get_secondary (sugar_invoker_get_palette_window (self)) != NULL) {
#line 221 "paletteinvoker.vala"
		sugar_palette_window_set_secondary_visible (sugar_invoker_get_palette_window (self), self->priv->_secondary_visible);
#line 222 "paletteinvoker.vala"
		if (!self->priv->_secondary_visible) {
#line 223 "paletteinvoker.vala"
			sugar_animator_start (self->priv->_secondary_anim);
#line 353 "paletteinvoker.c"
		}
	}
#line 226 "paletteinvoker.vala"
	gtk_window_set_transient_for ((GtkWindow*) sugar_invoker_get_palette_window (self), sugar_connector_get_toplevel (sugar_invoker_get_connector (self)));
#line 227 "paletteinvoker.vala"
	sugar_palette_window_reveal (sugar_invoker_get_palette_window (self));
#line 360 "paletteinvoker.c"
}


#line 230 "paletteinvoker.vala"
static void _sugar_invoker_on_enter (SugarInvoker* self) {
#line 366 "paletteinvoker.c"
	SugarPaletteGroup* _tmp0_;
	SugarInvoker* _tmp1_;
	SugarInvoker* parent;
#line 230 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 231 "paletteinvoker.vala"
	sugar_invoker_set_focused (self, TRUE);
#line 233 "paletteinvoker.vala"
	parent = (_tmp1_ = sugar_palette_group_get_parent (_tmp0_ = sugar_palette_groups_get (sugar_invoker_get_group_id (self)), self), _g_object_unref0 (_tmp0_), _tmp1_);
#line 234 "paletteinvoker.vala"
	if (parent != NULL) {
#line 235 "paletteinvoker.vala"
		sugar_animator_abort (parent->priv->_popdown_anim);
#line 380 "paletteinvoker.c"
	}
#line 237 "paletteinvoker.vala"
	sugar_animator_abort (self->priv->_popdown_anim);
#line 384 "paletteinvoker.c"
	_g_object_unref0 (parent);
}


#line 240 "paletteinvoker.vala"
static void _sugar_invoker_on_leave (SugarInvoker* self) {
#line 240 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 241 "paletteinvoker.vala"
	sugar_invoker_set_focused (self, FALSE);
#line 242 "paletteinvoker.vala"
	_sugar_invoker_popdown (self, FALSE);
#line 397 "paletteinvoker.c"
}


#line 245 "paletteinvoker.vala"
static void _sugar_invoker_invoker_enter_cb (SugarInvoker* self) {
#line 245 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 246 "paletteinvoker.vala"
	_sugar_invoker_on_enter (self);
#line 247 "paletteinvoker.vala"
	sugar_mouse_speed_detector_start (self->priv->_mouse_detector);
#line 409 "paletteinvoker.c"
}


#line 250 "paletteinvoker.vala"
static void _sugar_invoker_invoker_leave_cb (SugarInvoker* self) {
#line 250 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 251 "paletteinvoker.vala"
	_sugar_invoker_on_leave (self);
#line 252 "paletteinvoker.vala"
	sugar_mouse_speed_detector_stop (self->priv->_mouse_detector);
#line 421 "paletteinvoker.c"
}


#line 255 "paletteinvoker.vala"
static void _sugar_invoker_force_popup_cb (SugarInvoker* self) {
#line 255 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 256 "paletteinvoker.vala"
	_sugar_invoker_popup (self, TRUE, TRUE);
#line 431 "paletteinvoker.c"
}


#line 259 "paletteinvoker.vala"
static void _sugar_invoker_force_popdown_cb (SugarInvoker* self) {
#line 259 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 260 "paletteinvoker.vala"
	_sugar_invoker_popdown (self, TRUE);
#line 441 "paletteinvoker.c"
}


#line 263 "paletteinvoker.vala"
static void _sugar_invoker_palette_show_cb (SugarInvoker* self) {
#line 263 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 264 "paletteinvoker.vala"
	sugar_connector_on_popup (sugar_invoker_get_connector (self));
#line 265 "paletteinvoker.vala"
	g_signal_emit_by_name (self, "poped-up");
#line 453 "paletteinvoker.c"
}


#line 268 "paletteinvoker.vala"
static void _sugar_invoker_palette_hide_cb (SugarInvoker* self) {
#line 268 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 269 "paletteinvoker.vala"
	_sugar_invoker_popdown (self, TRUE);
#line 270 "paletteinvoker.vala"
	sugar_connector_on_popdown (sugar_invoker_get_connector (self));
#line 271 "paletteinvoker.vala"
	g_signal_emit_by_name (self, "poped-down");
#line 467 "paletteinvoker.c"
}


#line 274 "paletteinvoker.vala"
static gboolean _sugar_invoker_palette_enter_notify_event_cb (SugarInvoker* self, GdkEventCrossing* event) {
#line 473 "paletteinvoker.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 274 "paletteinvoker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 275 "paletteinvoker.vala"
	if ((*event).detail != GDK_NOTIFY_INFERIOR) {
#line 276 "paletteinvoker.vala"
		_tmp0_ = (*event).mode == GDK_CROSSING_NORMAL;
#line 482 "paletteinvoker.c"
	} else {
#line 275 "paletteinvoker.vala"
		_tmp0_ = FALSE;
#line 486 "paletteinvoker.c"
	}
#line 275 "paletteinvoker.vala"
	if (_tmp0_) {
#line 277 "paletteinvoker.vala"
		_sugar_invoker_on_enter (self);
#line 492 "paletteinvoker.c"
	}
	result = FALSE;
#line 278 "paletteinvoker.vala"
	return result;
#line 497 "paletteinvoker.c"
}


#line 281 "paletteinvoker.vala"
static gboolean _sugar_invoker_palette_leave_notify_event_cb (SugarInvoker* self, GdkEventCrossing* event) {
#line 503 "paletteinvoker.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 281 "paletteinvoker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 282 "paletteinvoker.vala"
	if ((*event).detail != GDK_NOTIFY_INFERIOR) {
#line 283 "paletteinvoker.vala"
		_tmp0_ = (*event).mode == GDK_CROSSING_NORMAL;
#line 512 "paletteinvoker.c"
	} else {
#line 282 "paletteinvoker.vala"
		_tmp0_ = FALSE;
#line 516 "paletteinvoker.c"
	}
#line 282 "paletteinvoker.vala"
	if (_tmp0_) {
#line 284 "paletteinvoker.vala"
		_sugar_invoker_on_leave (self);
#line 522 "paletteinvoker.c"
	}
	result = FALSE;
#line 285 "paletteinvoker.vala"
	return result;
#line 527 "paletteinvoker.c"
}


#line 288 "paletteinvoker.vala"
static void _sugar_invoker_popup_completed_cb (SugarInvoker* self, gboolean aborted) {
#line 288 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 289 "paletteinvoker.vala"
	if (!aborted) {
#line 290 "paletteinvoker.vala"
		_sugar_invoker_popup (self, TRUE, FALSE);
#line 539 "paletteinvoker.c"
	}
}


#line 293 "paletteinvoker.vala"
static void _sugar_invoker_popdown_completed_cb (SugarInvoker* self, gboolean aborted) {
#line 293 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 294 "paletteinvoker.vala"
	if (!aborted) {
#line 295 "paletteinvoker.vala"
		_sugar_invoker_popdown (self, TRUE);
#line 552 "paletteinvoker.c"
	}
}


#line 298 "paletteinvoker.vala"
static void _sugar_invoker_motion_slow_cb (SugarInvoker* self) {
#line 298 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 299 "paletteinvoker.vala"
	sugar_mouse_speed_detector_stop (self->priv->_mouse_detector);
#line 301 "paletteinvoker.vala"
	if (self->priv->_is_up) {
#line 302 "paletteinvoker.vala"
		sugar_animator_abort (self->priv->_popdown_anim);
#line 567 "paletteinvoker.c"
	} else {
		gboolean immediate;
#line 304 "paletteinvoker.vala"
		immediate = FALSE;
#line 305 "paletteinvoker.vala"
		if (sugar_invoker_get_group_id (self) != NULL) {
#line 574 "paletteinvoker.c"
			SugarPaletteGroup* _tmp0_;
#line 306 "paletteinvoker.vala"
			immediate = sugar_palette_group_get_is_up (_tmp0_ = sugar_palette_groups_get (sugar_invoker_get_group_id (self)));
#line 578 "paletteinvoker.c"
			_g_object_unref0 (_tmp0_);
		}
#line 307 "paletteinvoker.vala"
		_sugar_invoker_popup (self, immediate, FALSE);
#line 583 "paletteinvoker.c"
	}
}


#line 311 "paletteinvoker.vala"
static void _sugar_invoker_secondary_completed_cb (SugarInvoker* self, gboolean aborted) {
#line 311 "paletteinvoker.vala"
	g_return_if_fail (self != NULL);
#line 312 "paletteinvoker.vala"
	if (!aborted) {
#line 313 "paletteinvoker.vala"
		_sugar_invoker_popup (self, TRUE, TRUE);
#line 596 "paletteinvoker.c"
	}
}


SugarConnector* sugar_invoker_get_connector (SugarInvoker* self) {
	SugarConnector* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_connector;
#line 51 "paletteinvoker.vala"
	return result;
#line 607 "paletteinvoker.c"
}


#line 245 "paletteinvoker.vala"
static void __sugar_invoker_invoker_enter_cb_sugar_connector_invoker_enter (SugarConnector* _sender, gpointer self) {
#line 613 "paletteinvoker.c"
	_sugar_invoker_invoker_enter_cb (self);
}


#line 250 "paletteinvoker.vala"
static void __sugar_invoker_invoker_leave_cb_sugar_connector_invoker_leave (SugarConnector* _sender, gpointer self) {
#line 620 "paletteinvoker.c"
	_sugar_invoker_invoker_leave_cb (self);
}


#line 255 "paletteinvoker.vala"
static void __sugar_invoker_force_popup_cb_sugar_connector_popup (SugarConnector* _sender, gpointer self) {
#line 627 "paletteinvoker.c"
	_sugar_invoker_force_popup_cb (self);
}


#line 259 "paletteinvoker.vala"
static void __sugar_invoker_force_popdown_cb_sugar_connector_popdown (SugarConnector* _sender, gpointer self) {
#line 634 "paletteinvoker.c"
	_sugar_invoker_force_popdown_cb (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void sugar_invoker_set_connector (SugarInvoker* self, SugarConnector* value) {
	SugarConnector* _tmp4_;
	g_return_if_fail (self != NULL);
#line 54 "paletteinvoker.vala"
	if (sugar_invoker_get_connector (self) != NULL) {
#line 649 "paletteinvoker.c"
		guint _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
#line 55 "paletteinvoker.vala"
		g_signal_parse_name ("invoker-enter", SUGAR_TYPE_CONNECTOR, &_tmp0_, NULL, FALSE);
#line 55 "paletteinvoker.vala"
		g_signal_handlers_disconnect_matched (sugar_invoker_get_connector (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) __sugar_invoker_invoker_enter_cb_sugar_connector_invoker_enter, self);
#line 56 "paletteinvoker.vala"
		g_signal_parse_name ("invoker-leave", SUGAR_TYPE_CONNECTOR, &_tmp1_, NULL, FALSE);
#line 56 "paletteinvoker.vala"
		g_signal_handlers_disconnect_matched (sugar_invoker_get_connector (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) __sugar_invoker_invoker_leave_cb_sugar_connector_invoker_leave, self);
#line 57 "paletteinvoker.vala"
		g_signal_parse_name ("popup", SUGAR_TYPE_CONNECTOR, &_tmp2_, NULL, FALSE);
#line 57 "paletteinvoker.vala"
		g_signal_handlers_disconnect_matched (sugar_invoker_get_connector (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) __sugar_invoker_force_popup_cb_sugar_connector_popup, self);
#line 58 "paletteinvoker.vala"
		g_signal_parse_name ("popdown", SUGAR_TYPE_CONNECTOR, &_tmp3_, NULL, FALSE);
#line 58 "paletteinvoker.vala"
		g_signal_handlers_disconnect_matched (sugar_invoker_get_connector (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) __sugar_invoker_force_popdown_cb_sugar_connector_popdown, self);
#line 670 "paletteinvoker.c"
	}
#line 61 "paletteinvoker.vala"
	self->priv->_connector = (_tmp4_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_connector), _tmp4_);
#line 63 "paletteinvoker.vala"
	if (sugar_invoker_get_connector (self) != NULL) {
#line 64 "paletteinvoker.vala"
		g_signal_connect_object (sugar_invoker_get_connector (self), "invoker-enter", (GCallback) __sugar_invoker_invoker_enter_cb_sugar_connector_invoker_enter, self, 0);
#line 65 "paletteinvoker.vala"
		g_signal_connect_object (sugar_invoker_get_connector (self), "invoker-leave", (GCallback) __sugar_invoker_invoker_leave_cb_sugar_connector_invoker_leave, self, 0);
#line 66 "paletteinvoker.vala"
		g_signal_connect_object (sugar_invoker_get_connector (self), "popup", (GCallback) __sugar_invoker_force_popup_cb_sugar_connector_popup, self, 0);
#line 67 "paletteinvoker.vala"
		g_signal_connect_object (sugar_invoker_get_connector (self), "popdown", (GCallback) __sugar_invoker_force_popdown_cb_sugar_connector_popdown, self, 0);
#line 684 "paletteinvoker.c"
	}
	g_object_notify ((GObject *) self, "connector");
}


const char* sugar_invoker_get_group_id (SugarInvoker* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_group_id;
#line 74 "paletteinvoker.vala"
	return result;
#line 696 "paletteinvoker.c"
}


void sugar_invoker_set_group_id (SugarInvoker* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
#line 77 "paletteinvoker.vala"
	if (sugar_invoker_get_group_id (self) != NULL) {
#line 705 "paletteinvoker.c"
		SugarPaletteGroup* group;
#line 78 "paletteinvoker.vala"
		group = sugar_palette_groups_get (sugar_invoker_get_group_id (self));
#line 79 "paletteinvoker.vala"
		sugar_palette_group_remove (group, self);
#line 711 "paletteinvoker.c"
		_g_object_unref0 (group);
	}
#line 82 "paletteinvoker.vala"
	self->priv->_group_id = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_group_id), _tmp0_);
#line 84 "paletteinvoker.vala"
	if (sugar_invoker_get_group_id (self) != NULL) {
#line 718 "paletteinvoker.c"
		SugarPaletteGroup* group;
#line 85 "paletteinvoker.vala"
		group = sugar_palette_groups_get (sugar_invoker_get_group_id (self));
#line 86 "paletteinvoker.vala"
		sugar_palette_group_add (group, self);
#line 724 "paletteinvoker.c"
		_g_object_unref0 (group);
	}
	g_object_notify ((GObject *) self, "group-id");
}


SugarPaletteWindow* sugar_invoker_get_palette_window (SugarInvoker* self) {
	SugarPaletteWindow* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_palette;
#line 93 "paletteinvoker.vala"
	return result;
#line 737 "paletteinvoker.c"
}


#line 263 "paletteinvoker.vala"
static void __sugar_invoker_palette_show_cb_gtk_widget_show (GtkWidget* _sender, gpointer self) {
#line 743 "paletteinvoker.c"
	_sugar_invoker_palette_show_cb (self);
}


#line 268 "paletteinvoker.vala"
static void __sugar_invoker_palette_hide_cb_gtk_widget_hide (GtkWidget* _sender, gpointer self) {
#line 750 "paletteinvoker.c"
	_sugar_invoker_palette_hide_cb (self);
}


#line 274 "paletteinvoker.vala"
static gboolean __sugar_invoker_palette_enter_notify_event_cb_gtk_widget_enter_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self) {
#line 757 "paletteinvoker.c"
	gboolean result;
	result = _sugar_invoker_palette_enter_notify_event_cb (self, event);
	return result;
}


#line 281 "paletteinvoker.vala"
static gboolean __sugar_invoker_palette_leave_notify_event_cb_gtk_widget_leave_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self) {
#line 766 "paletteinvoker.c"
	gboolean result;
	result = _sugar_invoker_palette_leave_notify_event_cb (self, event);
	return result;
}


void sugar_invoker_set_palette_window (SugarInvoker* self, SugarPaletteWindow* value) {
	SugarPaletteWindow* _tmp4_;
	g_return_if_fail (self != NULL);
#line 96 "paletteinvoker.vala"
	if (sugar_invoker_get_palette_window (self) != NULL) {
#line 778 "paletteinvoker.c"
		guint _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
#line 97 "paletteinvoker.vala"
		_sugar_invoker_popdown (self, TRUE);
#line 99 "paletteinvoker.vala"
		g_signal_parse_name ("show", GTK_TYPE_WIDGET, &_tmp0_, NULL, FALSE);
#line 99 "paletteinvoker.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) sugar_invoker_get_palette_window (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) __sugar_invoker_palette_show_cb_gtk_widget_show, self);
#line 100 "paletteinvoker.vala"
		g_signal_parse_name ("hide", GTK_TYPE_WIDGET, &_tmp1_, NULL, FALSE);
#line 100 "paletteinvoker.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) sugar_invoker_get_palette_window (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) __sugar_invoker_palette_hide_cb_gtk_widget_hide, self);
#line 101 "paletteinvoker.vala"
		g_signal_parse_name ("enter-notify-event", GTK_TYPE_WIDGET, &_tmp2_, NULL, FALSE);
#line 101 "paletteinvoker.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) sugar_invoker_get_palette_window (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) __sugar_invoker_palette_enter_notify_event_cb_gtk_widget_enter_notify_event, self);
#line 103 "paletteinvoker.vala"
		g_signal_parse_name ("leave-notify-event", GTK_TYPE_WIDGET, &_tmp3_, NULL, FALSE);
#line 103 "paletteinvoker.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) sugar_invoker_get_palette_window (self), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) __sugar_invoker_palette_leave_notify_event_cb_gtk_widget_leave_notify_event, self);
#line 106 "paletteinvoker.vala"
		sugar_palette_window_set_connector (sugar_invoker_get_palette_window (self), NULL);
#line 803 "paletteinvoker.c"
	}
#line 109 "paletteinvoker.vala"
	self->priv->_palette = (_tmp4_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_palette), _tmp4_);
#line 111 "paletteinvoker.vala"
	if (sugar_invoker_get_palette_window (self) != NULL) {
#line 112 "paletteinvoker.vala"
		sugar_palette_window_set_connector (sugar_invoker_get_palette_window (self), sugar_invoker_get_connector (self));
#line 114 "paletteinvoker.vala"
		g_signal_connect_object ((GtkWidget*) sugar_invoker_get_palette_window (self), "show", (GCallback) __sugar_invoker_palette_show_cb_gtk_widget_show, self, 0);
#line 115 "paletteinvoker.vala"
		g_signal_connect_object ((GtkWidget*) sugar_invoker_get_palette_window (self), "hide", (GCallback) __sugar_invoker_palette_hide_cb_gtk_widget_hide, self, 0);
#line 116 "paletteinvoker.vala"
		g_signal_connect_object ((GtkWidget*) sugar_invoker_get_palette_window (self), "enter-notify-event", (GCallback) __sugar_invoker_palette_enter_notify_event_cb_gtk_widget_enter_notify_event, self, 0);
#line 118 "paletteinvoker.vala"
		g_signal_connect_object ((GtkWidget*) sugar_invoker_get_palette_window (self), "leave-notify-event", (GCallback) __sugar_invoker_palette_leave_notify_event_cb_gtk_widget_leave_notify_event, self, 0);
#line 121 "paletteinvoker.vala"
		if (self->priv->_is_up) {
#line 122 "paletteinvoker.vala"
			_sugar_invoker_reveal_palette (self);
#line 823 "paletteinvoker.c"
		}
	}
	g_object_notify ((GObject *) self, "palette-window");
}


SugarPalette* sugar_invoker_get_palette (SugarInvoker* self) {
	SugarPalette* result;
	SugarPaletteWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	result = (_tmp0_ = sugar_invoker_get_palette_window (self), SUGAR_IS_PALETTE (_tmp0_) ? ((SugarPalette*) _tmp0_) : NULL);
#line 128 "paletteinvoker.vala"
	return result;
#line 837 "paletteinvoker.c"
}


void sugar_invoker_set_palette (SugarInvoker* self, SugarPalette* value) {
	g_return_if_fail (self != NULL);
#line 129 "paletteinvoker.vala"
	sugar_invoker_set_palette_window (self, (SugarPaletteWindow*) value);
#line 845 "paletteinvoker.c"
	g_object_notify ((GObject *) self, "palette");
}


gboolean sugar_invoker_get_is_up (SugarInvoker* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_up;
#line 132 "paletteinvoker.vala"
	return result;
#line 856 "paletteinvoker.c"
}


static void sugar_invoker_set_is_up (SugarInvoker* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_is_up = value;
	g_object_notify ((GObject *) self, "is-up");
}


gboolean sugar_invoker_get_focused (SugarInvoker* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_focused;
#line 137 "paletteinvoker.vala"
	return result;
#line 873 "paletteinvoker.c"
}


static void sugar_invoker_set_focused (SugarInvoker* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_focused = value;
	g_object_notify ((GObject *) self, "focused");
}


#line 288 "paletteinvoker.vala"
static void __sugar_invoker_popup_completed_cb_sugar_animator_completed (SugarAnimator* _sender, gboolean aborted, gpointer self) {
#line 886 "paletteinvoker.c"
	_sugar_invoker_popup_completed_cb (self, aborted);
}


#line 293 "paletteinvoker.vala"
static void __sugar_invoker_popdown_completed_cb_sugar_animator_completed (SugarAnimator* _sender, gboolean aborted, gpointer self) {
#line 893 "paletteinvoker.c"
	_sugar_invoker_popdown_completed_cb (self, aborted);
}


#line 311 "paletteinvoker.vala"
static void __sugar_invoker_secondary_completed_cb_sugar_animator_completed (SugarAnimator* _sender, gboolean aborted, gpointer self) {
#line 900 "paletteinvoker.c"
	_sugar_invoker_secondary_completed_cb (self, aborted);
}


#line 298 "paletteinvoker.vala"
static void __sugar_invoker_motion_slow_cb_sugar_mouse_speed_detector_motion_slow (SugarMouseSpeedDetector* _sender, gpointer self) {
#line 907 "paletteinvoker.c"
	_sugar_invoker_motion_slow_cb (self);
}


static GObject * sugar_invoker_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SugarInvoker * self;
	parent_class = G_OBJECT_CLASS (sugar_invoker_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = SUGAR_INVOKER (obj);
	{
		SugarAnimator* _tmp0_;
		SugarAnimator* _tmp1_;
		SugarAnimator* _tmp2_;
		SugarMouseSpeedDetector* _tmp3_;
#line 144 "paletteinvoker.vala"
		self->priv->_popup_anim = (_tmp0_ = sugar_animator_new (0.5, 10, 0.0, 1.0, SUGAR_ANIMATION_TYPE_OUT_EXPO), _g_object_unref0 (self->priv->_popup_anim), _tmp0_);
#line 145 "paletteinvoker.vala"
		g_signal_connect_object (self->priv->_popup_anim, "completed", (GCallback) __sugar_invoker_popup_completed_cb_sugar_animator_completed, self, 0);
#line 147 "paletteinvoker.vala"
		self->priv->_popdown_anim = (_tmp1_ = sugar_animator_new (0.6, 10, 0.0, 1.0, SUGAR_ANIMATION_TYPE_OUT_EXPO), _g_object_unref0 (self->priv->_popdown_anim), _tmp1_);
#line 148 "paletteinvoker.vala"
		g_signal_connect_object (self->priv->_popdown_anim, "completed", (GCallback) __sugar_invoker_popdown_completed_cb_sugar_animator_completed, self, 0);
#line 150 "paletteinvoker.vala"
		self->priv->_secondary_anim = (_tmp2_ = sugar_animator_new (1.5, 10, 0.0, 1.0, SUGAR_ANIMATION_TYPE_OUT_EXPO), _g_object_unref0 (self->priv->_secondary_anim), _tmp2_);
#line 151 "paletteinvoker.vala"
		g_signal_connect_object (self->priv->_secondary_anim, "completed", (GCallback) __sugar_invoker_secondary_completed_cb_sugar_animator_completed, self, 0);
#line 153 "paletteinvoker.vala"
		self->priv->_mouse_detector = (_tmp3_ = sugar_mouse_speed_detector_new (200, 5), _g_object_unref0 (self->priv->_mouse_detector), _tmp3_);
#line 154 "paletteinvoker.vala"
		g_signal_connect_object (self->priv->_mouse_detector, "motion-slow", (GCallback) __sugar_invoker_motion_slow_cb_sugar_mouse_speed_detector_motion_slow, self, 0);
#line 940 "paletteinvoker.c"
	}
	return obj;
}


static void sugar_invoker_class_init (SugarInvokerClass * klass) {
	sugar_invoker_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarInvokerPrivate));
	G_OBJECT_CLASS (klass)->dispose = sugar_invoker_real_dispose;
	G_OBJECT_CLASS (klass)->get_property = sugar_invoker_get_property;
	G_OBJECT_CLASS (klass)->set_property = sugar_invoker_set_property;
	G_OBJECT_CLASS (klass)->constructor = sugar_invoker_constructor;
	G_OBJECT_CLASS (klass)->finalize = sugar_invoker_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_INVOKER_CONNECTOR, g_param_spec_object ("connector", "connector", "connector", SUGAR_TYPE_CONNECTOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_INVOKER_GROUP_ID, g_param_spec_string ("group-id", "group-id", "group-id", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_INVOKER_PALETTE_WINDOW, g_param_spec_object ("palette-window", "palette-window", "palette-window", SUGAR_TYPE_PALETTE_WINDOW, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_INVOKER_PALETTE, g_param_spec_object ("palette", "palette", "palette", SUGAR_TYPE_PALETTE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_INVOKER_IS_UP, g_param_spec_boolean ("is-up", "is-up", "is-up", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Is cursor under invoker's widget or palette_request
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_INVOKER_FOCUSED, g_param_spec_boolean ("focused", "focused", "focused", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("palette_request", SUGAR_TYPE_INVOKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("poped_up", SUGAR_TYPE_INVOKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("poped_down", SUGAR_TYPE_INVOKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void sugar_invoker_instance_init (SugarInvoker * self) {
	self->priv = SUGAR_INVOKER_GET_PRIVATE (self);
	self->priv->_is_up = FALSE;
	self->priv->_focused = FALSE;
}


static void sugar_invoker_finalize (GObject* obj) {
	SugarInvoker * self;
	self = SUGAR_INVOKER (obj);
	_g_free0 (self->priv->_group_id);
	_g_object_unref0 (self->priv->_connector);
	_g_object_unref0 (self->priv->_palette);
	_g_object_unref0 (self->priv->_popup_anim);
	_g_object_unref0 (self->priv->_popdown_anim);
	_g_object_unref0 (self->priv->_secondary_anim);
	_g_object_unref0 (self->priv->_mouse_detector);
	G_OBJECT_CLASS (sugar_invoker_parent_class)->finalize (obj);
}


GType sugar_invoker_get_type (void) {
	static volatile gsize sugar_invoker_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_invoker_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarInvokerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_invoker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarInvoker), 0, (GInstanceInitFunc) sugar_invoker_instance_init, NULL };
		GType sugar_invoker_type_id;
		sugar_invoker_type_id = g_type_register_static (G_TYPE_OBJECT, "SugarInvoker", &g_define_type_info, 0);
		g_once_init_leave (&sugar_invoker_type_id__volatile, sugar_invoker_type_id);
	}
	return sugar_invoker_type_id__volatile;
}


static void sugar_invoker_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarInvoker * self;
	self = SUGAR_INVOKER (object);
	switch (property_id) {
		case SUGAR_INVOKER_CONNECTOR:
		g_value_set_object (value, sugar_invoker_get_connector (self));
		break;
		case SUGAR_INVOKER_GROUP_ID:
		g_value_set_string (value, sugar_invoker_get_group_id (self));
		break;
		case SUGAR_INVOKER_PALETTE_WINDOW:
		g_value_set_object (value, sugar_invoker_get_palette_window (self));
		break;
		case SUGAR_INVOKER_PALETTE:
		g_value_set_object (value, sugar_invoker_get_palette (self));
		break;
		case SUGAR_INVOKER_IS_UP:
		g_value_set_boolean (value, sugar_invoker_get_is_up (self));
		break;
		case SUGAR_INVOKER_FOCUSED:
		g_value_set_boolean (value, sugar_invoker_get_focused (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sugar_invoker_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarInvoker * self;
	self = SUGAR_INVOKER (object);
	switch (property_id) {
		case SUGAR_INVOKER_CONNECTOR:
		sugar_invoker_set_connector (self, g_value_get_object (value));
		break;
		case SUGAR_INVOKER_GROUP_ID:
		sugar_invoker_set_group_id (self, g_value_get_string (value));
		break;
		case SUGAR_INVOKER_PALETTE_WINDOW:
		sugar_invoker_set_palette_window (self, g_value_get_object (value));
		break;
		case SUGAR_INVOKER_PALETTE:
		sugar_invoker_set_palette (self, g_value_get_object (value));
		break;
		case SUGAR_INVOKER_IS_UP:
		sugar_invoker_set_is_up (self, g_value_get_boolean (value));
		break;
		case SUGAR_INVOKER_FOCUSED:
		sugar_invoker_set_focused (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




