/* palettewindow.c generated by valac 0.10.1, the Vala compiler
 * generated from palettewindow.vala, do not modify */

/* palettewindow.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Port from original sugar-toolkit project.
 * File:   src/sugar/graphics/palettewindow.py
 * Commit: c684950ecff34e910e6da5840737a469f95a0e79
 *
 * Copyright (C) 2007, Eduardo Silva <edsiper@gmail.com>
 * Copyright (C) 2008, One Laptop Per Child
 * Copyright (C) 2009, Tomeu Vizoso
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/gui.h"
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <polyol/env.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

struct _SugarPaletteWindowPrivate {
	SugarConnector* _connector;
	GdkRectangle _old_alloc;
	GdkRectangle _reveal_rect;
};


static gpointer sugar_palette_window_parent_class = NULL;

#define SUGAR_PALETTE_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_PALETTE_WINDOW, SugarPaletteWindowPrivate))
enum  {
	SUGAR_PALETTE_WINDOW_DUMMY_PROPERTY,
	SUGAR_PALETTE_WINDOW_CONNECTOR,
	SUGAR_PALETTE_WINDOW_SECONDARY,
	SUGAR_PALETTE_WINDOW_SECONDARY_VISIBLE
};
static void sugar_palette_window_real_realize (GtkWidget* base);
static void sugar_palette_window_real_size_request (GtkWidget* base, GtkRequisition* requisition);
static void sugar_palette_window_real_size_allocate (GtkWidget* base, GdkRectangle* allocation);
static gboolean _gdk_rectangle_equal (const GdkRectangle* s1, const GdkRectangle* s2);
static gboolean sugar_palette_window_real_expose_event (GtkWidget* base, GdkEventExpose* event);
static gboolean sugar_palette_window_real_key_press_event (GtkWidget* base, GdkEventKey* event);
static GObject * sugar_palette_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void sugar_palette_window_finalize (GObject* obj);
static void sugar_palette_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sugar_palette_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 68 "palettewindow.vala"
void sugar_palette_window_get_rect (SugarPaletteWindow* self, GdkRectangle* result) {
#line 68 "palettewindow.vala"
	g_return_if_fail (self != NULL);
#line 90 "palettewindow.c"
	*result = self->priv->_reveal_rect;
#line 69 "palettewindow.vala"
	return;
#line 94 "palettewindow.c"
}


#line 72 "palettewindow.vala"
void sugar_palette_window_reveal (SugarPaletteWindow* self) {
#line 100 "palettewindow.c"
	GtkRequisition palette_size = {0};
	gint x = 0;
	gint y = 0;
#line 72 "palettewindow.vala"
	g_return_if_fail (self != NULL);
#line 74 "palettewindow.vala"
	gtk_widget_size_request ((GtkWidget*) self, &palette_size);
#line 77 "palettewindow.vala"
	sugar_connector_get_palette_pos (self->priv->_connector, &palette_size, &x, &y);
#line 79 "palettewindow.vala"
	self->priv->_reveal_rect.x = x;
#line 80 "palettewindow.vala"
	self->priv->_reveal_rect.y = y;
#line 81 "palettewindow.vala"
	self->priv->_reveal_rect.width = palette_size.width;
#line 82 "palettewindow.vala"
	self->priv->_reveal_rect.height = palette_size.height;
#line 84 "palettewindow.vala"
	gtk_window_move ((GtkWindow*) self, x, y);
#line 85 "palettewindow.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 87 "palettewindow.vala"
	gtk_window_move ((GtkWindow*) self, x, y);
#line 124 "palettewindow.c"
}


#line 90 "palettewindow.vala"
static void sugar_palette_window_real_realize (GtkWidget* base) {
#line 130 "palettewindow.c"
	SugarPaletteWindow * self;
	self = (SugarPaletteWindow*) base;
#line 91 "palettewindow.vala"
	GTK_WIDGET_CLASS (sugar_palette_window_parent_class)->realize ((GtkWidget*) GTK_WINDOW (self));
#line 92 "palettewindow.vala"
	gdk_window_set_type_hint (((GtkWidget*) self)->window, GDK_WINDOW_TYPE_HINT_DIALOG);
#line 137 "palettewindow.c"
}


#line 95 "palettewindow.vala"
static void sugar_palette_window_real_size_request (GtkWidget* base, GtkRequisition* requisition) {
#line 143 "palettewindow.c"
	SugarPaletteWindow * self;
	self = (SugarPaletteWindow*) base;
#line 96 "palettewindow.vala"
	GTK_WIDGET_CLASS (sugar_palette_window_parent_class)->size_request ((GtkWidget*) GTK_WINDOW (self), requisition);
#line 97 "palettewindow.vala"
	(*requisition).width = MAX ((*requisition).width, sugar_metrics_get (SUGAR_GRID_CELL_SIZE) * 2);
#line 150 "palettewindow.c"
}


static gboolean _gdk_rectangle_equal (const GdkRectangle* s1, const GdkRectangle* s2) {
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->x != s2->x) {
		return FALSE;
	}
	if (s1->y != s2->y) {
		return FALSE;
	}
	if (s1->width != s2->width) {
		return FALSE;
	}
	if (s1->height != s2->height) {
		return FALSE;
	}
	return TRUE;
}


#line 101 "palettewindow.vala"
static void sugar_palette_window_real_size_allocate (GtkWidget* base, GdkRectangle* allocation) {
#line 182 "palettewindow.c"
	SugarPaletteWindow * self;
	self = (SugarPaletteWindow*) base;
#line 102 "palettewindow.vala"
	GTK_WIDGET_CLASS (sugar_palette_window_parent_class)->size_allocate ((GtkWidget*) GTK_WINDOW (self), allocation);
#line 104 "palettewindow.vala"
	if (_gdk_rectangle_equal (&self->priv->_old_alloc, allocation) != TRUE) {
#line 105 "palettewindow.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 191 "palettewindow.c"
	}
#line 112 "palettewindow.vala"
	self->priv->_old_alloc = *allocation;
#line 195 "palettewindow.c"
}


#line 115 "palettewindow.vala"
static gboolean sugar_palette_window_real_expose_event (GtkWidget* base, GdkEventExpose* event) {
#line 201 "palettewindow.c"
	SugarPaletteWindow * self;
	gboolean result = FALSE;
	GtkPositionType gap_side;
	gint gap_start;
	gint gap_size;
	gboolean _tmp0_ = FALSE;
	self = (SugarPaletteWindow*) base;
#line 116 "palettewindow.vala"
	gap_side = GTK_POS_TOP;
#line 117 "palettewindow.vala"
	gap_start = 0;
#line 117 "palettewindow.vala"
	gap_size = 0;
#line 119 "palettewindow.vala"
	if (self->priv->_connector != NULL) {
#line 217 "palettewindow.c"
		GdkRectangle _tmp1_ = {0};
		GdkRectangle _tmp2_ = {0};
		GdkRectangle _tmp3_;
		GdkRectangle _tmp4_;
#line 119 "palettewindow.vala"
		_tmp0_ = sugar_connector_get_box_gap ((_tmp3_ = (sugar_palette_window_get_rect (self, &_tmp1_), _tmp1_), &_tmp3_), (_tmp4_ = (sugar_connector_get_rect (self->priv->_connector, &_tmp2_), _tmp2_), &_tmp4_), &gap_side, &gap_start, &gap_size);
#line 224 "palettewindow.c"
	} else {
#line 119 "palettewindow.vala"
		_tmp0_ = FALSE;
#line 228 "palettewindow.c"
	}
#line 119 "palettewindow.vala"
	if (_tmp0_) {
#line 122 "palettewindow.vala"
		gtk_paint_box_gap (gtk_widget_get_style ((GtkWidget*) self), (*event).window, GTK_STATE_PRELIGHT, GTK_SHADOW_IN, &(*event).area, (GtkWidget*) self, "palette", 0, 0, ((GtkWidget*) self)->allocation.width, ((GtkWidget*) self)->allocation.height, gap_side, gap_start, gap_size);
#line 234 "palettewindow.c"
	} else {
#line 127 "palettewindow.vala"
		gtk_paint_box (gtk_widget_get_style ((GtkWidget*) self), (*event).window, GTK_STATE_PRELIGHT, GTK_SHADOW_IN, &(*event).area, (GtkWidget*) self, "palette", 0, 0, ((GtkWidget*) self)->allocation.width, ((GtkWidget*) self)->allocation.height);
#line 238 "palettewindow.c"
	}
	{
		GList* child_collection;
		GList* child_it;
#line 132 "palettewindow.vala"
		child_collection = gtk_container_get_children ((GtkContainer*) self);
#line 245 "palettewindow.c"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child;
#line 132 "palettewindow.vala"
			child = (GtkWidget*) child_it->data;
#line 250 "palettewindow.c"
			{
#line 133 "palettewindow.vala"
				gtk_container_propagate_expose ((GtkContainer*) self, child, event);
#line 254 "palettewindow.c"
			}
		}
#line 132 "palettewindow.vala"
		_g_list_free0 (child_collection);
#line 259 "palettewindow.c"
	}
	result = TRUE;
#line 135 "palettewindow.vala"
	return result;
#line 264 "palettewindow.c"
}


#line 138 "palettewindow.vala"
static gboolean sugar_palette_window_real_key_press_event (GtkWidget* base, GdkEventKey* event) {
#line 270 "palettewindow.c"
	SugarPaletteWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	self = (SugarPaletteWindow*) base;
#line 139 "palettewindow.vala"
	if (self->priv->_connector != NULL) {
#line 139 "palettewindow.vala"
		_tmp0_ = (*event).keyval == 0xff1b;
#line 279 "palettewindow.c"
	} else {
#line 139 "palettewindow.vala"
		_tmp0_ = FALSE;
#line 283 "palettewindow.c"
	}
#line 139 "palettewindow.vala"
	if (_tmp0_) {
#line 140 "palettewindow.vala"
		g_signal_emit_by_name (self->priv->_connector, "popdown");
#line 289 "palettewindow.c"
	}
	result = FALSE;
#line 141 "palettewindow.vala"
	return result;
#line 294 "palettewindow.c"
}


#line 44 "palettewindow.vala"
SugarPaletteWindow* sugar_palette_window_construct (GType object_type) {
#line 300 "palettewindow.c"
	SugarPaletteWindow * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 44 "palettewindow.vala"
SugarPaletteWindow* sugar_palette_window_new (void) {
#line 44 "palettewindow.vala"
	return sugar_palette_window_construct (SUGAR_TYPE_PALETTE_WINDOW);
#line 311 "palettewindow.c"
}


SugarConnector* sugar_palette_window_get_connector (SugarPaletteWindow* self) {
	SugarConnector* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_connector;
#line 45 "palettewindow.vala"
	return result;
#line 321 "palettewindow.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void sugar_palette_window_set_connector (SugarPaletteWindow* self, SugarConnector* value) {
	SugarConnector* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_connector = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_connector), _tmp0_);
	g_object_notify ((GObject *) self, "connector");
}


GtkWidget* sugar_palette_window_get_secondary (SugarPaletteWindow* self) {
	return SUGAR_PALETTE_WINDOW_GET_CLASS (self)->get_secondary (self);
}


static GtkWidget* sugar_palette_window_real_get_secondary (SugarPaletteWindow* base) {
	GtkWidget* result;
	SugarPaletteWindow* self;
	self = base;
	result = NULL;
#line 48 "palettewindow.vala"
	return result;
#line 350 "palettewindow.c"
}


void sugar_palette_window_set_secondary (SugarPaletteWindow* self, GtkWidget* value) {
	SUGAR_PALETTE_WINDOW_GET_CLASS (self)->set_secondary (self, value);
}


static void sugar_palette_window_real_set_secondary (SugarPaletteWindow* base, GtkWidget* value) {
	SugarPaletteWindow* self;
	self = base;
	g_object_notify ((GObject *) self, "secondary");
}


gboolean sugar_palette_window_get_secondary_visible (SugarPaletteWindow* self) {
	return SUGAR_PALETTE_WINDOW_GET_CLASS (self)->get_secondary_visible (self);
}


static gboolean sugar_palette_window_real_get_secondary_visible (SugarPaletteWindow* base) {
	gboolean result;
	SugarPaletteWindow* self;
	self = base;
	result = FALSE;
#line 53 "palettewindow.vala"
	return result;
#line 378 "palettewindow.c"
}


void sugar_palette_window_set_secondary_visible (SugarPaletteWindow* self, gboolean value) {
	SUGAR_PALETTE_WINDOW_GET_CLASS (self)->set_secondary_visible (self, value);
}


static void sugar_palette_window_real_set_secondary_visible (SugarPaletteWindow* base, gboolean value) {
	SugarPaletteWindow* self;
	self = base;
	g_object_notify ((GObject *) self, "secondary-visible");
}


static GObject * sugar_palette_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SugarPaletteWindow * self;
	parent_class = G_OBJECT_CLASS (sugar_palette_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = SUGAR_PALETTE_WINDOW (obj);
	{
		GtkAccelGroup* accel_group;
#line 58 "palettewindow.vala"
		gtk_window_set_decorated ((GtkWindow*) self, FALSE);
#line 59 "palettewindow.vala"
		gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 61 "palettewindow.vala"
		gtk_container_set_border_width ((GtkContainer*) self, (guint) gtk_widget_get_style ((GtkWidget*) self)->xthickness);
#line 63 "palettewindow.vala"
		accel_group = gtk_accel_group_new ();
#line 64 "palettewindow.vala"
		g_object_set_data_full ((GObject*) self, "sugar-accel-group", _g_object_ref0 (accel_group), g_object_unref);
#line 65 "palettewindow.vala"
		gtk_window_add_accel_group ((GtkWindow*) self, accel_group);
#line 415 "palettewindow.c"
		_g_object_unref0 (accel_group);
	}
	return obj;
}


static void sugar_palette_window_class_init (SugarPaletteWindowClass * klass) {
	sugar_palette_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarPaletteWindowPrivate));
	GTK_WIDGET_CLASS (klass)->realize = sugar_palette_window_real_realize;
	GTK_WIDGET_CLASS (klass)->size_request = sugar_palette_window_real_size_request;
	GTK_WIDGET_CLASS (klass)->size_allocate = sugar_palette_window_real_size_allocate;
	GTK_WIDGET_CLASS (klass)->expose_event = sugar_palette_window_real_expose_event;
	GTK_WIDGET_CLASS (klass)->key_press_event = sugar_palette_window_real_key_press_event;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->get_secondary = sugar_palette_window_real_get_secondary;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->set_secondary = sugar_palette_window_real_set_secondary;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->get_secondary_visible = sugar_palette_window_real_get_secondary_visible;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->set_secondary_visible = sugar_palette_window_real_set_secondary_visible;
	G_OBJECT_CLASS (klass)->get_property = sugar_palette_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = sugar_palette_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = sugar_palette_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = sugar_palette_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_WINDOW_CONNECTOR, g_param_spec_object ("connector", "connector", "connector", SUGAR_TYPE_CONNECTOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_WINDOW_SECONDARY, g_param_spec_object ("secondary", "secondary", "secondary", GTK_TYPE_WIDGET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_WINDOW_SECONDARY_VISIBLE, g_param_spec_boolean ("secondary-visible", "secondary-visible", "secondary-visible", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void sugar_palette_window_instance_init (SugarPaletteWindow * self) {
	self->priv = SUGAR_PALETTE_WINDOW_GET_PRIVATE (self);
}


static void sugar_palette_window_finalize (GObject* obj) {
	SugarPaletteWindow * self;
	self = SUGAR_PALETTE_WINDOW (obj);
	_g_object_unref0 (self->priv->_connector);
	G_OBJECT_CLASS (sugar_palette_window_parent_class)->finalize (obj);
}


GType sugar_palette_window_get_type (void) {
	static volatile gsize sugar_palette_window_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_palette_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarPaletteWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_palette_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarPaletteWindow), 0, (GInstanceInitFunc) sugar_palette_window_instance_init, NULL };
		GType sugar_palette_window_type_id;
		sugar_palette_window_type_id = g_type_register_static (GTK_TYPE_WINDOW, "SugarPaletteWindow", &g_define_type_info, 0);
		g_once_init_leave (&sugar_palette_window_type_id__volatile, sugar_palette_window_type_id);
	}
	return sugar_palette_window_type_id__volatile;
}


static void sugar_palette_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarPaletteWindow * self;
	self = SUGAR_PALETTE_WINDOW (object);
	switch (property_id) {
		case SUGAR_PALETTE_WINDOW_CONNECTOR:
		g_value_set_object (value, sugar_palette_window_get_connector (self));
		break;
		case SUGAR_PALETTE_WINDOW_SECONDARY:
		g_value_set_object (value, sugar_palette_window_get_secondary (self));
		break;
		case SUGAR_PALETTE_WINDOW_SECONDARY_VISIBLE:
		g_value_set_boolean (value, sugar_palette_window_get_secondary_visible (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sugar_palette_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarPaletteWindow * self;
	self = SUGAR_PALETTE_WINDOW (object);
	switch (property_id) {
		case SUGAR_PALETTE_WINDOW_CONNECTOR:
		sugar_palette_window_set_connector (self, g_value_get_object (value));
		break;
		case SUGAR_PALETTE_WINDOW_SECONDARY:
		sugar_palette_window_set_secondary (self, g_value_get_object (value));
		break;
		case SUGAR_PALETTE_WINDOW_SECONDARY_VISIBLE:
		sugar_palette_window_set_secondary_visible (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




